=begin comment

libguestfs generated file
 WARNING: THIS FILE IS GENERATED FROM THE FOLLOWING FILES:
          generator/fish.ml
          and from the code in the generator/ subdirectory.
 ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.

 Copyright (C) 2009-2020 Red Hat Inc.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

=end comment

=head2 acl-delete-def-file

 acl-delete-def-file dir

This function deletes the default POSIX Access Control List (ACL)
attached to directory C<dir>.

This command depends on the feature C<acl>.   See also
L</feature-available>.

=head2 acl-get-file

 acl-get-file path acltype

This function returns the POSIX Access Control List (ACL) attached
to C<path>.  The ACL is returned in "long text form" (see L<acl(5)>).

The C<acltype> parameter may be:

=over 4

=item C<access>

Return the ordinary (access) ACL for any file, directory or
other filesystem object.

=item C<default>

Return the default ACL.  Normally this only makes sense if
C<path> is a directory.

=back

This command depends on the feature C<acl>.   See also
L</feature-available>.

=head2 acl-set-file

 acl-set-file path acltype acl

This function sets the POSIX Access Control List (ACL) attached
to C<path>.

The C<acltype> parameter may be:

=over 4

=item C<access>

Set the ordinary (access) ACL for any file, directory or
other filesystem object.

=item C<default>

Set the default ACL.  Normally this only makes sense if
C<path> is a directory.

=back

The C<acl> parameter is the new ACL in either "long text form"
or "short text form" (see L<acl(5)>).  The new ACL completely
replaces any previous ACL on the file.  The ACL must contain the
full Unix permissions (eg. C<u::rwx,g::rx,o::rx>).

If you are specifying individual users or groups, then the
mask field is also required (eg. C<m::rwx>), followed by the
C<u:I<ID>:...> and/or C<g:I<ID>:...> field(s).  A full ACL
string might therefore look like this:

 u::rwx,g::rwx,o::rwx,m::rwx,u:500:rwx,g:500:rwx
 \ Unix permissions / \mask/ \      ACL        /

You should use numeric UIDs and GIDs.  To map usernames and
groupnames to the correct numeric ID in the context of the
guest, use the Augeas functions (see L</aug-init>).

This command depends on the feature C<acl>.   See also
L</feature-available>.

=head2 add-cdrom

 add-cdrom filename

This function adds a virtual CD-ROM disk image to the guest.

The image is added as read-only drive, so this function is equivalent
of L</add-drive-ro>.

I<This function is deprecated.>
In new code, use the L</add-drive-ro> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 add-domain

=head2 domain

 add-domain dom [libvirturi:..] [readonly:true|false] [iface:..] [live:true|false] [allowuuid:true|false] [readonlydisk:..] [cachemode:..] [discard:..] [copyonread:true|false]

This function adds the disk(s) attached to the named libvirt
domain C<dom>.  It works by connecting to libvirt, requesting
the domain and domain XML from libvirt, parsing it for disks,
and calling L</add-drive-opts> on each one.

The number of disks added is returned.  This operation is atomic:
if an error is returned, then no disks are added.

This function does some minimal checks to make sure the libvirt
domain is not running (unless C<readonly> is true).  In a future
version we will try to acquire the libvirt lock on each disk.

Disks must be accessible locally.  This often means that adding disks
from a remote libvirt connection (see L<https://libvirt.org/remote.html>)
will fail unless those disks are accessible via the same device path
locally too.

The optional C<libvirturi> parameter sets the libvirt URI
(see L<https://libvirt.org/uri.html>).  If this is not set then
we connect to the default libvirt URI (or one set through an
environment variable, see the libvirt documentation for full
details).

The optional C<live> flag controls whether this call will try
to connect to a running virtual machine C<guestfsd> process if
it sees a suitable E<lt>channelE<gt> element in the libvirt
XML definition.  The default (if the flag is omitted) is never
to try.  See L<guestfs(3)/ATTACHING TO RUNNING DAEMONS> for more
information.

If the C<allowuuid> flag is true (default is false) then a UUID
I<may> be passed instead of the domain name.  The C<dom> string is
treated as a UUID first and looked up, and if that lookup fails
then we treat C<dom> as a name as usual.

The optional C<readonlydisk> parameter controls what we do for
disks which are marked E<lt>readonly/E<gt> in the libvirt XML.
Possible values are:

=over 4

=item readonlydisk = "error"

If C<readonly> is false:

The whole call is aborted with an error if any disk with
the E<lt>readonly/E<gt> flag is found.

If C<readonly> is true:

Disks with the E<lt>readonly/E<gt> flag are added read-only.

=item readonlydisk = "read"

If C<readonly> is false:

Disks with the E<lt>readonly/E<gt> flag are added read-only.
Other disks are added read/write.

If C<readonly> is true:

Disks with the E<lt>readonly/E<gt> flag are added read-only.

=item readonlydisk = "write" (default)

If C<readonly> is false:

Disks with the E<lt>readonly/E<gt> flag are added read/write.

If C<readonly> is true:

Disks with the E<lt>readonly/E<gt> flag are added read-only.

=item readonlydisk = "ignore"

If C<readonly> is true or false:

Disks with the E<lt>readonly/E<gt> flag are skipped.

=back

If present, the value of C<logical_block_size> attribute of E<lt>blockio/E<gt>
tag in libvirt XML will be passed as C<blocksize> parameter to
L</add-drive-opts>.

The other optional parameters are passed directly through to
L</add-drive-opts>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 add-drive

=head2 add

=head2 add-drive-opts

 add-drive filename [readonly:true|false] [format:..] [iface:..] [name:..] [label:..] [protocol:..] [server:..] [username:..] [secret:..] [cachemode:..] [discard:..] [copyonread:true|false] [blocksize:N]

This function adds a disk image called F<filename> to the handle.
F<filename> may be a regular host file or a host device.

When this function is called before L</launch> (the
usual case) then the first time you call this function,
the disk appears in the API as F</dev/sda>, the second time
as F</dev/sdb>, and so on.

In libguestfs E<ge> 1.20 you can also call this function
after launch (with some restrictions).  This is called
"hotplugging".  When hotplugging, you must specify a
C<label> so that the new disk gets a predictable name.
For more information see L<guestfs(3)/HOTPLUGGING>.

You don't necessarily need to be root when using libguestfs.  However
you obviously do need sufficient permissions to access the filename
for whatever operations you want to perform (ie. read access if you
just want to read the image or write access if you want to modify the
image).

This call checks that F<filename> exists.

F<filename> may be the special string C<"/dev/null">.
See L<guestfs(3)/NULL DISKS>.

The optional arguments are:

=over 4

=item C<readonly>

If true then the image is treated as read-only.  Writes are still
allowed, but they are stored in a temporary snapshot overlay which
is discarded at the end.  The disk that you add is not modified.

=item C<format>

This forces the image format.  If you omit this (or use L</add-drive>
or L</add-drive-ro>) then the format is automatically detected.
Possible formats include C<raw> and C<qcow2>.

Automatic detection of the format opens you up to a potential
security hole when dealing with untrusted raw-format images.
See CVE-2010-3851 and RHBZ#642934.  Specifying the format closes
this security hole.

=item C<iface>

This rarely-used option lets you emulate the behaviour of the
deprecated L</add-drive-with-if> call (q.v.)

=item C<name>

The name the drive had in the original guest, e.g. F</dev/sdb>.
This is used as a hint to the guest inspection process if
it is available.

=item C<label>

Give the disk a label.  The label should be a unique, short
string using I<only> ASCII characters C<[a-zA-Z]>.
As well as its usual name in the API (such as F</dev/sda>),
the drive will also be named F</dev/disk/guestfs/I<label>>.

See L<guestfs(3)/DISK LABELS>.

=item C<protocol>

The optional protocol argument can be used to select an alternate
source protocol.

See also: L<guestfs(3)/REMOTE STORAGE>.

=over 4

=item C<protocol = "file">

F<filename> is interpreted as a local file or device.
This is the default if the optional protocol parameter
is omitted.

=item C<protocol = "ftp"|"ftps"|"http"|"https"|"tftp">

Connect to a remote FTP, HTTP or TFTP server.
The C<server> parameter must also be supplied - see below.

See also: L<guestfs(3)/FTP, HTTP AND TFTP>

=item C<protocol = "gluster">

Connect to the GlusterFS server.
The C<server> parameter must also be supplied - see below.

See also: L<guestfs(3)/GLUSTER>

=item C<protocol = "iscsi">

Connect to the iSCSI server.
The C<server> parameter must also be supplied - see below.
The C<username> parameter may be supplied.  See below.
The C<secret> parameter may be supplied.  See below.

See also: L<guestfs(3)/ISCSI>.

=item C<protocol = "nbd">

Connect to the Network Block Device server.
The C<server> parameter must also be supplied - see below.

See also: L<guestfs(3)/NETWORK BLOCK DEVICE>.

=item C<protocol = "rbd">

Connect to the Ceph (librbd/RBD) server.
The C<server> parameter must also be supplied - see below.
The C<username> parameter may be supplied.  See below.
The C<secret> parameter may be supplied.  See below.

See also: L<guestfs(3)/CEPH>.

=item C<protocol = "sheepdog">

Connect to the Sheepdog server.
The C<server> parameter may also be supplied - see below.

See also: L<guestfs(3)/SHEEPDOG>.

=item C<protocol = "ssh">

Connect to the Secure Shell (ssh) server.

The C<server> parameter must be supplied.
The C<username> parameter may be supplied.  See below.

See also: L<guestfs(3)/SSH>.

=back

=item C<server>

For protocols which require access to a remote server, this
is a list of server(s).

 Protocol       Number of servers required
 --------       --------------------------
 file           List must be empty or param not used at all
 ftp|ftps|http|https|tftp  Exactly one
 gluster        Exactly one
 iscsi          Exactly one
 nbd            Exactly one
 rbd            Zero or more
 sheepdog       Zero or more
 ssh            Exactly one

Each list element is a string specifying a server.  The string must be
in one of the following formats:

 hostname
 hostname:port
 tcp:hostname
 tcp:hostname:port
 unix:/path/to/socket

If the port number is omitted, then the standard port number
for the protocol is used (see F</etc/services>).

=item C<username>

For the C<ftp>, C<ftps>, C<http>, C<https>, C<iscsi>, C<rbd>, C<ssh>
and C<tftp> protocols, this specifies the remote username.

If not given, then the local username is used for C<ssh>, and no authentication
is attempted for ceph.  But note this sometimes may give unexpected results, for
example if using the libvirt backend and if the libvirt backend is configured to
start the qemu appliance as a special user such as C<qemu.qemu>.  If in doubt,
specify the remote username you want.

=item C<secret>

For the C<rbd> protocol only, this specifies the ‘secret’ to use when
connecting to the remote device.  It must be base64 encoded.

If not given, then a secret matching the given username will be looked up in the
default keychain locations, or if no username is given, then no authentication
will be used.

=item C<cachemode>

Choose whether or not libguestfs will obey sync operations (safe but slow)
or not (unsafe but fast).  The possible values for this string are:

=over 4

=item C<cachemode = "writeback">

This is the default.

Write operations in the API do not return until a L<write(2)>
call has completed in the host [but note this does not imply
that anything gets written to disk].

Sync operations in the API, including implicit syncs caused by
filesystem journalling, will not return until an L<fdatasync(2)>
call has completed in the host, indicating that data has been
committed to disk.

=item C<cachemode = "unsafe">

In this mode, there are no guarantees.  Libguestfs may cache
anything and ignore sync requests.  This is suitable only
for scratch or temporary disks.

=back

=item C<discard>

Enable or disable discard (a.k.a. trim or unmap) support on this
drive.  If enabled, operations such as L</fstrim> will be able
to discard / make thin / punch holes in the underlying host file
or device.

Possible discard settings are:

=over 4

=item C<discard = "disable">

Disable discard support.  This is the default.

=item C<discard = "enable">

Enable discard support.  Fail if discard is not possible.

=item C<discard = "besteffort">

Enable discard support if possible, but don't fail if it is not
supported.

Since not all backends and not all underlying systems support
discard, this is a good choice if you want to use discard if
possible, but don't mind if it doesn't work.

=back

=item C<copyonread>

The boolean parameter C<copyonread> enables copy-on-read support.
This only affects disk formats which have backing files, and causes
reads to be stored in the overlay layer, speeding up multiple reads
of the same area of disk.

The default is false.

=item C<blocksize>

This parameter sets the sector size of the disk.  Possible values are
C<512> (the default if the parameter is omitted) or C<4096>.  Use
C<4096> when handling an "Advanced Format" disk that uses 4K sector
size (L<https://en.wikipedia.org/wiki/Advanced_Format>).

Only a subset of the backends support this parameter (currently only the
libvirt and direct backends do).

=back

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 add-drive-ro

=head2 add-ro

 add-drive-ro filename

This function is the equivalent of calling L</add-drive-opts>
with the optional parameter C<GUESTFS_ADD_DRIVE_OPTS_READONLY> set to 1,
so the disk is added read-only, with the format being detected
automatically.

=head2 add-drive-ro-with-if

 add-drive-ro-with-if filename iface

This is the same as L</add-drive-ro> but it allows you
to specify the QEMU interface emulation to use at run time.

I<This function is deprecated.>
In new code, use the L</add-drive> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 add-drive-scratch

=head2 scratch

 add-drive-scratch size [name:..] [label:..] [blocksize:N]

This command adds a temporary scratch drive to the handle.  The
C<size> parameter is the virtual size (in bytes).  The scratch
drive is blank initially (all reads return zeroes until you start
writing to it).  The drive is deleted when the handle is closed.

The optional arguments C<name>, C<label> and C<blocksize> are passed through to
L</add-drive-opts>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 add-drive-with-if

 add-drive-with-if filename iface

This is the same as L</add-drive> but it allows you
to specify the QEMU interface emulation to use at run time.

I<This function is deprecated.>
In new code, use the L</add-drive> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 aug-clear

 aug-clear augpath

Set the value associated with C<path> to C<NULL>.  This
is the same as the L<augtool(1)> C<clear> command.

=head2 aug-close

 aug-close

Close the current Augeas handle and free up any resources
used by it.  After calling this, you have to call
L</aug-init> again before you can use any other
Augeas functions.

=head2 aug-defnode

 aug-defnode name expr val

Defines a variable C<name> whose value is the result of
evaluating C<expr>.

If C<expr> evaluates to an empty nodeset, a node is created,
equivalent to calling L</aug-set> C<expr>, C<val>.
C<name> will be the nodeset containing that single node.

On success this returns a pair containing the
number of nodes in the nodeset, and a boolean flag
if a node was created.

=head2 aug-defvar

 aug-defvar name expr

Defines an Augeas variable C<name> whose value is the result
of evaluating C<expr>.  If C<expr> is NULL, then C<name> is
undefined.

On success this returns the number of nodes in C<expr>, or
C<0> if C<expr> evaluates to something which is not a nodeset.

=head2 aug-get

 aug-get augpath

Look up the value associated with C<path>.  If C<path>
matches exactly one node, the C<value> is returned.

=head2 aug-init

 aug-init root flags

Create a new Augeas handle for editing configuration files.
If there was any previous Augeas handle associated with this
guestfs session, then it is closed.

You must call this before using any other L</aug-*>
commands.

C<root> is the filesystem root.  C<root> must not be NULL,
use F</> instead.

The flags are the same as the flags defined in
E<lt>augeas.hE<gt>, the logical I<or> of the following
integers:

=over 4

=item C<AUG_SAVE_BACKUP> = 1

Keep the original file with a C<.augsave> extension.

=item C<AUG_SAVE_NEWFILE> = 2

Save changes into a file with extension C<.augnew>, and
do not overwrite original.  Overrides C<AUG_SAVE_BACKUP>.

=item C<AUG_TYPE_CHECK> = 4

Typecheck lenses.

This option is only useful when debugging Augeas lenses.  Use
of this option may require additional memory for the libguestfs
appliance.  You may need to set the C<LIBGUESTFS_MEMSIZE>
environment variable or call L</set-memsize>.

=item C<AUG_NO_STDINC> = 8

Do not use standard load path for modules.

=item C<AUG_SAVE_NOOP> = 16

Make save a no-op, just record what would have been changed.

=item C<AUG_NO_LOAD> = 32

Do not load the tree in L</aug-init>.

=back

To close the handle, you can call L</aug-close>.

To find out more about Augeas, see L<http://augeas.net/>.

=head2 aug-insert

 aug-insert augpath label true|false

Create a new sibling C<label> for C<path>, inserting it into
the tree before or after C<path> (depending on the boolean
flag C<before>).

C<path> must match exactly one existing node in the tree, and
C<label> must be a label, ie. not contain F</>, C<*> or end
with a bracketed index C<[N]>.

=head2 aug-label

 aug-label augpath

The label (name of the last element) of the Augeas path expression
C<augpath> is returned.  C<augpath> must match exactly one node, else
this function returns an error.

=head2 aug-load

 aug-load

Load files into the tree.

See C<aug_load> in the Augeas documentation for the full gory
details.

=head2 aug-ls

 aug-ls augpath

This is just a shortcut for listing L</aug-match>
C<path/*> and sorting the resulting nodes into alphabetical order.

=head2 aug-match

 aug-match augpath

Returns a list of paths which match the path expression C<path>.
The returned paths are sufficiently qualified so that they match
exactly one node in the current tree.

=head2 aug-mv

 aug-mv src dest

Move the node C<src> to C<dest>.  C<src> must match exactly
one node.  C<dest> is overwritten if it exists.

=head2 aug-rm

 aug-rm augpath

Remove C<path> and all of its children.

On success this returns the number of entries which were removed.

=head2 aug-save

 aug-save

This writes all pending changes to disk.

The flags which were passed to L</aug-init> affect exactly
how files are saved.

=head2 aug-set

 aug-set augpath val

Set the value associated with C<augpath> to C<val>.

In the Augeas API, it is possible to clear a node by setting
the value to NULL.  Due to an oversight in the libguestfs API
you cannot do that with this call.  Instead you must use the
L</aug-clear> call.

=head2 aug-setm

 aug-setm base sub val

Change multiple Augeas nodes in a single operation.  C<base> is
an expression matching multiple nodes.  C<sub> is a path expression
relative to C<base>.  All nodes matching C<base> are found, and then
for each node, C<sub> is changed to C<val>.  C<sub> may also be C<NULL>
in which case the C<base> nodes are modified.

This returns the number of nodes modified.

=head2 aug-transform

 aug-transform lens file [remove:true|false]

Add an Augeas transformation for the specified C<lens> so it can
handle C<file>.

If C<remove> is true (C<false> by default), then the transformation
is removed.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 available

 available 'groups ...'

This command is used to check the availability of some
groups of functionality in the appliance, which not all builds of
the libguestfs appliance will be able to provide.

The libguestfs groups, and the functions that those
groups correspond to, are listed in L<guestfs(3)/AVAILABILITY>.
You can also fetch this list at runtime by calling
L</available-all-groups>.

The argument C<groups> is a list of group names, eg:
C<["inotify", "augeas"]> would check for the availability of
the Linux inotify functions and Augeas (configuration file
editing) functions.

The command returns no error if I<all> requested groups are available.

It fails with an error if one or more of the requested
groups is unavailable in the appliance.

If an unknown group name is included in the
list of groups then an error is always returned.

I<Notes:>

=over 4

=item *

L</feature-available> is the same as this call, but
with a slightly simpler to use API: that call returns a boolean
true/false instead of throwing an error.

=item *

You must call L</launch> before calling this function.

The reason is because we don't know what groups are
supported by the appliance/daemon until it is running and can
be queried.

=item *

If a group of functions is available, this does not necessarily
mean that they will work.  You still have to check for errors
when calling individual API functions even if they are
available.

=item *

It is usually the job of distro packagers to build
complete functionality into the libguestfs appliance.
Upstream libguestfs, if built from source with all
requirements satisfied, will support everything.

=item *

This call was added in version C<1.0.80>.  In previous
versions of libguestfs all you could do would be to speculatively
execute a command to find out if the daemon implemented it.
See also L</version>.

=back

See also L</filesystem-available>.

=head2 available-all-groups

 available-all-groups

This command returns a list of all optional groups that this
daemon knows about.  Note this returns both supported and unsupported
groups.  To find out which ones the daemon can actually support
you have to call L</available> / L</feature-available>
on each member of the returned list.

See also L</available>, L</feature-available>
and L<guestfs(3)/AVAILABILITY>.

=head2 base64-in

 base64-in (base64file|-) filename

This command uploads base64-encoded data from C<base64file>
to F<filename>.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 base64-out

 base64-out filename (base64file|-)

This command downloads the contents of F<filename>, writing
it out to local file C<base64file> encoded as base64.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 blkdiscard

 blkdiscard device

This discards all blocks on the block device C<device>, giving
the free space back to the host.

This operation requires support in libguestfs, the host filesystem,
qemu and the host kernel.  If this support isn't present it may give
an error or even appear to run but do nothing.  You must also
set the C<discard> attribute on the underlying drive (see
L</add-drive-opts>).

This command depends on the feature C<blkdiscard>.   See also
L</feature-available>.

=head2 blkdiscardzeroes

 blkdiscardzeroes device

This call returns true if blocks on C<device> that have been
discarded by a call to L</blkdiscard> are returned as
blocks of zero bytes when read the next time.

If it returns false, then it may be that discarded blocks are
read as stale or random data.

This command depends on the feature C<blkdiscardzeroes>.   See also
L</feature-available>.

=head2 blkid

 blkid device

This command returns block device attributes for C<device>. The following fields are
usually present in the returned hash. Other fields may also be present.

=over

=item C<UUID>

The uuid of this device.

=item C<LABEL>

The label of this device.

=item C<VERSION>

The version of blkid command.

=item C<TYPE>

The filesystem type or RAID of this device.

=item C<USAGE>

The usage of this device, for example C<filesystem> or C<raid>.

=back

=head2 blockdev-flushbufs

 blockdev-flushbufs device

This tells the kernel to flush internal buffers associated
with C<device>.

This uses the L<blockdev(8)> command.

=head2 blockdev-getbsz

 blockdev-getbsz device

This returns the block size of a device.

Note: this is different from both I<size in blocks> and
I<filesystem block size>.  Also this setting is not really
used by anything.  You should probably not use it for
anything.  Filesystems have their own idea about what
block size to choose.

This uses the L<blockdev(8)> command.

=head2 blockdev-getro

 blockdev-getro device

Returns a boolean indicating if the block device is read-only
(true if read-only, false if not).

This uses the L<blockdev(8)> command.

=head2 blockdev-getsize64

 blockdev-getsize64 device

This returns the size of the device in bytes.

See also L</blockdev-getsz>.

This uses the L<blockdev(8)> command.

=head2 blockdev-getss

 blockdev-getss device

This returns the size of sectors on a block device.
Usually 512, but can be larger for modern devices.

(Note, this is not the size in sectors, use L</blockdev-getsz>
for that).

This uses the L<blockdev(8)> command.

=head2 blockdev-getsz

 blockdev-getsz device

This returns the size of the device in units of 512-byte sectors
(even if the sectorsize isn't 512 bytes ... weird).

See also L</blockdev-getss> for the real sector size of
the device, and L</blockdev-getsize64> for the more
useful I<size in bytes>.

This uses the L<blockdev(8)> command.

=head2 blockdev-rereadpt

 blockdev-rereadpt device

Reread the partition table on C<device>.

This uses the L<blockdev(8)> command.

=head2 blockdev-setbsz

 blockdev-setbsz device blocksize

This call does nothing and has never done anything
because of a bug in blockdev.  B<Do not use it.>

If you need to set the filesystem block size, use the
C<blocksize> option of L</mkfs>.

I<This function is deprecated.>
There is no replacement.  Consult the API documentation in
L<guestfs(3)> for further information.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 blockdev-setra

 blockdev-setra device sectors

Set readahead (in 512-byte sectors) for the device.

This uses the L<blockdev(8)> command.

=head2 blockdev-setro

 blockdev-setro device

Sets the block device named C<device> to read-only.

This uses the L<blockdev(8)> command.

=head2 blockdev-setrw

 blockdev-setrw device

Sets the block device named C<device> to read-write.

This uses the L<blockdev(8)> command.

=head2 btrfs-balance-cancel

 btrfs-balance-cancel path

Cancel a running balance on a btrfs filesystem.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-balance-pause

 btrfs-balance-pause path

Pause a running balance on a btrfs filesystem.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-balance-resume

 btrfs-balance-resume path

Resume a paused balance on a btrfs filesystem.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-balance-status

 btrfs-balance-status path

Show the status of a running or paused balance on a btrfs filesystem.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-device-add

 btrfs-device-add 'devices ...' fs

Add the list of device(s) in C<devices> to the btrfs filesystem
mounted at C<fs>.  If C<devices> is an empty list, this does nothing.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-device-delete

 btrfs-device-delete 'devices ...' fs

Remove the C<devices> from the btrfs filesystem mounted at C<fs>.
If C<devices> is an empty list, this does nothing.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-filesystem-balance

=head2 btrfs-balance

 btrfs-filesystem-balance fs

Balance the chunks in the btrfs filesystem mounted at C<fs>
across the underlying devices.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-filesystem-defragment

 btrfs-filesystem-defragment path [flush:true|false] [compress:..]

Defragment a file or directory on a btrfs filesystem. compress is one of zlib or lzo.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-filesystem-resize

 btrfs-filesystem-resize mountpoint [size:N]

This command resizes a btrfs filesystem.

Note that unlike other resize calls, the filesystem has to be
mounted and the parameter is the mountpoint not the device
(this is a requirement of btrfs itself).

The optional parameters are:

=over 4

=item C<size>

The new size (in bytes) of the filesystem.  If omitted, the filesystem
is resized to the maximum size.

=back

See also L<btrfs(8)>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-filesystem-show

 btrfs-filesystem-show device

Show all the devices where the filesystems in C<device> is spanned over.

If not all the devices for the filesystems are present, then this function
fails and the C<errno> is set to C<ENODEV>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-filesystem-sync

 btrfs-filesystem-sync fs

Force sync on the btrfs filesystem mounted at C<fs>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-fsck

 btrfs-fsck device [superblock:N] [repair:true|false]

Used to check a btrfs filesystem, C<device> is the device file where the
filesystem is stored.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-image

 btrfs-image 'source ...' image [compresslevel:N]

This is used to create an image of a btrfs filesystem.
All data will be zeroed, but metadata and the like is preserved.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-qgroup-assign

 btrfs-qgroup-assign src dst path

Add qgroup C<src> to parent qgroup C<dst>. This command can group
several qgroups into a parent qgroup to share common limit.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-qgroup-create

 btrfs-qgroup-create qgroupid subvolume

Create a quota group (qgroup) for subvolume at C<subvolume>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-qgroup-destroy

 btrfs-qgroup-destroy qgroupid subvolume

Destroy a quota group.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-qgroup-limit

 btrfs-qgroup-limit subvolume size

Limit the size of the subvolume with path C<subvolume>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-qgroup-remove

 btrfs-qgroup-remove src dst path

Remove qgroup C<src> from the parent qgroup C<dst>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-qgroup-show

 btrfs-qgroup-show path

Show all subvolume quota groups in a btrfs filesystem, including their
usages.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-quota-enable

 btrfs-quota-enable fs true|false

Enable or disable subvolume quota support for filesystem which contains C<path>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-quota-rescan

 btrfs-quota-rescan fs

Trash all qgroup numbers and scan the metadata again with the current config.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-replace

 btrfs-replace srcdev targetdev mntpoint

Replace device of a btrfs filesystem. On a live filesystem, duplicate the data
to the target device which is currently stored on the source device.
After completion of the operation, the source device is wiped out and
removed from the filesystem.

The C<targetdev> needs to be same size or larger than the C<srcdev>. Devices
which are currently mounted are never allowed to be used as the C<targetdev>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-rescue-chunk-recover

 btrfs-rescue-chunk-recover device

Recover the chunk tree of btrfs filesystem by scanning the devices one by one.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-rescue-super-recover

 btrfs-rescue-super-recover device

Recover bad superblocks from good copies.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-scrub-cancel

 btrfs-scrub-cancel path

Cancel a running scrub on a btrfs filesystem.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-scrub-resume

 btrfs-scrub-resume path

Resume a previously canceled or interrupted scrub on a btrfs filesystem.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-scrub-start

 btrfs-scrub-start path

Reads all the data and metadata on the filesystem, and uses checksums
and the duplicate copies from RAID storage to identify and repair any
corrupt data.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-scrub-status

 btrfs-scrub-status path

Show status of running or finished scrub on a btrfs filesystem.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-set-seeding

 btrfs-set-seeding device true|false

Enable or disable the seeding feature of a device that contains
a btrfs filesystem.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-subvolume-create

=head2 btrfs-subvolume-create-opts

 btrfs-subvolume-create dest [qgroupid:..]

Create a btrfs subvolume.  The C<dest> argument is the destination
directory and the name of the subvolume, in the form F</path/to/dest/name>.
The optional parameter C<qgroupid> represents the qgroup which the newly
created subvolume will be added to.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-subvolume-delete

 btrfs-subvolume-delete subvolume

Delete the named btrfs subvolume or snapshot.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-subvolume-get-default

 btrfs-subvolume-get-default fs

Get the default subvolume or snapshot of a filesystem mounted at C<mountpoint>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-subvolume-list

 btrfs-subvolume-list fs

List the btrfs snapshots and subvolumes of the btrfs filesystem
which is mounted at C<fs>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-subvolume-set-default

 btrfs-subvolume-set-default id fs

Set the subvolume of the btrfs filesystem C<fs> which will
be mounted by default.  See L</btrfs-subvolume-list> to
get a list of subvolumes.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-subvolume-show

 btrfs-subvolume-show subvolume

Return detailed information of the subvolume.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfs-subvolume-snapshot

=head2 btrfs-subvolume-snapshot-opts

 btrfs-subvolume-snapshot source dest [ro:true|false] [qgroupid:..]

Create a snapshot of the btrfs subvolume C<source>.
The C<dest> argument is the destination directory and the name
of the snapshot, in the form F</path/to/dest/name>. By default
the newly created snapshot is writable, if the value of optional
parameter C<ro> is true, then a readonly snapshot is created. The
optional parameter C<qgroupid> represents the qgroup which the
newly created snapshot will be added to.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfstune-enable-extended-inode-refs

 btrfstune-enable-extended-inode-refs device

This will Enable extended inode refs.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfstune-enable-skinny-metadata-extent-refs

 btrfstune-enable-skinny-metadata-extent-refs device

This enable skinny metadata extent refs.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 btrfstune-seeding

 btrfstune-seeding device true|false

Enable seeding of a btrfs device, this will force a fs readonly
so that you can use it to build other filesystems.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 c-pointer

 c-pointer

In non-C language bindings, this allows you to retrieve the underlying
C pointer to the handle (ie. L</h *>).  The purpose of this is
to allow other libraries to interwork with libguestfs.

=head2 canonical-device-name

 canonical-device-name device

This utility function is useful when displaying device names to
the user.  It takes a number of irregular device names and
returns them in a consistent format:

=over 4

=item F</dev/hdX>

=item F</dev/vdX>

These are returned as F</dev/sdX>.  Note this works for device
names and partition names.  This is approximately the reverse of
the algorithm described in L<guestfs(3)/BLOCK DEVICE NAMING>.

=item F</dev/mapper/VG-LV>

=item F</dev/dm-N>

Converted to F</dev/VG/LV> form using L</lvm-canonical-lv-name>.

=back

Other strings are returned unmodified.

=head2 cap-get-file

 cap-get-file path

This function returns the Linux capabilities attached to C<path>.
The capabilities set is returned in text form (see L<cap_to_text(3)>).

If no capabilities are attached to a file, an empty string is returned.

This command depends on the feature C<linuxcaps>.   See also
L</feature-available>.

=head2 cap-set-file

 cap-set-file path cap

This function sets the Linux capabilities attached to C<path>.
The capabilities set C<cap> should be passed in text form
(see L<cap_from_text(3)>).

This command depends on the feature C<linuxcaps>.   See also
L</feature-available>.

=head2 case-sensitive-path

 case-sensitive-path path

This can be used to resolve case insensitive paths on
a filesystem which is case sensitive.  The use case is
to resolve paths which you have read from Windows configuration
files or the Windows Registry, to the true path.

The command handles a peculiarity of the Linux ntfs-3g
filesystem driver (and probably others), which is that although
the underlying filesystem is case-insensitive, the driver
exports the filesystem to Linux as case-sensitive.

One consequence of this is that special directories such
as F<C:\windows> may appear as F</WINDOWS> or F</windows>
(or other things) depending on the precise details of how
they were created.  In Windows itself this would not be
a problem.

Bug or feature?  You decide:
L<https://www.tuxera.com/community/ntfs-3g-faq/#posixfilenames1>

L</case-sensitive-path> attempts to resolve the true case of
each element in the path. It will return a resolved path if either the
full path or its parent directory exists. If the parent directory
exists but the full path does not, the case of the parent directory
will be correctly resolved, and the remainder appended unmodified. For
example, if the file C<"/Windows/System32/netkvm.sys"> exists:

=over 4

=item L</case-sensitive-path> ("/windows/system32/netkvm.sys")

"Windows/System32/netkvm.sys"

=item L</case-sensitive-path> ("/windows/system32/NoSuchFile")

"Windows/System32/NoSuchFile"

=item L</case-sensitive-path> ("/windows/system33/netkvm.sys")

I<ERROR>

=back

I<Note>:
Because of the above behaviour, L</case-sensitive-path> cannot
be used to check for the existence of a file.

I<Note>:
This function does not handle drive names, backslashes etc.

See also L</realpath>.

=head2 cat

 cat path

Return the contents of the file named C<path>.

Because, in C, this function returns a C<char *>, there is no
way to differentiate between a C<\0> character in a file and
end of string.  To handle binary files, use the L</read-file>
or L</download> functions.

=head2 checksum

 checksum csumtype path

This call computes the MD5, SHAx or CRC checksum of the
file named C<path>.

The type of checksum to compute is given by the C<csumtype>
parameter which must have one of the following values:

=over 4

=item C<crc>

Compute the cyclic redundancy check (CRC) specified by POSIX
for the C<cksum> command.

=item C<md5>

Compute the MD5 hash (using the L<md5sum(1)> program).

=item C<sha1>

Compute the SHA1 hash (using the L<sha1sum(1)> program).

=item C<sha224>

Compute the SHA224 hash (using the L<sha224sum(1)> program).

=item C<sha256>

Compute the SHA256 hash (using the L<sha256sum(1)> program).

=item C<sha384>

Compute the SHA384 hash (using the L<sha384sum(1)> program).

=item C<sha512>

Compute the SHA512 hash (using the L<sha512sum(1)> program).

=back

The checksum is returned as a printable string.

To get the checksum for a device, use L</checksum-device>.

To get the checksums for many files, use L</checksums-out>.

=head2 checksum-device

 checksum-device csumtype device

This call computes the MD5, SHAx or CRC checksum of the
contents of the device named C<device>.  For the types of
checksums supported see the L</checksum> command.

=head2 checksums-out

 checksums-out csumtype directory (sumsfile|-)

This command computes the checksums of all regular files in
F<directory> and then emits a list of those checksums to
the local output file C<sumsfile>.

This can be used for verifying the integrity of a virtual
machine.  However to be properly secure you should pay
attention to the output of the checksum command (it uses
the ones from GNU coreutils).  In particular when the
filename is not printable, coreutils uses a special
backslash syntax.  For more information, see the GNU
coreutils info file.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 chmod

 chmod mode path

Change the mode (permissions) of C<path> to C<mode>.  Only
numeric modes are supported.

I<Note>: When using this command from guestfish, C<mode>
by default would be decimal, unless you prefix it with
C<0> to get octal, ie. use C<0700> not C<700>.

The mode actually set is affected by the umask.

=head2 chown

 chown owner group path

Change the file owner to C<owner> and group to C<group>.

Only numeric uid and gid are supported.  If you want to use
names, you will need to locate and parse the password file
yourself (Augeas support makes this relatively easy).

=head2 clear-backend-setting

 clear-backend-setting name

If there is a backend setting string matching C<"name"> or
beginning with C<"name=">, then that string is removed
from the backend settings.

This call returns the number of strings which were removed
(which may be 0, 1 or greater than 1).

See L<guestfs(3)/BACKEND>, L<guestfs(3)/BACKEND SETTINGS>.

=head2 command

 command 'arguments ...'

This call runs a command from the guest filesystem.  The
filesystem must be mounted, and must contain a compatible
operating system (ie. something Linux, with the same
or compatible processor architecture).

The single parameter is an argv-style list of arguments.
The first element is the name of the program to run.
Subsequent elements are parameters.  The list must be
non-empty (ie. must contain a program name).  Note that
the command runs directly, and is I<not> invoked via
the shell (see L</sh>).

The return value is anything printed to I<stdout> by
the command.

If the command returns a non-zero exit status, then
this function returns an error message.  The error message
string is the content of I<stderr> from the command.

The C<$PATH> environment variable will contain at least
F</usr/bin> and F</bin>.  If you require a program from
another location, you should provide the full path in the
first parameter.

Shared libraries and data files required by the program
must be available on filesystems which are mounted in the
correct places.  It is the caller’s responsibility to ensure
all filesystems that are needed are mounted at the right
locations.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 command-lines

 command-lines 'arguments ...'

This is the same as L</command>, but splits the
result into a list of lines.

See also: L</sh-lines>

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 compress-device-out

 compress-device-out ctype device (zdevice|-) [level:N]

This command compresses C<device> and writes it out to the local
file C<zdevice>.

The C<ctype> and optional C<level> parameters have the same meaning
as in L</compress-out>.

Use C<-> instead of a filename to read/write from stdin/stdout.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 compress-out

 compress-out ctype file (zfile|-) [level:N]

This command compresses F<file> and writes it out to the local
file F<zfile>.

The compression program used is controlled by the C<ctype> parameter.
Currently this includes: C<compress>, C<gzip>, C<bzip2>, C<xz> or C<lzop>.
Some compression types may not be supported by particular builds of
libguestfs, in which case you will get an error containing the
substring "not supported".

The optional C<level> parameter controls compression level.  The
meaning and default for this parameter depends on the compression
program being used.

Use C<-> instead of a filename to read/write from stdin/stdout.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 config

 config hvparam hvvalue

This can be used to add arbitrary hypervisor parameters of the
form I<-param value>.  Actually it’s not quite arbitrary - we
prevent you from setting some parameters which would interfere with
parameters that we use.

The first character of C<hvparam> string must be a C<-> (dash).

C<hvvalue> can be NULL.

=head2 copy-attributes

 copy-attributes src dest [all:true|false] [mode:true|false] [xattributes:true|false] [ownership:true|false]

Copy the attributes of a path (which can be a file or a directory)
to another path.

By default B<no> attribute is copied, so make sure to specify any
(or C<all> to copy everything).

The optional arguments specify which attributes can be copied:

=over 4

=item C<mode>

Copy part of the file mode from C<source> to C<destination>. Only the
UNIX permissions and the sticky/setuid/setgid bits can be copied.

=item C<xattributes>

Copy the Linux extended attributes (xattrs) from C<source> to C<destination>.
This flag does nothing if the I<linuxxattrs> feature is not available
(see L</feature-available>).

=item C<ownership>

Copy the owner uid and the group gid of C<source> to C<destination>.

=item C<all>

Copy B<all> the attributes from C<source> to C<destination>. Enabling it
enables all the other flags, if they are not specified already.

=back

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 copy-device-to-device

 copy-device-to-device src dest [srcoffset:N] [destoffset:N] [size:N] [sparse:true|false] [append:true|false]

The four calls L</copy-device-to-device>,
L</copy-device-to-file>,
L</copy-file-to-device>, and
L</copy-file-to-file>
let you copy from a source (device|file) to a destination
(device|file).

Partial copies can be made since you can specify optionally
the source offset, destination offset and size to copy.  These
values are all specified in bytes.  If not given, the offsets
both default to zero, and the size defaults to copying as much
as possible until we hit the end of the source.

The source and destination may be the same object.  However
overlapping regions may not be copied correctly.

If the destination is a file, it is created if required.  If
the destination file is not large enough, it is extended.

If the destination is a file and the C<append> flag is not set,
then the destination file is truncated.  If the C<append> flag is
set, then the copy appends to the destination file.  The C<append>
flag currently cannot be set for devices.

If the C<sparse> flag is true then the call avoids writing
blocks that contain only zeroes, which can help in some situations
where the backing disk is thin-provisioned.  Note that unless
the target is already zeroed, using this option will result
in incorrect copying.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 copy-device-to-file

 copy-device-to-file src dest [srcoffset:N] [destoffset:N] [size:N] [sparse:true|false] [append:true|false]

See L</copy-device-to-device> for a general overview
of this call.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 copy-file-to-device

 copy-file-to-device src dest [srcoffset:N] [destoffset:N] [size:N] [sparse:true|false] [append:true|false]

See L</copy-device-to-device> for a general overview
of this call.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 copy-file-to-file

 copy-file-to-file src dest [srcoffset:N] [destoffset:N] [size:N] [sparse:true|false] [append:true|false]

See L</copy-device-to-device> for a general overview
of this call.

This is B<not> the function you want for copying files.  This
is for copying blocks within existing files.  See L</cp>,
L</cp-a> and L</mv> for general file copying and
moving functions.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 copy-size

 copy-size src dest size

This command copies exactly C<size> bytes from one source device
or file C<src> to another destination device or file C<dest>.

Note this will fail if the source is too short or if the destination
is not large enough.

I<This function is deprecated.>
In new code, use the L</copy-device-to-device> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 cp

 cp src dest

This copies a file from C<src> to C<dest> where C<dest> is
either a destination filename or destination directory.

=head2 cp-a

 cp-a src dest

This copies a file or directory from C<src> to C<dest>
recursively using the C<cp -a> command.

=head2 cp-r

 cp-r src dest

This copies a file or directory from C<src> to C<dest>
recursively using the C<cp -rP> command.

Most users should use L</cp-a> instead.  This command
is useful when you don't want to preserve permissions, because
the target filesystem does not support it (primarily when
writing to DOS FAT filesystems).

=head2 cpio-out

 cpio-out directory (cpiofile|-) [format:..]

This command packs the contents of F<directory> and downloads
it to local file C<cpiofile>.

The optional C<format> parameter can be used to select the format.
Only the following formats are currently permitted:

=over 4

=item C<newc>

New (SVR4) portable format.  This format happens to be compatible
with the cpio-like format used by the Linux kernel for initramfs.

This is the default format.

=item C<crc>

New (SVR4) portable format with a checksum.

=back

Use C<-> instead of a filename to read/write from stdin/stdout.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 cryptsetup-close

 cryptsetup-close device

This closes an encrypted device that was created earlier by
L</cryptsetup-open>.  The C<device> parameter must be
the name of the mapping device (ie. F</dev/mapper/mapname>)
and I<not> the name of the underlying block device.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 cryptsetup-open

 cryptsetup-open device mapname [readonly:true|false] [crypttype:..]

This command opens a block device which has been encrypted
according to the Linux Unified Key Setup (LUKS) standard,
Windows BitLocker, or some other types.

C<device> is the encrypted block device or partition.

The caller must supply one of the keys associated with the
encrypted block device, in the C<key> parameter.

This creates a new block device called F</dev/mapper/mapname>.
Reads and writes to this block device are decrypted from and
encrypted to the underlying C<device> respectively.

C<mapname> cannot be C<"control"> because that name is reserved
by device-mapper.

If the optional C<crypttype> parameter is not present then
libguestfs tries to guess the correct type (for example
LUKS or BitLocker).  However you can override this by
specifying one of the following types:

=over 4

=item C<luks>

A Linux LUKS device.

=item C<bitlk>

A Windows BitLocker device.

=back

The optional C<readonly> flag, if set to true, creates a
read-only mapping.

If this block device contains LVM volume groups, then
calling L</lvm-scan> with the C<activate>
parameter C<true> will make them visible.

Use L</list-dm-devices> to list all device mapper
devices.

This command has one or more key or passphrase parameters.
Guestfish will prompt for these separately.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 dd

 dd src dest

This command copies from one source device or file C<src>
to another destination device or file C<dest>.  Normally you
would use this to copy to or from a device or partition, for
example to duplicate a filesystem.

If the destination is a device, it must be as large or larger
than the source file or device, otherwise the copy will fail.
This command cannot do partial copies
(see L</copy-device-to-device>).

I<This function is deprecated.>
In new code, use the L</copy-device-to-device> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 device-index

 device-index device

This function takes a device name (eg. "/dev/sdb") and
returns the index of the device in the list of devices.

Index numbers start from 0.  The named device must exist,
for example as a string returned from L</list-devices>.

See also L</list-devices>, L</part-to-dev>.

=head2 df

 df

This command runs the L<df(1)> command to report disk space used.

This command is mostly useful for interactive sessions.  It
is I<not> intended that you try to parse the output string.
Use L</statvfs> from programs.

=head2 df-h

 df-h

This command runs the C<df -h> command to report disk space used
in human-readable format.

This command is mostly useful for interactive sessions.  It
is I<not> intended that you try to parse the output string.
Use L</statvfs> from programs.

=head2 disk-create

 disk-create filename format size [backingfile:..] [backingformat:..] [preallocation:..] [compat:..] [clustersize:N]

Create a blank disk image called F<filename> (a host file)
with format C<format> (usually C<raw> or C<qcow2>).
The size is C<size> bytes.

If used with the optional C<backingfile> parameter, then a snapshot
is created on top of the backing file.  In this case, C<size> must
be passed as C<-1>.  The size of the snapshot is the same as the
size of the backing file, which is discovered automatically.  You
are encouraged to also pass C<backingformat> to describe the format
of C<backingfile>.

If F<filename> refers to a block device, then the device is
formatted.  The C<size> is ignored since block devices have an
intrinsic size.

The other optional parameters are:

=over 4

=item C<preallocation>

If format is C<raw>, then this can be either C<off> (or C<sparse>)
or C<full> to create a sparse or fully allocated file respectively.
The default is C<off>.

If format is C<qcow2>, then this can be C<off> (or C<sparse>),
C<metadata> or C<full>.  Preallocating metadata can be faster
when doing lots of writes, but uses more space.
The default is C<off>.

=item C<compat>

C<qcow2> only:
Pass the string C<1.1> to use the advanced qcow2 format supported
by qemu E<ge> 1.1.

=item C<clustersize>

C<qcow2> only:
Change the qcow2 cluster size.  The default is 65536 (bytes) and
this setting may be any power of two between 512 and 2097152.

=back

Note that this call does not add the new disk to the handle.  You
may need to call L</add-drive-opts> separately.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 disk-format

 disk-format filename

Detect and return the format of the disk image called F<filename>.
F<filename> can also be a host device, etc.  If the format of the
image could not be detected, then C<"unknown"> is returned.

Note that detecting the disk format can be insecure under some
circumstances.  See L<guestfs(3)/CVE-2010-3851>.

See also: L<guestfs(3)/DISK IMAGE FORMATS>

=head2 disk-has-backing-file

 disk-has-backing-file filename

Detect and return whether the disk image F<filename> has a
backing file.

Note that detecting disk features can be insecure under some
circumstances.  See L<guestfs(3)/CVE-2010-3851>.

=head2 disk-virtual-size

 disk-virtual-size filename

Detect and return the virtual size in bytes of the disk image
called F<filename>.

Note that detecting disk features can be insecure under some
circumstances.  See L<guestfs(3)/CVE-2010-3851>.

=head2 dmesg

 dmesg

This returns the kernel messages (L<dmesg(1)> output) from
the guest kernel.  This is sometimes useful for extended
debugging of problems.

Another way to get the same information is to enable
verbose messages with L</set-verbose> or by setting
the environment variable C<LIBGUESTFS_DEBUG=1> before
running the program.

=head2 download

 download remotefilename (filename|-)

Download file F<remotefilename> and save it as F<filename>
on the local machine.

F<filename> can also be a named pipe.

See also L</upload>, L</cat>.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 download-blocks

 download-blocks device start stop (filename|-) [unallocated:true|false]

Download the data units from F<start> address
to F<stop> from the disk partition (eg. F</dev/sda1>)
and save them as F<filename> on the local machine.

The use of this API on sparse disk image formats such as QCOW,
may result in large zero-filled files downloaded on the host.

The size of a data unit varies across filesystem implementations.
On NTFS filesystems data units are referred as clusters
while on ExtX ones they are referred as fragments.

If the optional C<unallocated> flag is true (default is false),
only the unallocated blocks will be extracted.
This is useful to detect hidden data or to retrieve deleted files
which data units have not been overwritten yet.

Use C<-> instead of a filename to read/write from stdin/stdout.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<sleuthkit>.   See also
L</feature-available>.

=head2 download-inode

 download-inode device inode (filename|-)

Download a file given its inode from the disk partition
(eg. F</dev/sda1>) and save it as F<filename> on the local machine.

It is not required to mount the disk to run this command.

The command is capable of downloading deleted or inaccessible files.

Use C<-> instead of a filename to read/write from stdin/stdout.

This command depends on the feature C<sleuthkit>.   See also
L</feature-available>.

=head2 download-offset

 download-offset remotefilename (filename|-) offset size

Download file F<remotefilename> and save it as F<filename>
on the local machine.

F<remotefilename> is read for C<size> bytes starting at C<offset>
(this region must be within the file or device).

Note that there is no limit on the amount of data that
can be downloaded with this call, unlike with L</pread>,
and this call always reads the full amount unless an
error occurs.

See also L</download>, L</pread>.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 drop-caches

 drop-caches whattodrop

This instructs the guest kernel to drop its page cache,
and/or dentries and inode caches.  The parameter C<whattodrop>
tells the kernel what precisely to drop, see
L<https://linux-mm.org/Drop_Caches>

Setting C<whattodrop> to 3 should drop everything.

This automatically calls L<sync(2)> before the operation,
so that the maximum guest memory is freed.

=head2 du

 du path

This command runs the C<du -s> command to estimate file space
usage for C<path>.

C<path> can be a file or a directory.  If C<path> is a directory
then the estimate includes the contents of the directory and all
subdirectories (recursively).

The result is the estimated size in I<kilobytes>
(ie. units of 1024 bytes).

=head2 e2fsck

 e2fsck device [correct:true|false] [forceall:true|false]

This runs the ext2/ext3 filesystem checker on C<device>.
It can take the following optional arguments:

=over 4

=item C<correct>

Automatically repair the file system. This option will cause e2fsck
to automatically fix any filesystem problems that can be safely
fixed without human intervention.

This option may not be specified at the same time as the C<forceall> option.

=item C<forceall>

Assume an answer of ‘yes’ to all questions; allows e2fsck to be used
non-interactively.

This option may not be specified at the same time as the C<correct> option.

=back

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 e2fsck-f

 e2fsck-f device

This runs C<e2fsck -p -f device>, ie. runs the ext2/ext3
filesystem checker on C<device>, noninteractively (I<-p>),
even if the filesystem appears to be clean (I<-f>).

I<This function is deprecated.>
In new code, use the L</e2fsck> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 echo-daemon

 echo-daemon 'words ...'

This command concatenates the list of C<words> passed with single spaces
between them and returns the resulting string.

You can use this command to test the connection through to the daemon.

See also L</ping-daemon>.

=head2 egrep

 egrep regex path

This calls the external L<egrep(1)> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 egrepi

 egrepi regex path

This calls the external C<egrep -i> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 equal

 equal file1 file2

This compares the two files F<file1> and F<file2> and returns
true if their content is exactly equal, or false otherwise.

The external L<cmp(1)> program is used for the comparison.

=head2 exists

 exists path

This returns C<true> if and only if there is a file, directory
(or anything) with the given C<path> name.

See also L</is-file>, L</is-dir>, L</stat>.

=head2 extlinux

 extlinux directory

Install the SYSLINUX bootloader on the device mounted at F<directory>.
Unlike L</syslinux> which requires a FAT filesystem, this can
be used on an ext2/3/4 or btrfs filesystem.

The F<directory> parameter can be either a mountpoint, or a
directory within the mountpoint.

You also have to mark the partition as "active"
(L</part-set-bootable>) and a Master Boot Record must
be installed (eg. using L</pwrite-device>) on the first
sector of the whole disk.
The SYSLINUX package comes with some suitable Master Boot Records.
See the L<extlinux(1)> man page for further information.

Additional configuration can be supplied to SYSLINUX by
placing a file called F<extlinux.conf> on the filesystem
under F<directory>.  For further information
about the contents of this file, see L<extlinux(1)>.

See also L</syslinux>.

This command depends on the feature C<extlinux>.   See also
L</feature-available>.

=head2 f2fs-expand

 f2fs-expand device

This expands a f2fs filesystem to match the size of the underlying
device.

This command depends on the feature C<f2fs>.   See also
L</feature-available>.

=head2 fallocate

 fallocate path len

This command preallocates a file (containing zero bytes) named
C<path> of size C<len> bytes.  If the file exists already, it
is overwritten.

Do not confuse this with the guestfish-specific
C<alloc> command which allocates a file in the host and
attaches it as a device.

I<This function is deprecated.>
In new code, use the L</fallocate64> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 fallocate64

 fallocate64 path len

This command preallocates a file (containing zero bytes) named
C<path> of size C<len> bytes.  If the file exists already, it
is overwritten.

Note that this call allocates disk blocks for the file.
To create a sparse file use L</truncate-size> instead.

The deprecated call L</fallocate> does the same,
but owing to an oversight it only allowed 30 bit lengths
to be specified, effectively limiting the maximum size
of files created through that call to 1GB.

Do not confuse this with the guestfish-specific
C<alloc> and C<sparse> commands which create
a file in the host and attach it as a device.

=head2 feature-available

 feature-available 'groups ...'

This is the same as L</available>, but unlike that
call it returns a simple true/false boolean result, instead
of throwing an exception if a feature is not found.  For
other documentation see L</available>.

=head2 fgrep

 fgrep pattern path

This calls the external L<fgrep(1)> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 fgrepi

 fgrepi pattern path

This calls the external C<fgrep -i> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 file

 file path

This call uses the standard L<file(1)> command to determine
the type or contents of the file.

This call will also transparently look inside various types
of compressed file.

The exact command which runs is C<file -zb path>.  Note in
particular that the filename is not prepended to the output
(the I<-b> option).

The output depends on the output of the underlying L<file(1)>
command and it can change in future in ways beyond our control.
In other words, the output is not guaranteed by the ABI.

See also: L<file(1)>, L</vfs-type>, L</lstat>,
L</is-file>, L</is-blockdev> (etc), L</is-zero>.

=head2 file-architecture

 file-architecture filename

This detects the architecture of the binary F<filename>,
and returns it if known.

Currently defined architectures are:

=over 4

=item "aarch64"

64 bit ARM.

=item "arm"

32 bit ARM.

=item "i386"

This string is returned for all 32 bit i386, i486, i586, i686 binaries
irrespective of the precise processor requirements of the binary.

=item "ia64"

Intel Itanium.

=item "ppc"

32 bit Power PC.

=item "ppc64"

64 bit Power PC (big endian).

=item "ppc64le"

64 bit Power PC (little endian).

=item "riscv32"

=item "riscv64"

=item "riscv128"

RISC-V 32-, 64- or 128-bit variants.

=item "s390"

31 bit IBM S/390.

=item "s390x"

64 bit IBM S/390.

=item "sparc"

32 bit SPARC.

=item "sparc64"

64 bit SPARC V9 and above.

=item "x86_64"

64 bit x86-64.

=back

Libguestfs may return other architecture strings in future.

The function works on at least the following types of files:

=over 4

=item *

many types of Un*x and Linux binary

=item *

many types of Un*x and Linux shared library

=item *

Windows Win32 and Win64 binaries

=item *

Windows Win32 and Win64 DLLs

Win32 binaries and DLLs return C<i386>.

Win64 binaries and DLLs return C<x86_64>.

=item *

Linux kernel modules

=item *

Linux new-style initrd images

=item *

some non-x86 Linux vmlinuz kernels

=back

What it can't do currently:

=over 4

=item *

static libraries (libfoo.a)

=item *

Linux old-style initrd as compressed ext2 filesystem (RHEL 3)

=item *

x86 Linux vmlinuz kernels

x86 vmlinuz images (bzImage format) consist of a mix of 16-, 32- and
compressed code, and are horribly hard to unpack.  If you want to find
the architecture of a kernel, use the architecture of the associated
initrd or kernel module(s) instead.

=back

=head2 filesize

 filesize file

This command returns the size of F<file> in bytes.

To get other stats about a file, use L</stat>, L</lstat>,
L</is-dir>, L</is-file> etc.
To get the size of block devices, use L</blockdev-getsize64>.

=head2 filesystem-available

 filesystem-available filesystem

Check whether libguestfs supports the named filesystem.
The argument C<filesystem> is a filesystem name, such as
C<ext3>.

You must call L</launch> before using this command.

This is mainly useful as a negative test.  If this returns true,
it doesn't mean that a particular filesystem can be created
or mounted, since filesystems can fail for other reasons
such as it being a later version of the filesystem,
or having incompatible features, or lacking the right
mkfs.E<lt>I<fs>E<gt> tool.

See also L</available>, L</feature-available>,
L<guestfs(3)/AVAILABILITY>.

=head2 filesystem-walk

 filesystem-walk device

Walk through the internal structures of a disk partition
(eg. F</dev/sda1>) in order to return a list of all the files
and directories stored within.

It is not necessary to mount the disk partition to run this command.

All entries in the filesystem are returned. This function can list deleted
or unaccessible files. The entries are I<not> sorted.

The C<tsk_dirent> structure contains the following fields.

=over 4

=item C<tsk_inode>

Filesystem reference number of the node. It might be C<0>
if the node has been deleted.

=item C<tsk_type>

Basic file type information.
See below for a detailed list of values.

=item C<tsk_size>

File size in bytes. It might be C<-1>
if the node has been deleted.

=item C<tsk_name>

The file path relative to its directory.

=item C<tsk_flags>

Bitfield containing extra information regarding the entry.
It contains the logical OR of the following values:

=over 4

=item 0x0001

If set to C<1>, the file is allocated and visible within the filesystem.
Otherwise, the file has been deleted.
Under certain circumstances, the function C<download_inode>
can be used to recover deleted files.

=item 0x0002

Filesystem such as NTFS and Ext2 or greater, separate the file name
from the metadata structure.
The bit is set to C<1> when the file name is in an unallocated state
and the metadata structure is in an allocated one.
This generally implies the metadata has been reallocated to a new file.
Therefore, information such as file type, file size, timestamps,
number of links and symlink target might not correspond
with the ones of the original deleted entry.

=item 0x0004

The bit is set to C<1> when the file is compressed using filesystem
native compression support (NTFS). The API is not able to detect
application level compression.

=back

=item C<tsk_atime_sec>

=item C<tsk_atime_nsec>

=item C<tsk_mtime_sec>

=item C<tsk_mtime_nsec>

=item C<tsk_ctime_sec>

=item C<tsk_ctime_nsec>

=item C<tsk_crtime_sec>

=item C<tsk_crtime_nsec>

Respectively, access, modification, last status change and creation
time in Unix format in seconds and nanoseconds.

=item C<tsk_nlink>

Number of file names pointing to this entry.

=item C<tsk_link>

If the entry is a symbolic link, this field will contain the path
to the target file.

=back

The C<tsk_type> field will contain one of the following characters:

=over 4

=item 'b'

Block special

=item 'c'

Char special

=item 'd'

Directory

=item 'f'

FIFO (named pipe)

=item 'l'

Symbolic link

=item 'r'

Regular file

=item 's'

Socket

=item 'h'

Shadow inode (Solaris)

=item 'w'

Whiteout inode (BSD)

=item 'u'

Unknown file type

=back

This command depends on the feature C<libtsk>.   See also
L</feature-available>.

=head2 fill

 fill c len path

This command creates a new file called C<path>.  The initial
content of the file is C<len> octets of C<c>, where C<c>
must be a number in the range C<[0..255]>.

To fill a file with zero bytes (sparsely), it is
much more efficient to use L</truncate-size>.
To create a file with a pattern of repeating bytes
use L</fill-pattern>.

=head2 fill-dir

 fill-dir dir nr

This function, useful for testing filesystems, creates C<nr>
empty files in the directory C<dir> with names C<00000000>
through C<nr-1> (ie. each file name is 8 digits long padded
with zeroes).

=head2 fill-pattern

 fill-pattern pattern len path

This function is like L</fill> except that it creates
a new file of length C<len> containing the repeating pattern
of bytes in C<pattern>.  The pattern is truncated if necessary
to ensure the length of the file is exactly C<len> bytes.

=head2 find

 find directory

This command lists out all files and directories, recursively,
starting at F<directory>.  It is essentially equivalent to
running the shell command C<find directory -print> but some
post-processing happens on the output, described below.

This returns a list of strings I<without any prefix>.  Thus
if the directory structure was:

 /tmp/a
 /tmp/b
 /tmp/c/d

then the returned list from L</find> F</tmp> would be
4 elements:

 a
 b
 c
 c/d

If F<directory> is not a directory, then this command returns
an error.

The returned list is sorted.

=head2 find0

 find0 directory (files|-)

This command lists out all files and directories, recursively,
starting at F<directory>, placing the resulting list in the
external file called F<files>.

This command works the same way as L</find> with the
following exceptions:

=over 4

=item *

The resulting list is written to an external file.

=item *

Items (filenames) in the result are separated
by C<\0> characters.  See L<find(1)> option I<-print0>.

=item *

The result list is not sorted.

=back

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 find-inode

 find-inode device inode

Searches all the entries associated with the given inode.

For each entry, a C<tsk_dirent> structure is returned.
See C<filesystem_walk> for more information about C<tsk_dirent> structures.

This command depends on the feature C<libtsk>.   See also
L</feature-available>.

=head2 findfs-label

 findfs-label label

This command searches the filesystems and returns the one
which has the given label.  An error is returned if no such
filesystem can be found.

To find the label of a filesystem, use L</vfs-label>.

=head2 findfs-uuid

 findfs-uuid uuid

This command searches the filesystems and returns the one
which has the given UUID.  An error is returned if no such
filesystem can be found.

To find the UUID of a filesystem, use L</vfs-uuid>.

=head2 fsck

 fsck fstype device

This runs the filesystem checker (fsck) on C<device> which
should have filesystem type C<fstype>.

The returned integer is the status.  See L<fsck(8)> for the
list of status codes from C<fsck>.

Notes:

=over 4

=item *

Multiple status codes can be summed together.

=item *

A non-zero return code can mean "success", for example if
errors have been corrected on the filesystem.

=item *

Checking or repairing NTFS volumes is not supported
(by linux-ntfs).

=back

This command is entirely equivalent to running C<fsck -a -t fstype device>.

=head2 fstrim

 fstrim mountpoint [offset:N] [length:N] [minimumfreeextent:N]

Trim the free space in the filesystem mounted on C<mountpoint>.
The filesystem must be mounted read-write.

The filesystem contents are not affected, but any free space
in the filesystem is "trimmed", that is, given back to the host
device, thus making disk images more sparse, allowing unused space
in qcow2 files to be reused, etc.

This operation requires support in libguestfs, the mounted
filesystem, the host filesystem, qemu and the host kernel.
If this support isn't present it may give an error or even
appear to run but do nothing.

In the case where the kernel vfs driver does not support
trimming, this call will fail with errno set to C<ENOTSUP>.
Currently this happens when trying to trim FAT filesystems.

See also L</zero-free-space>.  That is a slightly
different operation that turns free space in the filesystem
into zeroes.  It is valid to call L</fstrim> either
instead of, or after calling L</zero-free-space>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<fstrim>.   See also
L</feature-available>.

=head2 get-append

 get-append

Return the additional kernel options which are added to the
libguestfs appliance kernel command line.

If C<NULL> then no options are added.

=head2 get-attach-method

 get-attach-method

Return the current backend.

See L</set-backend> and L<guestfs(3)/BACKEND>.

I<This function is deprecated.>
In new code, use the L</get-backend> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 get-autosync

 get-autosync

Get the autosync flag.

=head2 get-backend

 get-backend

Return the current backend.

This handle property was previously called the "attach method".

See L</set-backend> and L<guestfs(3)/BACKEND>.

=head2 get-backend-setting

 get-backend-setting name

Find a backend setting string which is either C<"name"> or
begins with C<"name=">.  If C<"name">, this returns the
string C<"1">.  If C<"name=">, this returns the part
after the equals sign (which may be an empty string).

If no such setting is found, this function throws an error.
The errno (see L</last-errno>) will be C<ESRCH> in this
case.

See L<guestfs(3)/BACKEND>, L<guestfs(3)/BACKEND SETTINGS>.

=head2 get-backend-settings

 get-backend-settings

Return the current backend settings.

This call returns all backend settings strings.  If you want to
find a single backend setting, see L</get-backend-setting>.

See L<guestfs(3)/BACKEND>, L<guestfs(3)/BACKEND SETTINGS>.

=head2 get-cachedir

 get-cachedir

Get the directory used by the handle to store the appliance cache.

=head2 get-direct

 get-direct

Return the direct appliance mode flag.

I<This function is deprecated.>
In new code, use the L</internal-get-console-socket> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 get-e2attrs

 get-e2attrs file

This returns the file attributes associated with F<file>.

The attributes are a set of bits associated with each
inode which affect the behaviour of the file.  The attributes
are returned as a string of letters (described below).  The
string may be empty, indicating that no file attributes are
set for this file.

These attributes are only present when the file is located on
an ext2/3/4 filesystem.  Using this call on other filesystem
types will result in an error.

The characters (file attributes) in the returned string are
currently:

=over 4

=item 'A'

When the file is accessed, its atime is not modified.

=item 'a'

The file is append-only.

=item 'c'

The file is compressed on-disk.

=item 'D'

(Directories only.)  Changes to this directory are written
synchronously to disk.

=item 'd'

The file is not a candidate for backup (see L<dump(8)>).

=item 'E'

The file has compression errors.

=item 'e'

The file is using extents.

=item 'h'

The file is storing its blocks in units of the filesystem blocksize
instead of sectors.

=item 'I'

(Directories only.)  The directory is using hashed trees.

=item 'i'

The file is immutable.  It cannot be modified, deleted or renamed.
No link can be created to this file.

=item 'j'

The file is data-journaled.

=item 's'

When the file is deleted, all its blocks will be zeroed.

=item 'S'

Changes to this file are written synchronously to disk.

=item 'T'

(Directories only.)  This is a hint to the block allocator
that subdirectories contained in this directory should be
spread across blocks.  If not present, the block allocator
will try to group subdirectories together.

=item 't'

For a file, this disables tail-merging.
(Not used by upstream implementations of ext2.)

=item 'u'

When the file is deleted, its blocks will be saved, allowing
the file to be undeleted.

=item 'X'

The raw contents of the compressed file may be accessed.

=item 'Z'

The compressed file is dirty.

=back

More file attributes may be added to this list later.  Not all
file attributes may be set for all kinds of files.  For
detailed information, consult the L<chattr(1)> man page.

See also L</set-e2attrs>.

Don't confuse these attributes with extended attributes
(see L</getxattr>).

=head2 get-e2generation

 get-e2generation file

This returns the ext2 file generation of a file.  The generation
(which used to be called the "version") is a number associated
with an inode.  This is most commonly used by NFS servers.

The generation is only present when the file is located on
an ext2/3/4 filesystem.  Using this call on other filesystem
types will result in an error.

See L</set-e2generation>.

=head2 get-e2label

 get-e2label device

This returns the ext2/3/4 filesystem label of the filesystem on
C<device>.

I<This function is deprecated.>
In new code, use the L</vfs-label> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 get-e2uuid

 get-e2uuid device

This returns the ext2/3/4 filesystem UUID of the filesystem on
C<device>.

I<This function is deprecated.>
In new code, use the L</vfs-uuid> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 get-hv

 get-hv

Return the current hypervisor binary.

This is always non-NULL.  If it wasn't set already, then this will
return the default qemu binary name.

=head2 get-identifier

 get-identifier

Get the handle identifier.  See L</set-identifier>.

=head2 get-libvirt-requested-credential-challenge

 get-libvirt-requested-credential-challenge index

Get the challenge (provided by libvirt) for the C<index>'th
requested credential.  If libvirt did not provide a challenge,
this returns the empty string C<"">.

See L<guestfs(3)/LIBVIRT AUTHENTICATION> for documentation and example code.

=head2 get-libvirt-requested-credential-defresult

 get-libvirt-requested-credential-defresult index

Get the default result (provided by libvirt) for the C<index>'th
requested credential.  If libvirt did not provide a default result,
this returns the empty string C<"">.

See L<guestfs(3)/LIBVIRT AUTHENTICATION> for documentation and example code.

=head2 get-libvirt-requested-credential-prompt

 get-libvirt-requested-credential-prompt index

Get the prompt (provided by libvirt) for the C<index>'th
requested credential.  If libvirt did not provide a prompt,
this returns the empty string C<"">.

See L<guestfs(3)/LIBVIRT AUTHENTICATION> for documentation and example code.

=head2 get-libvirt-requested-credentials

 get-libvirt-requested-credentials

This should only be called during the event callback
for events of type C<GUESTFS_EVENT_LIBVIRT_AUTH>.

Return the list of credentials requested by libvirt.  Possible
values are a subset of the strings provided when you called
L</set-libvirt-supported-credentials>.

See L<guestfs(3)/LIBVIRT AUTHENTICATION> for documentation and example code.

=head2 get-memsize

 get-memsize

This gets the memory size in megabytes allocated to the
hypervisor.

If L</set-memsize> was not called
on this handle, and if C<LIBGUESTFS_MEMSIZE> was not set,
then this returns the compiled-in default value for memsize.

For more information on the architecture of libguestfs,
see L<guestfs(3)>.

=head2 get-network

 get-network

This returns the enable network flag.

=head2 get-path

 get-path

Return the current search path.

This is always non-NULL.  If it wasn't set already, then this will
return the default path.

=head2 get-pgroup

 get-pgroup

This returns the process group flag.

=head2 get-pid

=head2 pid

 get-pid

Return the process ID of the hypervisor.  If there is no
hypervisor running, then this will return an error.

This is an internal call used for debugging and testing.

=head2 get-program

 get-program

Get the program name.  See L</set-program>.

=head2 get-qemu

 get-qemu

Return the current hypervisor binary (usually qemu).

This is always non-NULL.  If it wasn't set already, then this will
return the default qemu binary name.

I<This function is deprecated.>
In new code, use the L</get-hv> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 get-recovery-proc

 get-recovery-proc

Return the recovery process enabled flag.

=head2 get-selinux

 get-selinux

This returns the current setting of the selinux flag which
is passed to the appliance at boot time.  See L</set-selinux>.

For more information on the architecture of libguestfs,
see L<guestfs(3)>.

I<This function is deprecated.>
In new code, use the L</selinux-relabel> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 get-smp

 get-smp

This returns the number of virtual CPUs assigned to the appliance.

=head2 get-sockdir

 get-sockdir

Get the directory used by the handle to store temporary socket files.

This is different from L</get-tmpdir>, as we need shorter
paths for sockets (due to the limited buffers of filenames for UNIX
sockets), and L</get-tmpdir> may be too long for them.

The environment variable C<XDG_RUNTIME_DIR> controls the default
value: If C<XDG_RUNTIME_DIR> is set, then that is the default.
Else F</tmp> is the default.

=head2 get-tmpdir

 get-tmpdir

Get the directory used by the handle to store temporary files.

=head2 get-trace

 get-trace

Return the command trace flag.

=head2 get-umask

 get-umask

Return the current umask.  By default the umask is C<022>
unless it has been set by calling L</umask>.

=head2 get-verbose

 get-verbose

This returns the verbose messages flag.

=head2 getcon

 getcon

This gets the SELinux security context of the daemon.

See the documentation about SELINUX in L<guestfs(3)>,
and L</setcon>

I<This function is deprecated.>
In new code, use the L</selinux-relabel> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<selinux>.   See also
L</feature-available>.

=head2 getxattr

 getxattr path name

Get a single extended attribute from file C<path> named C<name>.
This call follows symlinks.  If you want to lookup an extended
attribute for the symlink itself, use L</lgetxattr>.

Normally it is better to get all extended attributes from a file
in one go by calling L</getxattrs>.  However some Linux
filesystem implementations are buggy and do not provide a way to
list out attributes.  For these filesystems (notably ntfs-3g)
you have to know the names of the extended attributes you want
in advance and call this function.

Extended attribute values are blobs of binary data.  If there
is no extended attribute named C<name>, this returns an error.

See also: L</getxattrs>, L</lgetxattr>, L<attr(5)>.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 getxattrs

 getxattrs path

This call lists the extended attributes of the file or directory
C<path>.

At the system call level, this is a combination of the
L<listxattr(2)> and L<getxattr(2)> calls.

See also: L</lgetxattrs>, L<attr(5)>.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 glob-expand

=head2 glob-expand-opts

 glob-expand pattern [directoryslash:true|false]

This command searches for all the pathnames matching
C<pattern> according to the wildcard expansion rules
used by the shell.

If no paths match, then this returns an empty list
(note: not an error).

It is just a wrapper around the C L<glob(3)> function
with flags C<GLOB_MARK|GLOB_BRACE>.
See that manual page for more details.

C<directoryslash> controls whether use the C<GLOB_MARK> flag for
L<glob(3)>, and it defaults to true.  It can be explicitly set as
off to return no trailing slashes in filenames of directories.

Notice that there is no equivalent command for expanding a device
name (eg. F</dev/sd*>).  Use L</list-devices>,
L</list-partitions> etc functions instead.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 grep

=head2 grep-opts

 grep regex path [extended:true|false] [fixed:true|false] [insensitive:true|false] [compressed:true|false]

This calls the external L<grep(1)> program and returns the
matching lines.

The optional flags are:

=over 4

=item C<extended>

Use extended regular expressions.
This is the same as using the I<-E> flag.

=item C<fixed>

Match fixed (don't use regular expressions).
This is the same as using the I<-F> flag.

=item C<insensitive>

Match case-insensitive.  This is the same as using the I<-i> flag.

=item C<compressed>

Use L<zgrep(1)> instead of L<grep(1)>.  This allows the input to be
compress- or gzip-compressed.

=back

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 grepi

 grepi regex path

This calls the external C<grep -i> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 grub-install

 grub-install root device

This command installs GRUB 1 (the Grand Unified Bootloader) on
C<device>, with the root directory being C<root>.

Notes:

=over 4

=item *

There is currently no way in the API to install grub2, which
is used by most modern Linux guests.  It is possible to run
the grub2 command from the guest, although see the
caveats in L<guestfs(3)/RUNNING COMMANDS>.

=item *

This uses L<grub-install(8)> from the host.  Unfortunately grub is
not always compatible with itself, so this only works in rather
narrow circumstances.  Careful testing with each guest version
is advisable.

=item *

If grub-install reports the error
"No suitable drive was found in the generated device map."
it may be that you need to create a F</boot/grub/device.map>
file first that contains the mapping between grub device names
and Linux device names.  It is usually sufficient to create
a file containing:

 (hd0) /dev/vda

replacing F</dev/vda> with the name of the installation device.

=back

This command depends on the feature C<grub>.   See also
L</feature-available>.

=head2 head

 head path

This command returns up to the first 10 lines of a file as
a list of strings.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 head-n

 head-n nrlines path

If the parameter C<nrlines> is a positive number, this returns the first
C<nrlines> lines of the file C<path>.

If the parameter C<nrlines> is a negative number, this returns lines
from the file C<path>, excluding the last C<nrlines> lines.

If the parameter C<nrlines> is zero, this returns an empty list.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 hexdump

 hexdump path

This runs C<hexdump -C> on the given C<path>.  The result is
the human-readable, canonical hex dump of the file.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 hivex-close

 hivex-close

Close the current hivex handle.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-commit

 hivex-commit filename

Commit (write) changes to the hive.

If the optional F<filename> parameter is null, then the changes
are written back to the same hive that was opened.  If this is
not null then they are written to the alternate filename given
and the original hive is left untouched.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-add-child

 hivex-node-add-child parent name

Add a child node to C<parent> named C<name>.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-children

 hivex-node-children nodeh

Return the list of nodes which are subkeys of C<nodeh>.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-delete-child

 hivex-node-delete-child nodeh

Delete C<nodeh>, recursively if necessary.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-get-child

 hivex-node-get-child nodeh name

Return the child of C<nodeh> with the name C<name>, if it exists.
This can return C<0> meaning the name was not found.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-get-value

 hivex-node-get-value nodeh key

Return the value attached to C<nodeh> which has the
name C<key>, if it exists.  This can return C<0> meaning
the key was not found.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-name

 hivex-node-name nodeh

Return the name of C<nodeh>.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-parent

 hivex-node-parent nodeh

Return the parent node of C<nodeh>.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-set-value

 hivex-node-set-value nodeh key t val

Set or replace a single value under the node C<nodeh>.  The
C<key> is the name, C<t> is the type, and C<val> is the data.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-node-values

 hivex-node-values nodeh

Return the array of (key, datatype, data) tuples attached to C<nodeh>.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-open

 hivex-open filename [verbose:true|false] [debug:true|false] [write:true|false] [unsafe:true|false]

Open the Windows Registry hive file named F<filename>.
If there was any previous hivex handle associated with this
guestfs session, then it is closed.

This is a wrapper around the L<hivex(3)> call of the same name.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-root

 hivex-root

Return the root node of the hive.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-value-key

 hivex-value-key valueh

Return the key (name) field of a (key, datatype, data) tuple.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-value-string

 hivex-value-string valueh

This calls L</hivex-value-value> (which returns the
data field from a hivex value tuple).  It then assumes that
the field is a UTF-16LE string and converts the result to
UTF-8 (or if this is not possible, it returns an error).

This is useful for reading strings out of the Windows registry.
However it is not foolproof because the registry is not
strongly-typed and fields can contain arbitrary or unexpected
data.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-value-type

 hivex-value-type valueh

Return the data type field from a (key, datatype, data) tuple.

This is a wrapper around the L<hivex(3)> call of the same name.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-value-utf8

 hivex-value-utf8 valueh

This calls L</hivex-value-value> (which returns the
data field from a hivex value tuple).  It then assumes that
the field is a UTF-16LE string and converts the result to
UTF-8 (or if this is not possible, it returns an error).

This is useful for reading strings out of the Windows registry.
However it is not foolproof because the registry is not
strongly-typed and fields can contain arbitrary or unexpected
data.

I<This function is deprecated.>
In new code, use the L</hivex-value-string> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 hivex-value-value

 hivex-value-value valueh

Return the data field of a (key, datatype, data) tuple.

This is a wrapper around the L<hivex(3)> call of the same name.

See also: L</hivex-value-utf8>.

This command depends on the feature C<hivex>.   See also
L</feature-available>.

=head2 initrd-cat

 initrd-cat initrdpath filename

This command unpacks the file F<filename> from the initrd file
called F<initrdpath>.  The filename must be given I<without> the
initial F</> character.

For example, in guestfish you could use the following command
to examine the boot script (usually called F</init>)
contained in a Linux initrd or initramfs image:

 initrd-cat /boot/initrd-<version>.img init

See also L</initrd-list>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 initrd-list

 initrd-list path

This command lists out files contained in an initrd.

The files are listed without any initial F</> character.  The
files are listed in the order they appear (not necessarily
alphabetical).  Directory names are listed as separate items.

Old Linux kernels (2.4 and earlier) used a compressed ext2
filesystem as initrd.  We I<only> support the newer initramfs
format (compressed cpio files).

=head2 inotify-add-watch

 inotify-add-watch path mask

Watch C<path> for the events listed in C<mask>.

Note that if C<path> is a directory then events within that
directory are watched, but this does I<not> happen recursively
(in subdirectories).

Note for non-C or non-Linux callers: the inotify events are
defined by the Linux kernel ABI and are listed in
F</usr/include/sys/inotify.h>.

This command depends on the feature C<inotify>.   See also
L</feature-available>.

=head2 inotify-close

 inotify-close

This closes the inotify handle which was previously
opened by inotify_init.  It removes all watches, throws
away any pending events, and deallocates all resources.

This command depends on the feature C<inotify>.   See also
L</feature-available>.

=head2 inotify-files

 inotify-files

This function is a helpful wrapper around L</inotify-read>
which just returns a list of pathnames of objects that were
touched.  The returned pathnames are sorted and deduplicated.

This command depends on the feature C<inotify>.   See also
L</feature-available>.

=head2 inotify-init

 inotify-init maxevents

This command creates a new inotify handle.
The inotify subsystem can be used to notify events which happen to
objects in the guest filesystem.

C<maxevents> is the maximum number of events which will be
queued up between calls to L</inotify-read> or
L</inotify-files>.
If this is passed as C<0>, then the kernel (or previously set)
default is used.  For Linux 2.6.29 the default was 16384 events.
Beyond this limit, the kernel throws away events, but records
the fact that it threw them away by setting a flag
C<IN_Q_OVERFLOW> in the returned structure list (see
L</inotify-read>).

Before any events are generated, you have to add some
watches to the internal watch list.  See: L</inotify-add-watch> and
L</inotify-rm-watch>.

Queued up events should be read periodically by calling
L</inotify-read>
(or L</inotify-files> which is just a helpful
wrapper around L</inotify-read>).  If you don't
read the events out often enough then you risk the internal
queue overflowing.

The handle should be closed after use by calling
L</inotify-close>.  This also removes any
watches automatically.

See also L<inotify(7)> for an overview of the inotify interface
as exposed by the Linux kernel, which is roughly what we expose
via libguestfs.  Note that there is one global inotify handle
per libguestfs instance.

This command depends on the feature C<inotify>.   See also
L</feature-available>.

=head2 inotify-read

 inotify-read

Return the complete queue of events that have happened
since the previous read call.

If no events have happened, this returns an empty list.

I<Note>: In order to make sure that all events have been
read, you must call this function repeatedly until it
returns an empty list.  The reason is that the call will
read events up to the maximum appliance-to-host message
size and leave remaining events in the queue.

This command depends on the feature C<inotify>.   See also
L</feature-available>.

=head2 inotify-rm-watch

 inotify-rm-watch wd

Remove a previously defined inotify watch.
See L</inotify-add-watch>.

This command depends on the feature C<inotify>.   See also
L</feature-available>.

=head2 inspect-get-arch

 inspect-get-arch root

This returns the architecture of the inspected operating system.
The possible return values are listed under
L</file-architecture>.

If the architecture could not be determined, then the
string C<unknown> is returned.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-distro

 inspect-get-distro root

This returns the distro (distribution) of the inspected operating
system.

Currently defined distros are:

=over 4

=item "alpinelinux"

Alpine Linux.

=item "altlinux"

ALT Linux.

=item "archlinux"

Arch Linux.

=item "buildroot"

Buildroot-derived distro, but not one we specifically recognize.

=item "centos"

CentOS.

=item "cirros"

Cirros.

=item "coreos"

CoreOS.

=item "debian"

Debian.

=item "fedora"

Fedora.

=item "freebsd"

FreeBSD.

=item "freedos"

FreeDOS.

=item "frugalware"

Frugalware.

=item "gentoo"

Gentoo.

=item "kalilinux"

Kali Linux.

=item "linuxmint"

Linux Mint.

=item "mageia"

Mageia.

=item "mandriva"

Mandriva.

=item "meego"

MeeGo.

=item "msdos"

Microsoft DOS.

=item "neokylin"

NeoKylin.

=item "netbsd"

NetBSD.

=item "openbsd"

OpenBSD.

=item "openmandriva"

OpenMandriva Lx.

=item "opensuse"

OpenSUSE.

=item "oraclelinux"

Oracle Linux.

=item "pardus"

Pardus.

=item "pldlinux"

PLD Linux.

=item "redhat-based"

Some Red Hat-derived distro.

=item "rhel"

Red Hat Enterprise Linux.

=item "scientificlinux"

Scientific Linux.

=item "slackware"

Slackware.

=item "sles"

SuSE Linux Enterprise Server or Desktop.

=item "suse-based"

Some openSuSE-derived distro.

=item "ttylinux"

ttylinux.

=item "ubuntu"

Ubuntu.

=item "unknown"

The distro could not be determined.

=item "voidlinux"

Void Linux.

=item "windows"

Windows does not have distributions.  This string is
returned if the OS type is Windows.

=back

Future versions of libguestfs may return other strings here.
The caller should be prepared to handle any string.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-drive-mappings

 inspect-get-drive-mappings root

This call is useful for Windows which uses a primitive system
of assigning drive letters (like F<C:\>) to partitions.
This inspection API examines the Windows Registry to find out
how disks/partitions are mapped to drive letters, and returns
a hash table as in the example below:

 C      =>     /dev/vda2
 E      =>     /dev/vdb1
 F      =>     /dev/vdc1

Note that keys are drive letters.  For Windows, the key is
case insensitive and just contains the drive letter, without
the customary colon separator character.

In future we may support other operating systems that also used drive
letters, but the keys for those might not be case insensitive
and might be longer than 1 character.  For example in OS-9,
hard drives were named C<h0>, C<h1> etc.

For Windows guests, currently only hard drive mappings are
returned.  Removable disks (eg. DVD-ROMs) are ignored.

For guests that do not use drive mappings, or if the drive mappings
could not be determined, this returns an empty hash table.

Please read L<guestfs(3)/INSPECTION> for more details.
See also L</inspect-get-mountpoints>,
L</inspect-get-filesystems>.

=head2 inspect-get-filesystems

 inspect-get-filesystems root

This returns a list of all the filesystems that we think
are associated with this operating system.  This includes
the root filesystem, other ordinary filesystems, and
non-mounted devices like swap partitions.

In the case of a multi-boot virtual machine, it is possible
for a filesystem to be shared between operating systems.

Please read L<guestfs(3)/INSPECTION> for more details.
See also L</inspect-get-mountpoints>.

=head2 inspect-get-format

 inspect-get-format root

Before libguestfs 1.38, there was some unreliable support for detecting
installer CDs.  This API would return:

=over 4

=item C<installed>

This is an installed operating system.

=item C<installer>

The disk image being inspected is not an installed operating system,
but a I<bootable> install disk, live CD, or similar.

=item C<unknown>

The format of this disk image is not known.

=back

In libguestfs E<ge> 1.38, this only returns C<installed>.
Use libosinfo directly to detect installer CDs.

Please read L<guestfs(3)/INSPECTION> for more details.

I<This function is deprecated.>
There is no replacement.  Consult the API documentation in
L<guestfs(3)> for further information.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 inspect-get-hostname

 inspect-get-hostname root

This function returns the hostname of the operating system
as found by inspection of the guest’s configuration files.

If the hostname could not be determined, then the
string C<unknown> is returned.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-icon

 inspect-get-icon root [favicon:true|false] [highquality:true|false]

This function returns an icon corresponding to the inspected
operating system.  The icon is returned as a buffer containing a
PNG image (re-encoded to PNG if necessary).

If it was not possible to get an icon this function returns a
zero-length (non-NULL) buffer.  I<Callers must check for this case>.

Libguestfs will start by looking for a file called
F</etc/favicon.png> or F<C:\etc\favicon.png>
and if it has the correct format, the contents of this file will
be returned.  You can disable favicons by passing the
optional C<favicon> boolean as false (default is true).

If finding the favicon fails, then we look in other places in the
guest for a suitable icon.

If the optional C<highquality> boolean is true then
only high quality icons are returned, which means only icons of
high resolution with an alpha channel.  The default (false) is
to return any icon we can, even if it is of substandard quality.

Notes:

=over 4

=item *

Unlike most other inspection API calls, the guest’s disks must be
mounted up before you call this, since it needs to read information
from the guest filesystem during the call.

=item *

B<Security:> The icon data comes from the untrusted guest,
and should be treated with caution.  PNG files have been
known to contain exploits.  Ensure that libpng (or other relevant
libraries) are fully up to date before trying to process or
display the icon.

=item *

The PNG image returned can be any size.  It might not be square.
Libguestfs tries to return the largest, highest quality
icon available.  The application must scale the icon to the
required size.

=item *

Extracting icons from Windows guests requires the external
L<wrestool(1)> program from the C<icoutils> package, and
several programs (L<bmptopnm(1)>, L<pnmtopng(1)>, L<pamcut(1)>)
from the C<netpbm> package.  These must be installed separately.

=item *

Operating system icons are usually trademarks.  Seek legal
advice before using trademarks in applications.

=back

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 inspect-get-major-version

 inspect-get-major-version root

This returns the major version number of the inspected operating
system.

Windows uses a consistent versioning scheme which is I<not>
reflected in the popular public names used by the operating system.
Notably the operating system known as "Windows 7" is really
version 6.1 (ie. major = 6, minor = 1).  You can find out the
real versions corresponding to releases of Windows by consulting
Wikipedia or MSDN.

If the version could not be determined, then C<0> is returned.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-minor-version

 inspect-get-minor-version root

This returns the minor version number of the inspected operating
system.

If the version could not be determined, then C<0> is returned.

Please read L<guestfs(3)/INSPECTION> for more details.
See also L</inspect-get-major-version>.

=head2 inspect-get-mountpoints

 inspect-get-mountpoints root

This returns a hash of where we think the filesystems
associated with this operating system should be mounted.
Callers should note that this is at best an educated guess
made by reading configuration files such as F</etc/fstab>.
I<In particular note> that this may return filesystems
which are non-existent or not mountable and callers should
be prepared to handle or ignore failures if they try to
mount them.

Each element in the returned hashtable has a key which
is the path of the mountpoint (eg. F</boot>) and a value
which is the filesystem that would be mounted there
(eg. F</dev/sda1>).

Non-mounted devices such as swap devices are I<not>
returned in this list.

For operating systems like Windows which still use drive
letters, this call will only return an entry for the first
drive "mounted on" F</>.  For information about the
mapping of drive letters to partitions, see
L</inspect-get-drive-mappings>.

Please read L<guestfs(3)/INSPECTION> for more details.
See also L</inspect-get-filesystems>.

=head2 inspect-get-osinfo

 inspect-get-osinfo root

This function returns a possible short ID for libosinfo corresponding
to the guest.

I<Note:> The returned ID is only a guess by libguestfs, and nothing
ensures that it actually exists in osinfo-db.

If no ID could not be determined, then the string C<unknown> is
returned.

=head2 inspect-get-package-format

 inspect-get-package-format root

This function and L</inspect-get-package-management> return
the package format and package management tool used by the
inspected operating system.  For example for Fedora these
functions would return C<rpm> (package format), and
C<yum> or C<dnf> (package management).

This returns the string C<unknown> if we could not determine the
package format I<or> if the operating system does not have
a real packaging system (eg. Windows).

Possible strings include:
C<rpm>, C<deb>, C<ebuild>, C<pisi>, C<pacman>, C<pkgsrc>, C<apk>,
C<xbps>.
Future versions of libguestfs may return other strings.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-package-management

 inspect-get-package-management root

L</inspect-get-package-format> and this function return
the package format and package management tool used by the
inspected operating system.  For example for Fedora these
functions would return C<rpm> (package format), and
C<yum> or C<dnf> (package management).

This returns the string C<unknown> if we could not determine the
package management tool I<or> if the operating system does not have
a real packaging system (eg. Windows).

Possible strings include: C<yum>, C<dnf>, C<up2date>,
C<apt> (for all Debian derivatives),
C<portage>, C<pisi>, C<pacman>, C<urpmi>, C<zypper>, C<apk>, C<xbps>.
Future versions of libguestfs may return other strings.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-product-name

 inspect-get-product-name root

This returns the product name of the inspected operating
system.  The product name is generally some freeform string
which can be displayed to the user, but should not be
parsed by programs.

If the product name could not be determined, then the
string C<unknown> is returned.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-product-variant

 inspect-get-product-variant root

This returns the product variant of the inspected operating
system.

For Windows guests, this returns the contents of the Registry key
C<HKLM\Software\Microsoft\Windows NT\CurrentVersion>
C<InstallationType> which is usually a string such as
C<Client> or C<Server> (other values are possible).  This
can be used to distinguish consumer and enterprise versions
of Windows that have the same version number (for example,
Windows 7 and Windows 2008 Server are both version 6.1,
but the former is C<Client> and the latter is C<Server>).

For enterprise Linux guests, in future we intend this to return
the product variant such as C<Desktop>, C<Server> and so on.  But
this is not implemented at present.

If the product variant could not be determined, then the
string C<unknown> is returned.

Please read L<guestfs(3)/INSPECTION> for more details.
See also L</inspect-get-product-name>,
L</inspect-get-major-version>.

=head2 inspect-get-roots

 inspect-get-roots

This function is a convenient way to get the list of root
devices, as returned from a previous call to L</inspect-os>,
but without redoing the whole inspection process.

This returns an empty list if either no root devices were
found or the caller has not called L</inspect-os>.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-type

 inspect-get-type root

This returns the type of the inspected operating system.
Currently defined types are:

=over 4

=item "linux"

Any Linux-based operating system.

=item "windows"

Any Microsoft Windows operating system.

=item "freebsd"

FreeBSD.

=item "netbsd"

NetBSD.

=item "openbsd"

OpenBSD.

=item "hurd"

GNU/Hurd.

=item "dos"

MS-DOS, FreeDOS and others.

=item "minix"

MINIX.

=item "unknown"

The operating system type could not be determined.

=back

Future versions of libguestfs may return other strings here.
The caller should be prepared to handle any string.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-windows-current-control-set

 inspect-get-windows-current-control-set root

This returns the Windows CurrentControlSet of the inspected guest.
The CurrentControlSet is a registry key name such as C<ControlSet001>.

This call assumes that the guest is Windows and that the
Registry could be examined by inspection.  If this is not
the case then an error is returned.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-windows-software-hive

 inspect-get-windows-software-hive root

This returns the path to the hive (binary Windows Registry file)
corresponding to HKLM\SOFTWARE.

This call assumes that the guest is Windows and that the guest
has a software hive file with the right name.  If this is not the
case then an error is returned.  This call does not check that the
hive is a valid Windows Registry hive.

You can use L</hivex-open> to read or write to the hive.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-windows-system-hive

 inspect-get-windows-system-hive root

This returns the path to the hive (binary Windows Registry file)
corresponding to HKLM\SYSTEM.

This call assumes that the guest is Windows and that the guest
has a system hive file with the right name.  If this is not the
case then an error is returned.  This call does not check that the
hive is a valid Windows Registry hive.

You can use L</hivex-open> to read or write to the hive.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-get-windows-systemroot

 inspect-get-windows-systemroot root

This returns the Windows systemroot of the inspected guest.
The systemroot is a directory path such as F</WINDOWS>.

This call assumes that the guest is Windows and that the
systemroot could be determined by inspection.  If this is not
the case then an error is returned.

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-is-live

 inspect-is-live root

This is deprecated and always returns C<false>.

Please read L<guestfs(3)/INSPECTION> for more details.

I<This function is deprecated.>
There is no replacement.  Consult the API documentation in
L<guestfs(3)> for further information.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 inspect-is-multipart

 inspect-is-multipart root

This is deprecated and always returns C<false>.

Please read L<guestfs(3)/INSPECTION> for more details.

I<This function is deprecated.>
There is no replacement.  Consult the API documentation in
L<guestfs(3)> for further information.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 inspect-is-netinst

 inspect-is-netinst root

This is deprecated and always returns C<false>.

Please read L<guestfs(3)/INSPECTION> for more details.

I<This function is deprecated.>
There is no replacement.  Consult the API documentation in
L<guestfs(3)> for further information.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 inspect-list-applications

 inspect-list-applications root

Return the list of applications installed in the operating system.

I<Note:> This call works differently from other parts of the
inspection API.  You have to call L</inspect-os>, then
L</inspect-get-mountpoints>, then mount up the disks,
before calling this.  Listing applications is a significantly
more difficult operation which requires access to the full
filesystem.  Also note that unlike the other
L</inspect-get-*> calls which are just returning
data cached in the libguestfs handle, this call actually reads
parts of the mounted filesystems during the call.

This returns an empty list if the inspection code was not able
to determine the list of applications.

The application structure contains the following fields:

=over 4

=item C<app_name>

The name of the application.  For Linux guests, this is the package
name.

=item C<app_display_name>

The display name of the application, sometimes localized to the
install language of the guest operating system.

If unavailable this is returned as an empty string C<"">.
Callers needing to display something can use C<app_name> instead.

=item C<app_epoch>

For package managers which use epochs, this contains the epoch of
the package (an integer).  If unavailable, this is returned as C<0>.

=item C<app_version>

The version string of the application or package.  If unavailable
this is returned as an empty string C<"">.

=item C<app_release>

The release string of the application or package, for package
managers that use this.  If unavailable this is returned as an
empty string C<"">.

=item C<app_install_path>

The installation path of the application (on operating systems
such as Windows which use installation paths).  This path is
in the format used by the guest operating system, it is not
a libguestfs path.

If unavailable this is returned as an empty string C<"">.

=item C<app_trans_path>

The install path translated into a libguestfs path.
If unavailable this is returned as an empty string C<"">.

=item C<app_publisher>

The name of the publisher of the application, for package
managers that use this.  If unavailable this is returned
as an empty string C<"">.

=item C<app_url>

The URL (eg. upstream URL) of the application.
If unavailable this is returned as an empty string C<"">.

=item C<app_source_package>

For packaging systems which support this, the name of the source
package.  If unavailable this is returned as an empty string C<"">.

=item C<app_summary>

A short (usually one line) description of the application or package.
If unavailable this is returned as an empty string C<"">.

=item C<app_description>

A longer description of the application or package.
If unavailable this is returned as an empty string C<"">.

=back

Please read L<guestfs(3)/INSPECTION> for more details.

I<This function is deprecated.>
In new code, use the L</inspect-list-applications2> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 inspect-list-applications2

 inspect-list-applications2 root

Return the list of applications installed in the operating system.

I<Note:> This call works differently from other parts of the
inspection API.  You have to call L</inspect-os>, then
L</inspect-get-mountpoints>, then mount up the disks,
before calling this.  Listing applications is a significantly
more difficult operation which requires access to the full
filesystem.  Also note that unlike the other
L</inspect-get-*> calls which are just returning
data cached in the libguestfs handle, this call actually reads
parts of the mounted filesystems during the call.

This returns an empty list if the inspection code was not able
to determine the list of applications.

The application structure contains the following fields:

=over 4

=item C<app2_name>

The name of the application.  For Linux guests, this is the package
name.

=item C<app2_display_name>

The display name of the application, sometimes localized to the
install language of the guest operating system.

If unavailable this is returned as an empty string C<"">.
Callers needing to display something can use C<app2_name> instead.

=item C<app2_epoch>

For package managers which use epochs, this contains the epoch of
the package (an integer).  If unavailable, this is returned as C<0>.

=item C<app2_version>

The version string of the application or package.  If unavailable
this is returned as an empty string C<"">.

=item C<app2_release>

The release string of the application or package, for package
managers that use this.  If unavailable this is returned as an
empty string C<"">.

=item C<app2_arch>

The architecture string of the application or package, for package
managers that use this.  If unavailable this is returned as an empty
string C<"">.

=item C<app2_install_path>

The installation path of the application (on operating systems
such as Windows which use installation paths).  This path is
in the format used by the guest operating system, it is not
a libguestfs path.

If unavailable this is returned as an empty string C<"">.

=item C<app2_trans_path>

The install path translated into a libguestfs path.
If unavailable this is returned as an empty string C<"">.

=item C<app2_publisher>

The name of the publisher of the application, for package
managers that use this.  If unavailable this is returned
as an empty string C<"">.

=item C<app2_url>

The URL (eg. upstream URL) of the application.
If unavailable this is returned as an empty string C<"">.

=item C<app2_source_package>

For packaging systems which support this, the name of the source
package.  If unavailable this is returned as an empty string C<"">.

=item C<app2_summary>

A short (usually one line) description of the application or package.
If unavailable this is returned as an empty string C<"">.

=item C<app2_description>

A longer description of the application or package.
If unavailable this is returned as an empty string C<"">.

=back

Please read L<guestfs(3)/INSPECTION> for more details.

=head2 inspect-os

 inspect-os

This function uses other libguestfs functions and certain
heuristics to inspect the disk(s) (usually disks belonging to
a virtual machine), looking for operating systems.

The list returned is empty if no operating systems were found.

If one operating system was found, then this returns a list with
a single element, which is the name of the root filesystem of
this operating system.  It is also possible for this function
to return a list containing more than one element, indicating
a dual-boot or multi-boot virtual machine, with each element being
the root filesystem of one of the operating systems.

You can pass the root string(s) returned to other
L</inspect-get-*> functions in order to query further
information about each operating system, such as the name
and version.

This function uses other libguestfs features such as
L</mount-ro> and L</umount-all> in order to mount
and unmount filesystems and look at the contents.  This should
be called with no disks currently mounted.  The function may also
use Augeas, so any existing Augeas handle will be closed.

This function cannot decrypt encrypted disks.  The caller
must do that first (supplying the necessary keys) if the
disk is encrypted.

Please read L<guestfs(3)/INSPECTION> for more details.

See also L</list-filesystems>.

=head2 is-blockdev

=head2 is-blockdev-opts

 is-blockdev path [followsymlinks:true|false]

This returns C<true> if and only if there is a block device
with the given C<path> name.

If the optional flag C<followsymlinks> is true, then a symlink
(or chain of symlinks) that ends with a block device also causes the
function to return true.

This call only looks at files within the guest filesystem.  Libguestfs
partitions and block devices (eg. F</dev/sda>) cannot be used as the
C<path> parameter of this call.

See also L</stat>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 is-chardev

=head2 is-chardev-opts

 is-chardev path [followsymlinks:true|false]

This returns C<true> if and only if there is a character device
with the given C<path> name.

If the optional flag C<followsymlinks> is true, then a symlink
(or chain of symlinks) that ends with a chardev also causes the
function to return true.

See also L</stat>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 is-config

 is-config

This returns true iff this handle is being configured
(in the C<CONFIG> state).

For more information on states, see L<guestfs(3)>.

=head2 is-dir

=head2 is-dir-opts

 is-dir path [followsymlinks:true|false]

This returns C<true> if and only if there is a directory
with the given C<path> name.  Note that it returns false for
other objects like files.

If the optional flag C<followsymlinks> is true, then a symlink
(or chain of symlinks) that ends with a directory also causes the
function to return true.

See also L</stat>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 is-fifo

=head2 is-fifo-opts

 is-fifo path [followsymlinks:true|false]

This returns C<true> if and only if there is a FIFO (named pipe)
with the given C<path> name.

If the optional flag C<followsymlinks> is true, then a symlink
(or chain of symlinks) that ends with a FIFO also causes the
function to return true.

See also L</stat>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 is-file

=head2 is-file-opts

 is-file path [followsymlinks:true|false]

This returns C<true> if and only if there is a regular file
with the given C<path> name.  Note that it returns false for
other objects like directories.

If the optional flag C<followsymlinks> is true, then a symlink
(or chain of symlinks) that ends with a file also causes the
function to return true.

See also L</stat>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 is-lv

 is-lv mountable

This command tests whether C<mountable> is a logical volume, and
returns true iff this is the case.

=head2 is-socket

=head2 is-socket-opts

 is-socket path [followsymlinks:true|false]

This returns C<true> if and only if there is a Unix domain socket
with the given C<path> name.

If the optional flag C<followsymlinks> is true, then a symlink
(or chain of symlinks) that ends with a socket also causes the
function to return true.

See also L</stat>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 is-symlink

 is-symlink path

This returns C<true> if and only if there is a symbolic link
with the given C<path> name.

See also L</stat>.

=head2 is-whole-device

 is-whole-device device

This returns C<true> if and only if C<device> refers to a whole block
device. That is, not a partition or a logical device.

=head2 is-zero

 is-zero path

This returns true iff the file exists and the file is empty or
it contains all zero bytes.

=head2 is-zero-device

 is-zero-device device

This returns true iff the device exists and contains all zero bytes.

Note that for large devices this can take a long time to run.

=head2 isoinfo

 isoinfo isofile

This is the same as L</isoinfo-device> except that it
works for an ISO file located inside some other mounted filesystem.
Note that in the common case where you have added an ISO file
as a libguestfs device, you would I<not> call this.  Instead
you would call L</isoinfo-device>.

=head2 isoinfo-device

 isoinfo-device device

C<device> is an ISO device.  This returns a struct of information
read from the primary volume descriptor (the ISO equivalent of the
superblock) of the device.

Usually it is more efficient to use the L<isoinfo(1)> command
with the I<-d> option on the host to analyze ISO files,
instead of going through libguestfs.

For information on the primary volume descriptor fields, see
L<https://wiki.osdev.org/ISO_9660#The_Primary_Volume_Descriptor>

=head2 journal-close

 journal-close

Close the journal handle.

This command depends on the feature C<journal>.   See also
L</feature-available>.

=head2 journal-get

 journal-get

Read the current journal entry.  This returns all the fields
in the journal as a set of C<(attrname, attrval)> pairs.  The
C<attrname> is the field name (a string).

The C<attrval> is the field value (a binary blob, often but
not always a string).  Please note that C<attrval> is a byte
array, I<not> a \0-terminated C string.

The length of data may be truncated to the data threshold
(see: L</journal-set-data-threshold>,
L</journal-get-data-threshold>).

If you set the data threshold to unlimited (C<0>) then this call
can read a journal entry of any size, ie. it is not limited by
the libguestfs protocol.

This command depends on the feature C<journal>.   See also
L</feature-available>.

=head2 journal-get-data-threshold

 journal-get-data-threshold

Get the current data threshold for reading journal entries.
This is a hint to the journal that it may truncate data fields to
this size when reading them (note also that it may not truncate them).
If this returns C<0>, then the threshold is unlimited.

See also L</journal-set-data-threshold>.

This command depends on the feature C<journal>.   See also
L</feature-available>.

=head2 journal-get-realtime-usec

 journal-get-realtime-usec

Get the realtime (wallclock) timestamp of the current journal entry.

This command depends on the feature C<journal>.   See also
L</feature-available>.

=head2 journal-next

 journal-next

Move to the next journal entry.  You have to call this
at least once after opening the handle before you are able
to read data.

The returned boolean tells you if there are any more journal
records to read.  C<true> means you can read the next record
(eg. using L</journal-get>), and C<false> means you
have reached the end of the journal.

This command depends on the feature C<journal>.   See also
L</feature-available>.

=head2 journal-open

 journal-open directory

Open the systemd journal located in F<directory>.  Any previously
opened journal handle is closed.

The contents of the journal can be read using L</journal-next>
and L</journal-get>.

After you have finished using the journal, you should close the
handle by calling L</journal-close>.

This command depends on the feature C<journal>.   See also
L</feature-available>.

=head2 journal-set-data-threshold

 journal-set-data-threshold threshold

Set the data threshold for reading journal entries.
This is a hint to the journal that it may truncate data fields to
this size when reading them (note also that it may not truncate them).
If you set this to C<0>, then the threshold is unlimited.

See also L</journal-get-data-threshold>.

This command depends on the feature C<journal>.   See also
L</feature-available>.

=head2 journal-skip

 journal-skip skip

Skip forwards (C<skip E<ge> 0>) or backwards (C<skip E<lt> 0>) in the
journal.

The number of entries actually skipped is returned (note S<C<rskip E<ge> 0>>).
If this is not the same as the absolute value of the skip parameter
(C<|skip|>) you passed in then it means you have reached the end or
the start of the journal.

This command depends on the feature C<journal>.   See also
L</feature-available>.

=head2 kill-subprocess

 kill-subprocess

This kills the hypervisor.

Do not call this.  See: L</shutdown> instead.

I<This function is deprecated.>
In new code, use the L</shutdown> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 launch

=head2 run

 launch

You should call this after configuring the handle
(eg. adding drives) but before performing any actions.

Do not call L</launch> twice on the same handle.  Although
it will not give an error (for historical reasons), the precise
behaviour when you do this is not well defined.  Handles are
very cheap to create, so create a new one for each launch.

=head2 lchown

 lchown owner group path

Change the file owner to C<owner> and group to C<group>.
This is like L</chown> but if C<path> is a symlink then
the link itself is changed, not the target.

Only numeric uid and gid are supported.  If you want to use
names, you will need to locate and parse the password file
yourself (Augeas support makes this relatively easy).

=head2 ldmtool-create-all

 ldmtool-create-all

This function scans all block devices looking for Windows
dynamic disk volumes and partitions, and creates devices
for any that were found.

Call L</list-ldm-volumes> and L</list-ldm-partitions>
to return all devices.

Note that you B<don't> normally need to call this explicitly,
since it is done automatically at L</launch> time.
However you might want to call this function if you have
hotplugged disks or have just created a Windows dynamic disk.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-diskgroup-disks

 ldmtool-diskgroup-disks diskgroup

Return the disks in a Windows dynamic disk group.  The C<diskgroup>
parameter should be the GUID of a disk group, one element from
the list returned by L</ldmtool-scan>.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-diskgroup-name

 ldmtool-diskgroup-name diskgroup

Return the name of a Windows dynamic disk group.  The C<diskgroup>
parameter should be the GUID of a disk group, one element from
the list returned by L</ldmtool-scan>.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-diskgroup-volumes

 ldmtool-diskgroup-volumes diskgroup

Return the volumes in a Windows dynamic disk group.  The C<diskgroup>
parameter should be the GUID of a disk group, one element from
the list returned by L</ldmtool-scan>.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-remove-all

 ldmtool-remove-all

This is essentially the opposite of L</ldmtool-create-all>.
It removes the device mapper mappings for all Windows dynamic disk
volumes

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-scan

 ldmtool-scan

This function scans for Windows dynamic disks.  It returns a list
of identifiers (GUIDs) for all disk groups that were found.  These
identifiers can be passed to other L</ldmtool-*> functions.

This function scans all block devices.  To scan a subset of
block devices, call L</ldmtool-scan-devices> instead.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-scan-devices

 ldmtool-scan-devices 'devices ...'

This function scans for Windows dynamic disks.  It returns a list
of identifiers (GUIDs) for all disk groups that were found.  These
identifiers can be passed to other L</ldmtool-*> functions.

The parameter C<devices> is a list of block devices which are
scanned.  If this list is empty, all block devices are scanned.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-volume-hint

 ldmtool-volume-hint diskgroup volume

Return the hint field of the volume named C<volume> in the disk
group with GUID C<diskgroup>.  This may not be defined, in which
case the empty string is returned.  The hint field is often, though
not always, the name of a Windows drive, eg. C<E:>.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-volume-partitions

 ldmtool-volume-partitions diskgroup volume

Return the list of partitions in the volume named C<volume> in the disk
group with GUID C<diskgroup>.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 ldmtool-volume-type

 ldmtool-volume-type diskgroup volume

Return the type of the volume named C<volume> in the disk
group with GUID C<diskgroup>.

Possible volume types that can be returned here include:
C<simple>, C<spanned>, C<striped>, C<mirrored>, C<raid5>.
Other types may also be returned.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 lgetxattr

 lgetxattr path name

Get a single extended attribute from file C<path> named C<name>.
If C<path> is a symlink, then this call returns an extended
attribute from the symlink.

Normally it is better to get all extended attributes from a file
in one go by calling L</getxattrs>.  However some Linux
filesystem implementations are buggy and do not provide a way to
list out attributes.  For these filesystems (notably ntfs-3g)
you have to know the names of the extended attributes you want
in advance and call this function.

Extended attribute values are blobs of binary data.  If there
is no extended attribute named C<name>, this returns an error.

See also: L</lgetxattrs>, L</getxattr>, L<attr(5)>.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 lgetxattrs

 lgetxattrs path

This is the same as L</getxattrs>, but if C<path>
is a symbolic link, then it returns the extended attributes
of the link itself.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 list-9p

 list-9p

List all 9p filesystems attached to the guest.  A list of
mount tags is returned.

=head2 list-devices

 list-devices

List all the block devices.

The full block device names are returned, eg. F</dev/sda>.

See also L</list-filesystems>.

=head2 list-disk-labels

 list-disk-labels

If you add drives using the optional C<label> parameter
of L</add-drive-opts>, you can use this call to
map between disk labels, and raw block device and partition
names (like F</dev/sda> and F</dev/sda1>).

This returns a hashtable, where keys are the disk labels
(I<without> the F</dev/disk/guestfs> prefix), and the values
are the full raw block device and partition names
(eg. F</dev/sda> and F</dev/sda1>).

=head2 list-dm-devices

 list-dm-devices

List all device mapper devices.

The returned list contains F</dev/mapper/*> devices, eg. ones created
by a previous call to L</luks-open>.

Device mapper devices which correspond to logical volumes are I<not>
returned in this list.  Call L</lvs> if you want to list logical
volumes.

=head2 list-filesystems

 list-filesystems

This inspection command looks for filesystems on partitions,
block devices and logical volumes, returning a list of C<mountables>
containing filesystems and their type.

The return value is a hash, where the keys are the devices
containing filesystems, and the values are the filesystem types.
For example:

 "/dev/sda1" => "ntfs"
 "/dev/sda2" => "ext2"
 "/dev/vg_guest/lv_root" => "ext4"
 "/dev/vg_guest/lv_swap" => "swap"

The key is not necessarily a block device. It may also be an opaque
‘mountable’ string which can be passed to L</mount>.

The value can have the special value "unknown", meaning the
content of the device is undetermined or empty.
"swap" means a Linux swap partition.

In libguestfs E<le> 1.36 this command ran other libguestfs commands,
which might have included L</mount> and L</umount>, and
therefore you had to use this soon after launch and only when
nothing else was mounted.  This restriction is removed in libguestfs
E<ge> 1.38.

Not all of the filesystems returned will be mountable.  In
particular, swap partitions are returned in the list.  Also
this command does not check that each filesystem
found is valid and mountable, and some filesystems might
be mountable but require special options.  Filesystems may
not all belong to a single logical operating system
(use L</inspect-os> to look for OSes).

=head2 list-ldm-partitions

 list-ldm-partitions

This function returns all Windows dynamic disk partitions
that were found at launch time.  It returns a list of
device names.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 list-ldm-volumes

 list-ldm-volumes

This function returns all Windows dynamic disk volumes
that were found at launch time.  It returns a list of
device names.

This command depends on the feature C<ldm>.   See also
L</feature-available>.

=head2 list-md-devices

 list-md-devices

List all Linux md devices.

=head2 list-partitions

 list-partitions

List all the partitions detected on all block devices.

The full partition device names are returned, eg. F</dev/sda1>

This does not return logical volumes.  For that you will need to
call L</lvs>.

See also L</list-filesystems>.

=head2 ll

 ll directory

List the files in F<directory> (relative to the root directory,
there is no cwd) in the format of C<ls -la>.

This command is mostly useful for interactive sessions.  It
is I<not> intended that you try to parse the output string.

=head2 llz

 llz directory

List the files in F<directory> in the format of C<ls -laZ>.

This command is mostly useful for interactive sessions.  It
is I<not> intended that you try to parse the output string.

I<This function is deprecated.>
In new code, use the L</lgetxattrs> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 ln

 ln target linkname

This command creates a hard link.

=head2 ln-f

 ln-f target linkname

This command creates a hard link, removing the link C<linkname>
if it exists already.

=head2 ln-s

 ln-s target linkname

This command creates a symbolic link using the C<ln -s> command.

=head2 ln-sf

 ln-sf target linkname

This command creates a symbolic link using the C<ln -sf> command,
The I<-f> option removes the link (C<linkname>) if it exists already.

=head2 lremovexattr

 lremovexattr xattr path

This is the same as L</removexattr>, but if C<path>
is a symbolic link, then it removes an extended attribute
of the link itself.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 ls

 ls directory

List the files in F<directory> (relative to the root directory,
there is no cwd).  The C<.> and C<..> entries are not returned, but
hidden files are shown.

=head2 ls0

 ls0 dir (filenames|-)

This specialized command is used to get a listing of
the filenames in the directory C<dir>.  The list of filenames
is written to the local file F<filenames> (on the host).

In the output file, the filenames are separated by C<\0> characters.

C<.> and C<..> are not returned.  The filenames are not sorted.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 lsetxattr

 lsetxattr xattr val vallen path

This is the same as L</setxattr>, but if C<path>
is a symbolic link, then it sets an extended attribute
of the link itself.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 lstat

 lstat path

Returns file information for the given C<path>.

This is the same as L</stat> except that if C<path>
is a symbolic link, then the link is stat-ed, not the file it
refers to.

This is the same as the L<lstat(2)> system call.

I<This function is deprecated.>
In new code, use the L</lstatns> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 lstatlist

 lstatlist path 'names ...'

This call allows you to perform the L</lstat> operation
on multiple files, where all files are in the directory C<path>.
C<names> is the list of files from this directory.

On return you get a list of stat structs, with a one-to-one
correspondence to the C<names> list.  If any name did not exist
or could not be lstat'd, then the C<st_ino> field of that structure
is set to C<-1>.

This call is intended for programs that want to efficiently
list a directory contents without making many round-trips.
See also L</lxattrlist> for a similarly efficient call
for getting extended attributes.

I<This function is deprecated.>
In new code, use the L</lstatnslist> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 lstatns

 lstatns path

Returns file information for the given C<path>.

This is the same as L</statns> except that if C<path>
is a symbolic link, then the link is stat-ed, not the file it
refers to.

This is the same as the L<lstat(2)> system call.

=head2 lstatnslist

 lstatnslist path 'names ...'

This call allows you to perform the L</lstatns> operation
on multiple files, where all files are in the directory C<path>.
C<names> is the list of files from this directory.

On return you get a list of stat structs, with a one-to-one
correspondence to the C<names> list.  If any name did not exist
or could not be lstat'd, then the C<st_ino> field of that structure
is set to C<-1>.

This call is intended for programs that want to efficiently
list a directory contents without making many round-trips.
See also L</lxattrlist> for a similarly efficient call
for getting extended attributes.

=head2 luks-add-key

 luks-add-key device keyslot

This command adds a new key on LUKS device C<device>.
C<key> is any existing key, and is used to access the device.
C<newkey> is the new key to add.  C<keyslot> is the key slot
that will be replaced.

Note that if C<keyslot> already contains a key, then this
command will fail.  You have to use L</luks-kill-slot>
first to remove that key.

This command has one or more key or passphrase parameters.
Guestfish will prompt for these separately.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 luks-close

 luks-close device

This closes a LUKS device that was created earlier by
L</luks-open> or L</luks-open-ro>.  The
C<device> parameter must be the name of the LUKS mapping
device (ie. F</dev/mapper/mapname>) and I<not> the name
of the underlying block device.

I<This function is deprecated.>
In new code, use the L</cryptsetup-close> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 luks-format

 luks-format device keyslot

This command erases existing data on C<device> and formats
the device as a LUKS encrypted device.  C<key> is the
initial key, which is added to key slot C<keyslot>.  (LUKS
supports 8 key slots, numbered 0-7).

This command has one or more key or passphrase parameters.
Guestfish will prompt for these separately.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 luks-format-cipher

 luks-format-cipher device keyslot cipher

This command is the same as L</luks-format> but
it also allows you to set the C<cipher> used.

This command has one or more key or passphrase parameters.
Guestfish will prompt for these separately.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 luks-kill-slot

 luks-kill-slot device keyslot

This command deletes the key in key slot C<keyslot> from the
encrypted LUKS device C<device>.  C<key> must be one of the
I<other> keys.

This command has one or more key or passphrase parameters.
Guestfish will prompt for these separately.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 luks-open

 luks-open device mapname

This command opens a block device which has been encrypted
according to the Linux Unified Key Setup (LUKS) standard.

C<device> is the encrypted block device or partition.

The caller must supply one of the keys associated with the
LUKS block device, in the C<key> parameter.

This creates a new block device called F</dev/mapper/mapname>.
Reads and writes to this block device are decrypted from and
encrypted to the underlying C<device> respectively.

If this block device contains LVM volume groups, then
calling L</lvm-scan> with the C<activate>
parameter C<true> will make them visible.

Use L</list-dm-devices> to list all device mapper
devices.

This command has one or more key or passphrase parameters.
Guestfish will prompt for these separately.

I<This function is deprecated.>
In new code, use the L</cryptsetup-open> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 luks-open-ro

 luks-open-ro device mapname

This is the same as L</luks-open> except that a read-only
mapping is created.

This command has one or more key or passphrase parameters.
Guestfish will prompt for these separately.

I<This function is deprecated.>
In new code, use the L</cryptsetup-open> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 luks-uuid

 luks-uuid device

This returns the UUID of the LUKS device C<device>.

This command depends on the feature C<luks>.   See also
L</feature-available>.

=head2 lvcreate

 lvcreate logvol volgroup mbytes

This creates an LVM logical volume called C<logvol>
on the volume group C<volgroup>, with C<size> megabytes.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvcreate-free

 lvcreate-free logvol volgroup percent

Create an LVM logical volume called F</dev/volgroup/logvol>,
using approximately C<percent> % of the free space remaining
in the volume group.  Most usefully, when C<percent> is C<100>
this will create the largest possible LV.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvm-canonical-lv-name

 lvm-canonical-lv-name lvname

This converts alternative naming schemes for LVs that you
might find to the canonical name.  For example, F</dev/mapper/VG-LV>
is converted to F</dev/VG/LV>.

This command returns an error if the C<lvname> parameter does
not refer to a logical volume.  In this case errno will be
set to C<EINVAL>.

See also L</is-lv>, L</canonical-device-name>.

=head2 lvm-clear-filter

 lvm-clear-filter

This undoes the effect of L</lvm-set-filter>.  LVM
will be able to see every block device.

This command also clears the LVM cache and performs a volume
group scan.

=head2 lvm-remove-all

 lvm-remove-all

This command removes all LVM logical volumes, volume groups
and physical volumes.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvm-scan

 lvm-scan true|false

This scans all block devices and rebuilds the list of LVM
physical volumes, volume groups and logical volumes.

If the C<activate> parameter is C<true> then newly found
volume groups and logical volumes are activated, meaning
the LV F</dev/VG/LV> devices become visible.

When a libguestfs handle is launched it scans for existing
devices, so you do not normally need to use this API.  However
it is useful when you have added a new device or deleted an
existing device (such as when the L</luks-open> API
is used).

=head2 lvm-set-filter

 lvm-set-filter 'devices ...'

This sets the LVM device filter so that LVM will only be
able to "see" the block devices in the list C<devices>,
and will ignore all other attached block devices.

Where disk image(s) contain duplicate PVs or VGs, this
command is useful to get LVM to ignore the duplicates, otherwise
LVM can get confused.  Note also there are two types
of duplication possible: either cloned PVs/VGs which have
identical UUIDs; or VGs that are not cloned but just happen
to have the same name.  In normal operation you cannot
create this situation, but you can do it outside LVM, eg.
by cloning disk images or by bit twiddling inside the LVM
metadata.

This command also clears the LVM cache and performs a volume
group scan.

You can filter whole block devices or individual partitions.

You cannot use this if any VG is currently in use (eg.
contains a mounted filesystem), even if you are not
filtering out that VG.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvremove

 lvremove device

Remove an LVM logical volume C<device>, where C<device> is
the path to the LV, such as F</dev/VG/LV>.

You can also remove all LVs in a volume group by specifying
the VG name, F</dev/VG>.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvrename

 lvrename logvol newlogvol

Rename a logical volume C<logvol> with the new name C<newlogvol>.

=head2 lvresize

 lvresize device mbytes

This resizes (expands or shrinks) an existing LVM logical
volume to C<mbytes>.  When reducing, data in the reduced part
is lost.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvresize-free

 lvresize-free lv percent

This expands an existing logical volume C<lv> so that it fills
C<pc> % of the remaining free space in the volume group.  Commonly
you would call this with pc = 100 which expands the logical volume
as much as possible, using all remaining free space in the volume
group.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvs

 lvs

List all the logical volumes detected.  This is the equivalent
of the L<lvs(8)> command.

This returns a list of the logical volume device names
(eg. F</dev/VolGroup00/LogVol00>).

See also L</lvs-full>, L</list-filesystems>.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvs-full

 lvs-full

List all the logical volumes detected.  This is the equivalent
of the L<lvs(8)> command.  The "full" version includes all fields.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 lvuuid

 lvuuid device

This command returns the UUID of the LVM LV C<device>.

=head2 lxattrlist

 lxattrlist path 'names ...'

This call allows you to get the extended attributes
of multiple files, where all files are in the directory C<path>.
C<names> is the list of files from this directory.

On return you get a flat list of xattr structs which must be
interpreted sequentially.  The first xattr struct always has a zero-length
C<attrname>.  C<attrval> in this struct is zero-length
to indicate there was an error doing L</lgetxattr> for this
file, I<or> is a C string which is a decimal number
(the number of following attributes for this file, which could
be C<"0">).  Then after the first xattr struct are the
zero or more attributes for the first named file.
This repeats for the second and subsequent files.

This call is intended for programs that want to efficiently
list a directory contents without making many round-trips.
See also L</lstatlist> for a similarly efficient call
for getting standard stats.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 max-disks

 max-disks

Return the maximum number of disks that may be added to a
handle (eg. by L</add-drive-opts> and similar calls).

This function was added in libguestfs 1.19.7.  In previous
versions of libguestfs the limit was 25.

See L<guestfs(3)/MAXIMUM NUMBER OF DISKS> for additional
information on this topic.

=head2 md-create

 md-create name 'devices ...' [missingbitmap:N] [nrdevices:N] [spare:N] [chunk:N] [level:..]

Create a Linux md (RAID) device named C<name> on the devices
in the list C<devices>.

The optional parameters are:

=over 4

=item C<missingbitmap>

A bitmap of missing devices.  If a bit is set it means that a
missing device is added to the array.  The least significant bit
corresponds to the first device in the array.

As examples:

If C<devices = ["/dev/sda"]> and C<missingbitmap = 0x1> then
the resulting array would be C<[E<lt>missingE<gt>, "/dev/sda"]>.

If C<devices = ["/dev/sda"]> and C<missingbitmap = 0x2> then
the resulting array would be C<["/dev/sda", E<lt>missingE<gt>]>.

This defaults to C<0> (no missing devices).

The length of C<devices> + the number of bits set in
C<missingbitmap> must equal C<nrdevices> + C<spare>.

=item C<nrdevices>

The number of active RAID devices.

If not set, this defaults to the length of C<devices> plus
the number of bits set in C<missingbitmap>.

=item C<spare>

The number of spare devices.

If not set, this defaults to C<0>.

=item C<chunk>

The chunk size in bytes.

=item C<level>

The RAID level, which can be one of:
C<linear>, C<raid0>, C<0>, C<stripe>, C<raid1>, C<1>, C<mirror>,
C<raid4>, C<4>, C<raid5>, C<5>, C<raid6>, C<6>, C<raid10>, C<10>.
Some of these are synonymous, and more levels may be added in future.

If not set, this defaults to C<raid1>.

=back

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<mdadm>.   See also
L</feature-available>.

=head2 md-detail

 md-detail md

This command exposes the output of C<mdadm -DY E<lt>mdE<gt>>.
The following fields are usually present in the returned hash.
Other fields may also be present.

=over

=item C<level>

The raid level of the MD device.

=item C<devices>

The number of underlying devices in the MD device.

=item C<metadata>

The metadata version used.

=item C<uuid>

The UUID of the MD device.

=item C<name>

The name of the MD device.

=back

This command depends on the feature C<mdadm>.   See also
L</feature-available>.

=head2 md-stat

 md-stat md

This call returns a list of the underlying devices which make
up the single software RAID array device C<md>.

To get a list of software RAID devices, call L</list-md-devices>.

Each structure returned corresponds to one device along with
additional status information:

=over 4

=item C<mdstat_device>

The name of the underlying device.

=item C<mdstat_index>

The index of this device within the array.

=item C<mdstat_flags>

Flags associated with this device.  This is a string containing
(in no specific order) zero or more of the following flags:

=over 4

=item C<W>

write-mostly

=item C<F>

device is faulty

=item C<S>

device is a RAID spare

=item C<R>

replacement

=back

=back

This command depends on the feature C<mdadm>.   See also
L</feature-available>.

=head2 md-stop

 md-stop md

This command deactivates the MD array named C<md>.  The
device is stopped, but it is not destroyed or zeroed.

This command depends on the feature C<mdadm>.   See also
L</feature-available>.

=head2 mkdir

 mkdir path

Create a directory named C<path>.

=head2 mkdir-mode

 mkdir-mode path mode

This command creates a directory, setting the initial permissions
of the directory to C<mode>.

For common Linux filesystems, the actual mode which is set will
be C<mode & ~umask & 01777>.  Non-native-Linux filesystems may
interpret the mode in other ways.

See also L</mkdir>, L</umask>

=head2 mkdir-p

 mkdir-p path

Create a directory named C<path>, creating any parent directories
as necessary.  This is like the C<mkdir -p> shell command.

=head2 mkdtemp

 mkdtemp tmpl

This command creates a temporary directory.  The
C<tmpl> parameter should be a full pathname for the
temporary directory name with the final six characters being
"XXXXXX".

For example: "/tmp/myprogXXXXXX" or "/Temp/myprogXXXXXX",
the second one being suitable for Windows filesystems.

The name of the temporary directory that was created
is returned.

The temporary directory is created with mode 0700
and is owned by root.

The caller is responsible for deleting the temporary
directory and its contents after use.

See also: L<mkdtemp(3)>

=head2 mke2fs

 mke2fs device [blockscount:N] [blocksize:N] [fragsize:N] [blockspergroup:N] [numberofgroups:N] [bytesperinode:N] [inodesize:N] [journalsize:N] [numberofinodes:N] [stridesize:N] [stripewidth:N] [maxonlineresize:N] [reservedblockspercentage:N] [mmpupdateinterval:N] [journaldevice:..] [label:..] [lastmounteddir:..] [creatoros:..] [fstype:..] [usagetype:..] [uuid:..] [forcecreate:true|false] [writesbandgrouponly:true|false] [lazyitableinit:true|false] [lazyjournalinit:true|false] [testfs:true|false] [discard:true|false] [quotatype:true|false] [extent:true|false] [filetype:true|false] [flexbg:true|false] [hasjournal:true|false] [journaldev:true|false] [largefile:true|false] [quota:true|false] [resizeinode:true|false] [sparsesuper:true|false] [uninitbg:true|false]

C<mke2fs> is used to create an ext2, ext3, or ext4 filesystem
on C<device>.

The optional C<blockscount> is the size of the filesystem in blocks.
If omitted it defaults to the size of C<device>.  Note if the
filesystem is too small to contain a journal, C<mke2fs> will
silently create an ext2 filesystem instead.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 mke2fs-J

 mke2fs-J fstype blocksize device journal

This creates an ext2/3/4 filesystem on C<device> with
an external journal on C<journal>.  It is equivalent
to the command:

 mke2fs -t fstype -b blocksize -J device=<journal> <device>

See also L</mke2journal>.

I<This function is deprecated.>
In new code, use the L</mke2fs> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 mke2fs-JL

 mke2fs-JL fstype blocksize device label

This creates an ext2/3/4 filesystem on C<device> with
an external journal on the journal labeled C<label>.

See also L</mke2journal-L>.

I<This function is deprecated.>
In new code, use the L</mke2fs> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 mke2fs-JU

 mke2fs-JU fstype blocksize device uuid

This creates an ext2/3/4 filesystem on C<device> with
an external journal on the journal with UUID C<uuid>.

See also L</mke2journal-U>.

I<This function is deprecated.>
In new code, use the L</mke2fs> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<linuxfsuuid>.   See also
L</feature-available>.

=head2 mke2journal

 mke2journal blocksize device

This creates an ext2 external journal on C<device>.  It is equivalent
to the command:

 mke2fs -O journal_dev -b blocksize device

I<This function is deprecated.>
In new code, use the L</mke2fs> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 mke2journal-L

 mke2journal-L blocksize label device

This creates an ext2 external journal on C<device> with label C<label>.

I<This function is deprecated.>
In new code, use the L</mke2fs> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 mke2journal-U

 mke2journal-U blocksize uuid device

This creates an ext2 external journal on C<device> with UUID C<uuid>.

I<This function is deprecated.>
In new code, use the L</mke2fs> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<linuxfsuuid>.   See also
L</feature-available>.

=head2 mkfifo

 mkfifo mode path

This call creates a FIFO (named pipe) called C<path> with
mode C<mode>.  It is just a convenient wrapper around
L</mknod>.

Unlike with L</mknod>, C<mode> B<must> contain only permissions
bits.

The mode actually set is affected by the umask.

This command depends on the feature C<mknod>.   See also
L</feature-available>.

=head2 mkfs

=head2 mkfs-opts

 mkfs fstype device [blocksize:N] [features:..] [inode:N] [sectorsize:N] [label:..]

This function creates a filesystem on C<device>.  The filesystem
type is C<fstype>, for example C<ext3>.

The optional arguments are:

=over 4

=item C<blocksize>

The filesystem block size.  Supported block sizes depend on the
filesystem type, but typically they are C<1024>, C<2048> or C<4096>
for Linux ext2/3 filesystems.

For VFAT and NTFS the C<blocksize> parameter is treated as
the requested cluster size.

For UFS block sizes, please see L<mkfs.ufs(8)>.

=item C<features>

This passes the I<-O> parameter to the external mkfs program.

For certain filesystem types, this allows extra filesystem
features to be selected.  See L<mke2fs(8)> and L<mkfs.ufs(8)>
for more details.

You cannot use this optional parameter with the C<gfs> or
C<gfs2> filesystem type.

=item C<inode>

This passes the I<-I> parameter to the external L<mke2fs(8)> program
which sets the inode size (only for ext2/3/4 filesystems at present).

=item C<sectorsize>

This passes the I<-S> parameter to external L<mkfs.ufs(8)> program,
which sets sector size for ufs filesystem.

=back

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 mkfs-b

 mkfs-b fstype blocksize device

This call is similar to L</mkfs>, but it allows you to
control the block size of the resulting filesystem.  Supported
block sizes depend on the filesystem type, but typically they
are C<1024>, C<2048> or C<4096> only.

For VFAT and NTFS the C<blocksize> parameter is treated as
the requested cluster size.

I<This function is deprecated.>
In new code, use the L</mkfs> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 mkfs-btrfs

 mkfs-btrfs 'devices ...' [allocstart:N] [bytecount:N] [datatype:..] [leafsize:N] [label:..] [metadata:..] [nodesize:N] [sectorsize:N]

Create a btrfs filesystem, allowing all configurables to be set.
For more information on the optional arguments, see L<mkfs.btrfs(8)>.

Since btrfs filesystems can span multiple devices, this takes a
non-empty list of devices.

To create general filesystems, use L</mkfs>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<btrfs>.   See also
L</feature-available>.

=head2 mklost-and-found

 mklost-and-found mountpoint

Make the C<lost+found> directory, normally in the root directory
of an ext2/3/4 filesystem.  C<mountpoint> is the directory under
which we try to create the C<lost+found> directory.

=head2 mkmountpoint

 mkmountpoint exemptpath

L</mkmountpoint> and L</rmmountpoint> are
specialized calls that can be used to create extra mountpoints
before mounting the first filesystem.

These calls are I<only> necessary in some very limited circumstances,
mainly the case where you want to mount a mix of unrelated and/or
read-only filesystems together.

For example, live CDs often contain a "Russian doll" nest of
filesystems, an ISO outer layer, with a squashfs image inside, with
an ext2/3 image inside that.  You can unpack this as follows
in guestfish:

 add-ro Fedora-11-i686-Live.iso
 run
 mkmountpoint /cd
 mkmountpoint /sqsh
 mkmountpoint /ext3fs
 mount /dev/sda /cd
 mount-loop /cd/LiveOS/squashfs.img /sqsh
 mount-loop /sqsh/LiveOS/ext3fs.img /ext3fs

The inner filesystem is now unpacked under the /ext3fs mountpoint.

L</mkmountpoint> is not compatible with L</umount-all>.
You may get unexpected errors if you try to mix these calls.  It is
safest to manually unmount filesystems and remove mountpoints after use.

L</umount-all> unmounts filesystems by sorting the paths
longest first, so for this to work for manual mountpoints, you
must ensure that the innermost mountpoints have the longest
pathnames, as in the example code above.

For more details see L<https://bugzilla.redhat.com/show_bug.cgi?id=599503>

Autosync [see L</set-autosync>, this is set by default on
handles] can cause L</umount-all> to be called when the handle
is closed which can also trigger these issues.

=head2 mknod

 mknod mode devmajor devminor path

This call creates block or character special devices, or
named pipes (FIFOs).

The C<mode> parameter should be the mode, using the standard
constants.  C<devmajor> and C<devminor> are the
device major and minor numbers, only used when creating block
and character special devices.

Note that, just like L<mknod(2)>, the mode must be bitwise
OR'd with S_IFBLK, S_IFCHR, S_IFIFO or S_IFSOCK (otherwise this call
just creates a regular file).  These constants are
available in the standard Linux header files, or you can use
L</mknod-b>, L</mknod-c> or L</mkfifo>
which are wrappers around this command which bitwise OR
in the appropriate constant for you.

The mode actually set is affected by the umask.

This command depends on the feature C<mknod>.   See also
L</feature-available>.

=head2 mknod-b

 mknod-b mode devmajor devminor path

This call creates a block device node called C<path> with
mode C<mode> and device major/minor C<devmajor> and C<devminor>.
It is just a convenient wrapper around L</mknod>.

Unlike with L</mknod>, C<mode> B<must> contain only permissions
bits.

The mode actually set is affected by the umask.

This command depends on the feature C<mknod>.   See also
L</feature-available>.

=head2 mknod-c

 mknod-c mode devmajor devminor path

This call creates a char device node called C<path> with
mode C<mode> and device major/minor C<devmajor> and C<devminor>.
It is just a convenient wrapper around L</mknod>.

Unlike with L</mknod>, C<mode> B<must> contain only permissions
bits.

The mode actually set is affected by the umask.

This command depends on the feature C<mknod>.   See also
L</feature-available>.

=head2 mksquashfs

 mksquashfs path (filename|-) [compress:..] [excludes:..]

Create a squashfs filesystem for the specified C<path>.

The optional C<compress> flag controls compression.  If not given,
then the output compressed using C<gzip>.  Otherwise one
of the following strings may be given to select the compression
type of the squashfs: C<gzip>, C<lzma>, C<lzo>, C<lz4>, C<xz>.

The other optional arguments are:

=over 4

=item C<excludes>

A list of wildcards.  Files are excluded if they match any of the
wildcards.

=back

Please note that this API may fail when used to compress directories
with large files, such as the resulting squashfs will be over 3GB big.

Use C<-> instead of a filename to read/write from stdin/stdout.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<squashfs>.   See also
L</feature-available>.

=head2 mkswap

=head2 mkswap-opts

 mkswap device [label:..] [uuid:..]

Create a Linux swap partition on C<device>.

The option arguments C<label> and C<uuid> allow you to set the
label and/or UUID of the new swap partition.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 mkswap-L

 mkswap-L label device

Create a swap partition on C<device> with label C<label>.

Note that you cannot attach a swap label to a block device
(eg. F</dev/sda>), just to a partition.  This appears to be
a limitation of the kernel or swap tools.

I<This function is deprecated.>
In new code, use the L</mkswap> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 mkswap-U

 mkswap-U uuid device

Create a swap partition on C<device> with UUID C<uuid>.

I<This function is deprecated.>
In new code, use the L</mkswap> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<linuxfsuuid>.   See also
L</feature-available>.

=head2 mkswap-file

 mkswap-file path

Create a swap file.

This command just writes a swap file signature to an existing
file.  To create the file itself, use something like L</fallocate>.

=head2 mktemp

 mktemp tmpl [suffix:..]

This command creates a temporary file.  The
C<tmpl> parameter should be a full pathname for the
temporary directory name with the final six characters being
"XXXXXX".

For example: "/tmp/myprogXXXXXX" or "/Temp/myprogXXXXXX",
the second one being suitable for Windows filesystems.

The name of the temporary file that was created
is returned.

The temporary file is created with mode 0600
and is owned by root.

The caller is responsible for deleting the temporary
file after use.

If the optional C<suffix> parameter is given, then the suffix
(eg. C<.txt>) is appended to the temporary name.

See also: L</mkdtemp>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 modprobe

 modprobe modulename

This loads a kernel module in the appliance.

This command depends on the feature C<linuxmodules>.   See also
L</feature-available>.

=head2 mount

 mount mountable mountpoint

Mount a guest disk at a position in the filesystem.  Block devices
are named F</dev/sda>, F</dev/sdb> and so on, as they were added to
the guest.  If those block devices contain partitions, they will have
the usual names (eg. F</dev/sda1>).  Also LVM F</dev/VG/LV>-style
names can be used, or ‘mountable’ strings returned by
L</list-filesystems> or L</inspect-get-mountpoints>.

The rules are the same as for L<mount(2)>:  A filesystem must
first be mounted on F</> before others can be mounted.  Other
filesystems can only be mounted on directories which already
exist.

The mounted filesystem is writable, if we have sufficient permissions
on the underlying device.

Before libguestfs 1.13.16, this call implicitly added the options
C<sync> and C<noatime>.  The C<sync> option greatly slowed
writes and caused many problems for users.  If your program
might need to work with older versions of libguestfs, use
L</mount-options> instead (using an empty string for the
first parameter if you don't want any options).

=head2 mount-9p

 mount-9p mounttag mountpoint [options:..]

Mount the virtio-9p filesystem with the tag C<mounttag> on the
directory C<mountpoint>.

If required, C<trans=virtio> will be automatically added to the options.
Any other options required can be passed in the optional C<options>
parameter.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 mount-local

 mount-local localmountpoint [readonly:true|false] [options:..] [cachetimeout:N] [debugcalls:true|false]

This call exports the libguestfs-accessible filesystem to
a local mountpoint (directory) called C<localmountpoint>.
Ordinary reads and writes to files and directories under
C<localmountpoint> are redirected through libguestfs.

If the optional C<readonly> flag is set to true, then
writes to the filesystem return error C<EROFS>.

C<options> is a comma-separated list of mount options.
See L<guestmount(1)> for some useful options.

C<cachetimeout> sets the timeout (in seconds) for cached directory
entries.  The default is 60 seconds.  See L<guestmount(1)>
for further information.

If C<debugcalls> is set to true, then additional debugging
information is generated for every FUSE call.

When L</mount-local> returns, the filesystem is ready,
but is not processing requests (access to it will block).  You
have to call L</mount-local-run> to run the main loop.

See L<guestfs(3)/MOUNT LOCAL> for full documentation.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 mount-local-run

 mount-local-run

Run the main loop which translates kernel calls to libguestfs
calls.

This should only be called after L</mount-local>
returns successfully.  The call will not return until the
filesystem is unmounted.

B<Note> you must I<not> make concurrent libguestfs calls
on the same handle from another thread.

You may call this from a different thread than the one which
called L</mount-local>, subject to the usual rules
for threads and libguestfs (see
L<guestfs(3)/MULTIPLE HANDLES AND MULTIPLE THREADS>).

See L<guestfs(3)/MOUNT LOCAL> for full documentation.

=head2 mount-loop

 mount-loop file mountpoint

This command lets you mount F<file> (a filesystem image
in a file) on a mount point.  It is entirely equivalent to
the command C<mount -o loop file mountpoint>.

=head2 mount-options

 mount-options options mountable mountpoint

This is the same as the L</mount> command, but it
allows you to set the mount options as for the
L<mount(8)> I<-o> flag.

If the C<options> parameter is an empty string, then
no options are passed (all options default to whatever
the filesystem uses).

=head2 mount-ro

 mount-ro mountable mountpoint

This is the same as the L</mount> command, but it
mounts the filesystem with the read-only (I<-o ro>) flag.

=head2 mount-vfs

 mount-vfs options vfstype mountable mountpoint

This is the same as the L</mount> command, but it
allows you to set both the mount options and the vfstype
as for the L<mount(8)> I<-o> and I<-t> flags.

=head2 mountable-device

 mountable-device mountable

Returns the device name of a mountable. In quite a lot of
cases, the mountable is the device name.

However this doesn't apply for btrfs subvolumes, where the
mountable is a combination of both the device name and the
subvolume path (see also L</mountable-subvolume> to
extract the subvolume path of the mountable if any).

=head2 mountable-subvolume

 mountable-subvolume mountable

Returns the subvolume path of a mountable. Btrfs subvolumes
mountables are a combination of both the device name and the
subvolume path (see also L</mountable-device> to extract
the device of the mountable).

If the mountable does not represent a btrfs subvolume, then
this function fails and the C<errno> is set to C<EINVAL>.

=head2 mountpoints

 mountpoints

This call is similar to L</mounts>.  That call returns
a list of devices.  This one returns a hash table (map) of
device name to directory where the device is mounted.

=head2 mounts

 mounts

This returns the list of currently mounted filesystems.  It returns
the list of devices (eg. F</dev/sda1>, F</dev/VG/LV>).

Some internal mounts are not shown.

See also: L</mountpoints>

=head2 mv

 mv src dest

This moves a file from C<src> to C<dest> where C<dest> is
either a destination filename or destination directory.

See also: L</rename>.

=head2 nr-devices

 nr-devices

This returns the number of whole block devices that were
added.  This is the same as the number of devices that would
be returned if you called L</list-devices>.

To find out the maximum number of devices that could be added,
call L</max-disks>.

=head2 ntfs-3g-probe

 ntfs-3g-probe true|false device

This command runs the L<ntfs-3g.probe(8)> command which probes
an NTFS C<device> for mountability.  (Not all NTFS volumes can
be mounted read-write, and some cannot be mounted at all).

C<rw> is a boolean flag.  Set it to true if you want to test
if the volume can be mounted read-write.  Set it to false if
you want to test if the volume can be mounted read-only.

The return value is an integer which C<0> if the operation
would succeed, or some non-zero value documented in the
L<ntfs-3g.probe(8)> manual page.

This command depends on the feature C<ntfs3g>.   See also
L</feature-available>.

=head2 ntfscat-i

 ntfscat-i device inode (filename|-)

Download a file given its inode from a NTFS filesystem and save it as
F<filename> on the local machine.

This allows to download some otherwise inaccessible files such as the ones
within the C<$Extend> folder.

The filesystem from which to extract the file must be unmounted,
otherwise the call will fail.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 ntfsclone-in

 ntfsclone-in (backupfile|-) device

Restore the C<backupfile> (from a previous call to
L</ntfsclone-out>) to C<device>, overwriting
any existing contents of this device.

Use C<-> instead of a filename to read/write from stdin/stdout.

This command depends on the feature C<ntfs3g>.   See also
L</feature-available>.

=head2 ntfsclone-out

 ntfsclone-out device (backupfile|-) [metadataonly:true|false] [rescue:true|false] [ignorefscheck:true|false] [preservetimestamps:true|false] [force:true|false]

Stream the NTFS filesystem C<device> to the local file
C<backupfile>.  The format used for the backup file is a
special format used by the L<ntfsclone(8)> tool.

If the optional C<metadataonly> flag is true, then I<only> the
metadata is saved, losing all the user data (this is useful
for diagnosing some filesystem problems).

The optional C<rescue>, C<ignorefscheck>, C<preservetimestamps>
and C<force> flags have precise meanings detailed in the
L<ntfsclone(8)> man page.

Use L</ntfsclone-in> to restore the file back to a
libguestfs device.

Use C<-> instead of a filename to read/write from stdin/stdout.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<ntfs3g>.   See also
L</feature-available>.

=head2 ntfsfix

 ntfsfix device [clearbadsectors:true|false]

This command repairs some fundamental NTFS inconsistencies,
resets the NTFS journal file, and schedules an NTFS consistency
check for the first boot into Windows.

This is I<not> an equivalent of Windows C<chkdsk>.  It does I<not>
scan the filesystem for inconsistencies.

The optional C<clearbadsectors> flag clears the list of bad sectors.
This is useful after cloning a disk with bad sectors to a new disk.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<ntfs3g>.   See also
L</feature-available>.

=head2 ntfsresize

=head2 ntfsresize-opts

 ntfsresize device [size:N] [force:true|false]

This command resizes an NTFS filesystem, expanding or
shrinking it to the size of the underlying device.

The optional parameters are:

=over 4

=item C<size>

The new size (in bytes) of the filesystem.  If omitted, the filesystem
is resized to fit the container (eg. partition).

=item C<force>

If this option is true, then force the resize of the filesystem
even if the filesystem is marked as requiring a consistency check.

After the resize operation, the filesystem is always marked
as requiring a consistency check (for safety).  You have to boot
into Windows to perform this check and clear this condition.
If you I<don't> set the C<force> option then it is not
possible to call L</ntfsresize> multiple times on a
single filesystem without booting into Windows between each resize.

=back

See also L<ntfsresize(8)>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<ntfsprogs>.   See also
L</feature-available>.

=head2 ntfsresize-size

 ntfsresize-size device size

This command is the same as L</ntfsresize> except that it
allows you to specify the new size (in bytes) explicitly.

I<This function is deprecated.>
In new code, use the L</ntfsresize> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<ntfsprogs>.   See also
L</feature-available>.

=head2 parse-environment

 parse-environment

Parse the program’s environment and set flags in the handle
accordingly.  For example if C<LIBGUESTFS_DEBUG=1> then the
‘verbose’ flag is set in the handle.

I<Most programs do not need to call this>.  It is done implicitly
when you call L</create>.

See L<guestfs(3)/ENVIRONMENT VARIABLES> for a list of environment
variables that can affect libguestfs handles.  See also
L<guestfs(3)/guestfs_create_flags>, and
L</parse-environment-list>.

=head2 parse-environment-list

 parse-environment-list 'environment ...'

Parse the list of strings in the argument C<environment>
and set flags in the handle accordingly.
For example if C<LIBGUESTFS_DEBUG=1> is a string in the list,
then the ‘verbose’ flag is set in the handle.

This is the same as L</parse-environment> except that
it parses an explicit list of strings instead of the program's
environment.

=head2 part-add

 part-add device prlogex startsect endsect

This command adds a partition to C<device>.  If there is no partition
table on the device, call L</part-init> first.

The C<prlogex> parameter is the type of partition.  Normally you
should pass C<p> or C<primary> here, but MBR partition tables also
support C<l> (or C<logical>) and C<e> (or C<extended>) partition
types.

C<startsect> and C<endsect> are the start and end of the partition
in I<sectors>.  C<endsect> may be negative, which means it counts
backwards from the end of the disk (C<-1> is the last sector).

Creating a partition which covers the whole disk is not so easy.
Use L</part-disk> to do that.

=head2 part-del

 part-del device partnum

This command deletes the partition numbered C<partnum> on C<device>.

Note that in the case of MBR partitioning, deleting an
extended partition also deletes any logical partitions
it contains.

=head2 part-disk

 part-disk device parttype

This command is simply a combination of L</part-init>
followed by L</part-add> to create a single primary partition
covering the whole disk.

C<parttype> is the partition table type, usually C<mbr> or C<gpt>,
but other possible values are described in L</part-init>.

=head2 part-expand-gpt

 part-expand-gpt device

Move backup GPT data structures to the end of the disk.
This is useful in case of in-place image expand
since disk space after backup GPT header is not usable.
This is equivalent to C<sgdisk -e>.

See also L<sgdisk(8)>.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-get-bootable

 part-get-bootable device partnum

This command returns true if the partition C<partnum> on
C<device> has the bootable flag set.

See also L</part-set-bootable>.

=head2 part-get-disk-guid

 part-get-disk-guid device

Return the disk identifier (GUID) of a GPT-partitioned C<device>.
Behaviour is undefined for other partition types.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-get-gpt-attributes

 part-get-gpt-attributes device partnum

Return the attribute flags of numbered GPT partition C<partnum>.
An error is returned for MBR partitions.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-get-gpt-guid

 part-get-gpt-guid device partnum

Return the GUID of numbered GPT partition C<partnum>.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-get-gpt-type

 part-get-gpt-type device partnum

Return the type GUID of numbered GPT partition C<partnum>. For MBR partitions,
return an appropriate GUID corresponding to the MBR type. Behaviour is undefined
for other partition types.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-get-mbr-id

 part-get-mbr-id device partnum

Returns the MBR type byte (also known as the ID byte) from
the numbered partition C<partnum>.

Note that only MBR (old DOS-style) partitions have type bytes.
You will get undefined results for other partition table
types (see L</part-get-parttype>).

=head2 part-get-mbr-part-type

 part-get-mbr-part-type device partnum

This returns the partition type of an MBR partition
numbered C<partnum> on device C<device>.

It returns C<primary>, C<logical>, or C<extended>.

=head2 part-get-name

 part-get-name device partnum

This gets the partition name on partition numbered C<partnum> on
device C<device>.  Note that partitions are numbered from 1.

The partition name can only be read on certain types of partition
table.  This works on C<gpt> but not on C<mbr> partitions.

=head2 part-get-parttype

 part-get-parttype device

This command examines the partition table on C<device> and
returns the partition table type (format) being used.

Common return values include: C<msdos> (a DOS/Windows style MBR
partition table), C<gpt> (a GPT/EFI-style partition table).  Other
values are possible, although unusual.  See L</part-init>
for a full list.

=head2 part-init

 part-init device parttype

This creates an empty partition table on C<device> of one of the
partition types listed below.  Usually C<parttype> should be
either C<msdos> or C<gpt> (for large disks).

Initially there are no partitions.  Following this, you should
call L</part-add> for each partition required.

Possible values for C<parttype> are:

=over 4

=item C<efi>

=item C<gpt>

Intel EFI / GPT partition table.

This is recommended for >= 2 TB partitions that will be accessed
from Linux and Intel-based Mac OS X.  It also has limited backwards
compatibility with the C<mbr> format.

=item C<mbr>

=item C<msdos>

The standard PC "Master Boot Record" (MBR) format used
by MS-DOS and Windows.  This partition type will B<only> work
for device sizes up to 2 TB.  For large disks we recommend
using C<gpt>.

=back

Other partition table types that may work but are not
supported include:

=over 4

=item C<aix>

AIX disk labels.

=item C<amiga>

=item C<rdb>

Amiga "Rigid Disk Block" format.

=item C<bsd>

BSD disk labels.

=item C<dasd>

DASD, used on IBM mainframes.

=item C<dvh>

MIPS/SGI volumes.

=item C<mac>

Old Mac partition format.  Modern Macs use C<gpt>.

=item C<pc98>

NEC PC-98 format, common in Japan apparently.

=item C<sun>

Sun disk labels.

=back

=head2 part-list

 part-list device

This command parses the partition table on C<device> and
returns the list of partitions found.

The fields in the returned structure are:

=over 4

=item C<part_num>

Partition number, counting from 1.

=item C<part_start>

Start of the partition I<in bytes>.  To get sectors you have to
divide by the device’s sector size, see L</blockdev-getss>.

=item C<part_end>

End of the partition in bytes.

=item C<part_size>

Size of the partition in bytes.

=back

=head2 part-resize

 part-resize device partnum endsect

This command resizes the partition numbered C<partnum> on C<device>
by moving the end position.

Note that this does not modify any filesystem present in the partition.
If you wish to do this, you will need to use filesystem resizing
commands like L</resize2fs>.

When growing a partition you will want to grow the filesystem
afterwards, but when shrinking, you need to shrink the filesystem
before the partition.

=head2 part-set-bootable

 part-set-bootable device partnum true|false

This sets the bootable flag on partition numbered C<partnum> on
device C<device>.  Note that partitions are numbered from 1.

The bootable flag is used by some operating systems (notably
Windows) to determine which partition to boot from.  It is by
no means universally recognized.

=head2 part-set-disk-guid

 part-set-disk-guid device guid

Set the disk identifier (GUID) of a GPT-partitioned C<device> to C<guid>.
Return an error if the partition table of C<device> isn't GPT,
or if C<guid> is not a valid GUID.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-set-disk-guid-random

 part-set-disk-guid-random device

Set the disk identifier (GUID) of a GPT-partitioned C<device> to
a randomly generated value.
Return an error if the partition table of C<device> isn't GPT.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-set-gpt-attributes

 part-set-gpt-attributes device partnum attributes

Set the attribute flags of numbered GPT partition C<partnum> to C<attributes>. Return an
error if the partition table of C<device> isn't GPT.

See L<https://en.wikipedia.org/wiki/GUID_Partition_Table#Partition_entries>
for a useful list of partition attributes.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-set-gpt-guid

 part-set-gpt-guid device partnum guid

Set the GUID of numbered GPT partition C<partnum> to C<guid>.  Return an
error if the partition table of C<device> isn't GPT, or if C<guid> is not a
valid GUID.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-set-gpt-type

 part-set-gpt-type device partnum guid

Set the type GUID of numbered GPT partition C<partnum> to C<guid>. Return an
error if the partition table of C<device> isn't GPT, or if C<guid> is not a
valid GUID.

See L<https://en.wikipedia.org/wiki/GUID_Partition_Table#Partition_type_GUIDs>
for a useful list of type GUIDs.

This command depends on the feature C<gdisk>.   See also
L</feature-available>.

=head2 part-set-mbr-id

 part-set-mbr-id device partnum idbyte

Sets the MBR type byte (also known as the ID byte) of
the numbered partition C<partnum> to C<idbyte>.  Note
that the type bytes quoted in most documentation are
in fact hexadecimal numbers, but usually documented
without any leading "0x" which might be confusing.

Note that only MBR (old DOS-style) partitions have type bytes.
You will get undefined results for other partition table
types (see L</part-get-parttype>).

=head2 part-set-name

 part-set-name device partnum name

This sets the partition name on partition numbered C<partnum> on
device C<device>.  Note that partitions are numbered from 1.

The partition name can only be set on certain types of partition
table.  This works on C<gpt> but not on C<mbr> partitions.

=head2 part-to-dev

 part-to-dev partition

This function takes a partition name (eg. "/dev/sdb1") and
removes the partition number, returning the device name
(eg. "/dev/sdb").

The named partition must exist, for example as a string returned
from L</list-partitions>.

See also L</part-to-partnum>, L</device-index>.

=head2 part-to-partnum

 part-to-partnum partition

This function takes a partition name (eg. "/dev/sdb1") and
returns the partition number (eg. C<1>).

The named partition must exist, for example as a string returned
from L</list-partitions>.

See also L</part-to-dev>.

=head2 ping-daemon

 ping-daemon

This is a test probe into the guestfs daemon running inside
the libguestfs appliance.  Calling this function checks that the
daemon responds to the ping message, without affecting the daemon
or attached block device(s) in any other way.

=head2 pread

 pread path count offset

This command lets you read part of a file.  It reads C<count>
bytes of the file, starting at C<offset>, from file C<path>.

This may read fewer bytes than requested.  For further details
see the L<pread(2)> system call.

See also L</pwrite>, L</pread-device>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 pread-device

 pread-device device count offset

This command lets you read part of a block device.  It reads C<count>
bytes of C<device>, starting at C<offset>.

This may read fewer bytes than requested.  For further details
see the L<pread(2)> system call.

See also L</pread>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 pvchange-uuid

 pvchange-uuid device

Generate a new random UUID for the physical volume C<device>.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 pvchange-uuid-all

 pvchange-uuid-all

Generate new random UUIDs for all physical volumes.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 pvcreate

 pvcreate device

This creates an LVM physical volume on the named C<device>,
where C<device> should usually be a partition name such
as F</dev/sda1>.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 pvremove

 pvremove device

This wipes a physical volume C<device> so that LVM will no longer
recognise it.

The implementation uses the L<pvremove(8)> command which refuses to
wipe physical volumes that contain any volume groups, so you have
to remove those first.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 pvresize

 pvresize device

This resizes (expands or shrinks) an existing LVM physical
volume to match the new size of the underlying device.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 pvresize-size

 pvresize-size device size

This command is the same as L</pvresize> except that it
allows you to specify the new size (in bytes) explicitly.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 pvs

 pvs

List all the physical volumes detected.  This is the equivalent
of the L<pvs(8)> command.

This returns a list of just the device names that contain
PVs (eg. F</dev/sda2>).

See also L</pvs-full>.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 pvs-full

 pvs-full

List all the physical volumes detected.  This is the equivalent
of the L<pvs(8)> command.  The "full" version includes all fields.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 pvuuid

 pvuuid device

This command returns the UUID of the LVM PV C<device>.

=head2 pwrite

 pwrite path content offset

This command writes to part of a file.  It writes the data
buffer C<content> to the file C<path> starting at offset C<offset>.

This command implements the L<pwrite(2)> system call, and like
that system call it may not write the full data requested.  The
return value is the number of bytes that were actually written
to the file.  This could even be 0, although short writes are
unlikely for regular files in ordinary circumstances.

See also L</pread>, L</pwrite-device>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 pwrite-device

 pwrite-device device content offset

This command writes to part of a device.  It writes the data
buffer C<content> to C<device> starting at offset C<offset>.

This command implements the L<pwrite(2)> system call, and like
that system call it may not write the full data requested
(although short writes to disk devices and partitions are
probably impossible with standard Linux kernels).

See also L</pwrite>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 read-file

 read-file path

This calls returns the contents of the file C<path> as a
buffer.

Unlike L</cat>, this function can correctly
handle files that contain embedded ASCII NUL characters.

=head2 read-lines

 read-lines path

Return the contents of the file named C<path>.

The file contents are returned as a list of lines.  Trailing
C<LF> and C<CRLF> character sequences are I<not> returned.

Note that this function cannot correctly handle binary files
(specifically, files containing C<\0> character which is treated
as end of string).  For those you need to use the L</read-file>
function and split the buffer into lines yourself.

=head2 readdir

 readdir dir

This returns the list of directory entries in directory C<dir>.

All entries in the directory are returned, including C<.> and
C<..>.  The entries are I<not> sorted, but returned in the same
order as the underlying filesystem.

Also this call returns basic file type information about each
file.  The C<ftyp> field will contain one of the following characters:

=over 4

=item 'b'

Block special

=item 'c'

Char special

=item 'd'

Directory

=item 'f'

FIFO (named pipe)

=item 'l'

Symbolic link

=item 'r'

Regular file

=item 's'

Socket

=item 'u'

Unknown file type

=item '?'

The L<readdir(3)> call returned a C<d_type> field with an
unexpected value

=back

This function is primarily intended for use by programs.  To
get a simple list of names, use L</ls>.  To get a printable
directory for human consumption, use L</ll>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 readlink

 readlink path

This command reads the target of a symbolic link.

=head2 readlinklist

 readlinklist path 'names ...'

This call allows you to do a C<readlink> operation
on multiple files, where all files are in the directory C<path>.
C<names> is the list of files from this directory.

On return you get a list of strings, with a one-to-one
correspondence to the C<names> list.  Each string is the
value of the symbolic link.

If the L<readlink(2)> operation fails on any name, then
the corresponding result string is the empty string C<"">.
However the whole operation is completed even if there
were L<readlink(2)> errors, and so you can call this
function with names where you don't know if they are
symbolic links already (albeit slightly less efficient).

This call is intended for programs that want to efficiently
list a directory contents without making many round-trips.

=head2 realpath

 realpath path

Return the canonicalized absolute pathname of C<path>.  The
returned path has no C<.>, C<..> or symbolic link path elements.

=head2 remount

 remount mountpoint [rw:true|false]

This call allows you to change the C<rw> (readonly/read-write)
flag on an already mounted filesystem at C<mountpoint>,
converting a readonly filesystem to be read-write, or vice-versa.

Note that at the moment you must supply the "optional" C<rw>
parameter.  In future we may allow other flags to be adjusted.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 remove-drive

 remove-drive label

This function is conceptually the opposite of L</add-drive-opts>.
It removes the drive that was previously added with label C<label>.

Note that in order to remove drives, you have to add them with
labels (see the optional C<label> argument to L</add-drive-opts>).
If you didn't use a label, then they cannot be removed.

You can call this function before or after launching the handle.
If called after launch, if the backend supports it, we try to hot
unplug the drive: see L<guestfs(3)/HOTPLUGGING>.  The disk B<must not>
be in use (eg. mounted) when you do this.  We try to detect if the
disk is in use and stop you from doing this.

=head2 removexattr

 removexattr xattr path

This call removes the extended attribute named C<xattr>
of the file C<path>.

See also: L</lremovexattr>, L<attr(5)>.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 rename

 rename oldpath newpath

Rename a file to a new place on the same filesystem.  This is
the same as the Linux L<rename(2)> system call.  In most cases
you are better to use L</mv> instead.

=head2 resize2fs

 resize2fs device

This resizes an ext2, ext3 or ext4 filesystem to match the size of
the underlying device.

See also L<guestfs(3)/RESIZE2FS ERRORS>.

=head2 resize2fs-M

 resize2fs-M device

This command is the same as L</resize2fs>, but the filesystem
is resized to its minimum size.  This works like the I<-M> option
to the L<resize2fs(8)> command.

To get the resulting size of the filesystem you should call
L</tune2fs-l> and read the C<Block size> and C<Block count>
values.  These two numbers, multiplied together, give the
resulting size of the minimal filesystem in bytes.

See also L<guestfs(3)/RESIZE2FS ERRORS>.

=head2 resize2fs-size

 resize2fs-size device size

This command is the same as L</resize2fs> except that it
allows you to specify the new size (in bytes) explicitly.

See also L<guestfs(3)/RESIZE2FS ERRORS>.

=head2 rm

 rm path

Remove the single file C<path>.

=head2 rm-f

 rm-f path

Remove the file C<path>.

If the file doesn't exist, that error is ignored.  (Other errors,
eg. I/O errors or bad paths, are not ignored)

This call cannot remove directories.
Use L</rmdir> to remove an empty directory,
or L</rm-rf> to remove directories recursively.

=head2 rm-rf

 rm-rf path

Remove the file or directory C<path>, recursively removing the
contents if its a directory.  This is like the C<rm -rf> shell
command.

=head2 rmdir

 rmdir path

Remove the single directory C<path>.

=head2 rmmountpoint

 rmmountpoint exemptpath

This call removes a mountpoint that was previously created
with L</mkmountpoint>.  See L</mkmountpoint>
for full details.

=head2 rsync

 rsync src dest [archive:true|false] [deletedest:true|false]

This call may be used to copy or synchronize two directories
under the same libguestfs handle.  This uses the L<rsync(1)>
program which uses a fast algorithm that avoids copying files
unnecessarily.

C<src> and C<dest> are the source and destination directories.
Files are copied from C<src> to C<dest>.

The optional arguments are:

=over 4

=item C<archive>

Turns on archive mode.  This is the same as passing the
I<--archive> flag to C<rsync>.

=item C<deletedest>

Delete files at the destination that do not exist at the source.

=back

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<rsync>.   See also
L</feature-available>.

=head2 rsync-in

 rsync-in remote dest [archive:true|false] [deletedest:true|false]

This call may be used to copy or synchronize the filesystem
on the host or on a remote computer with the filesystem
within libguestfs.  This uses the L<rsync(1)> program
which uses a fast algorithm that avoids copying files unnecessarily.

This call only works if the network is enabled.  See
L</set-network> or the I<--network> option to
various tools like L<guestfish(1)>.

Files are copied from the remote server and directory
specified by C<remote> to the destination directory C<dest>.

The format of the remote server string is defined by L<rsync(1)>.
Note that there is no way to supply a password or passphrase
so the target must be set up not to require one.

The optional arguments are the same as those of L</rsync>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<rsync>.   See also
L</feature-available>.

=head2 rsync-out

 rsync-out src remote [archive:true|false] [deletedest:true|false]

This call may be used to copy or synchronize the filesystem within
libguestfs with a filesystem on the host or on a remote computer.
This uses the L<rsync(1)> program which uses a fast algorithm that
avoids copying files unnecessarily.

This call only works if the network is enabled.  See
L</set-network> or the I<--network> option to
various tools like L<guestfish(1)>.

Files are copied from the source directory C<src> to the
remote server and directory specified by C<remote>.

The format of the remote server string is defined by L<rsync(1)>.
Note that there is no way to supply a password or passphrase
so the target must be set up not to require one.

The optional arguments are the same as those of L</rsync>.

Globbing does not happen on the C<src> parameter.  In programs
which use the API directly you have to expand wildcards yourself
(see L</glob-expand>).  In guestfish you can use the C<glob>
command (see L<guestfish(1)/glob>), for example:

 ><fs> glob rsync-out /* rsync://remote/

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<rsync>.   See also
L</feature-available>.

=head2 scrub-device

 scrub-device device

This command writes patterns over C<device> to make data retrieval
more difficult.

It is an interface to the L<scrub(1)> program.  See that
manual page for more details.

This command depends on the feature C<scrub>.   See also
L</feature-available>.

=head2 scrub-file

 scrub-file file

This command writes patterns over a file to make data retrieval
more difficult.

The file is I<removed> after scrubbing.

It is an interface to the L<scrub(1)> program.  See that
manual page for more details.

This command depends on the feature C<scrub>.   See also
L</feature-available>.

=head2 scrub-freespace

 scrub-freespace dir

This command creates the directory C<dir> and then fills it
with files until the filesystem is full, and scrubs the files
as for L</scrub-file>, and deletes them.
The intention is to scrub any free space on the partition
containing C<dir>.

It is an interface to the L<scrub(1)> program.  See that
manual page for more details.

This command depends on the feature C<scrub>.   See also
L</feature-available>.

=head2 selinux-relabel

 selinux-relabel specfile path [force:true|false]

SELinux relabel parts of the filesystem.

The C<specfile> parameter controls the policy spec file used.
You have to parse C</etc/selinux/config> to find the correct
SELinux policy and then pass the spec file, usually:
C</etc/selinux/> + I<selinuxtype> + C</contexts/files/file_contexts>.

The required C<path> parameter is the top level directory where
relabelling starts.  Normally you should pass C<path> as C</>
to relabel the whole guest filesystem.

The optional C<force> boolean controls whether the context
is reset for customizable files, and also whether the
user, role and range parts of the file context is changed.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<selinuxrelabel>.   See also
L</feature-available>.

=head2 set-append

=head2 append

 set-append append

This function is used to add additional options to the
libguestfs appliance kernel command line.

The default is C<NULL> unless overridden by setting
C<LIBGUESTFS_APPEND> environment variable.

Setting C<append> to C<NULL> means I<no> additional options
are passed (libguestfs always adds a few of its own).

=head2 set-attach-method

=head2 attach-method

 set-attach-method backend

Set the method that libguestfs uses to connect to the backend
guestfsd daemon.

See L<guestfs(3)/BACKEND>.

I<This function is deprecated.>
In new code, use the L</set-backend> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 set-autosync

=head2 autosync

 set-autosync true|false

If C<autosync> is true, this enables autosync.  Libguestfs will make a
best effort attempt to make filesystems consistent and synchronized
when the handle is closed
(also if the program exits without closing handles).

This is enabled by default (since libguestfs 1.5.24, previously it was
disabled by default).

=head2 set-backend

=head2 backend

 set-backend backend

Set the method that libguestfs uses to connect to the backend
guestfsd daemon.

This handle property was previously called the "attach method".

See L<guestfs(3)/BACKEND>.

=head2 set-backend-setting

 set-backend-setting name val

Append C<"name=value"> to the backend settings string list.
However if a string already exists matching C<"name">
or beginning with C<"name=">, then that setting is replaced.

See L<guestfs(3)/BACKEND>, L<guestfs(3)/BACKEND SETTINGS>.

=head2 set-backend-settings

 set-backend-settings 'settings ...'

Set a list of zero or more settings which are passed through to
the current backend.  Each setting is a string which is interpreted
in a backend-specific way, or ignored if not understood by the
backend.

The default value is an empty list, unless the environment
variable C<LIBGUESTFS_BACKEND_SETTINGS> was set when the handle
was created.  This environment variable contains a colon-separated
list of settings.

This call replaces all backend settings.  If you want to replace
a single backend setting, see L</set-backend-setting>.
If you want to clear a single backend setting, see
L</clear-backend-setting>.

See L<guestfs(3)/BACKEND>, L<guestfs(3)/BACKEND SETTINGS>.

=head2 set-cachedir

=head2 cachedir

 set-cachedir cachedir

Set the directory used by the handle to store the appliance
cache, when using a supermin appliance.  The appliance is
cached and shared between all handles which have the same
effective user ID.

The environment variables C<LIBGUESTFS_CACHEDIR> and C<TMPDIR>
control the default value: If C<LIBGUESTFS_CACHEDIR> is set, then
that is the default.  Else if C<TMPDIR> is set, then that is
the default.  Else F</var/tmp> is the default.

=head2 set-direct

=head2 direct

 set-direct true|false

If the direct appliance mode flag is enabled, then stdin and
stdout are passed directly through to the appliance once it
is launched.

One consequence of this is that log messages aren't caught
by the library and handled by L</set-log-message-callback>,
but go straight to stdout.

You probably don't want to use this unless you know what you
are doing.

The default is disabled.

I<This function is deprecated.>
In new code, use the L</internal-get-console-socket> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 set-e2attrs

 set-e2attrs file attrs [clear:true|false]

This sets or clears the file attributes C<attrs>
associated with the inode F<file>.

C<attrs> is a string of characters representing
file attributes.  See L</get-e2attrs> for a list of
possible attributes.  Not all attributes can be changed.

If optional boolean C<clear> is not present or false, then
the C<attrs> listed are set in the inode.

If C<clear> is true, then the C<attrs> listed are cleared
in the inode.

In both cases, other attributes not present in the C<attrs>
string are left unchanged.

These attributes are only present when the file is located on
an ext2/3/4 filesystem.  Using this call on other filesystem
types will result in an error.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 set-e2generation

 set-e2generation file generation

This sets the ext2 file generation of a file.

See L</get-e2generation>.

=head2 set-e2label

 set-e2label device label

This sets the ext2/3/4 filesystem label of the filesystem on
C<device> to C<label>.  Filesystem labels are limited to
16 characters.

You can use either L</tune2fs-l> or L</get-e2label>
to return the existing label on a filesystem.

I<This function is deprecated.>
In new code, use the L</set-label> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 set-e2uuid

 set-e2uuid device uuid

This sets the ext2/3/4 filesystem UUID of the filesystem on
C<device> to C<uuid>.  The format of the UUID and alternatives
such as C<clear>, C<random> and C<time> are described in the
L<tune2fs(8)> manpage.

You can use L</vfs-uuid> to return the existing UUID
of a filesystem.

I<This function is deprecated.>
In new code, use the L</set-uuid> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 set-hv

=head2 hv

 set-hv hv

Set the hypervisor binary that we will use.  The hypervisor
depends on the backend, but is usually the location of the
qemu/KVM hypervisor.  For the uml backend, it is the location
of the C<linux> or C<vmlinux> binary.

The default is chosen when the library was compiled by the
configure script.

You can also override this by setting the C<LIBGUESTFS_HV>
environment variable.

Note that you should call this function as early as possible
after creating the handle.  This is because some pre-launch
operations depend on testing qemu features (by running C<qemu -help>).
If the qemu binary changes, we don't retest features, and
so you might see inconsistent results.  Using the environment
variable C<LIBGUESTFS_HV> is safest of all since that picks
the qemu binary at the same time as the handle is created.

=head2 set-identifier

=head2 identifier

 set-identifier identifier

This is an informative string which the caller may optionally
set in the handle.  It is printed in various places, allowing
the current handle to be identified in debugging output.

One important place is when tracing is enabled.  If the
identifier string is not an empty string, then trace messages
change from this:

 libguestfs: trace: get_tmpdir
 libguestfs: trace: get_tmpdir = "/tmp"

to this:

 libguestfs: trace: ID: get_tmpdir
 libguestfs: trace: ID: get_tmpdir = "/tmp"

where C<ID> is the identifier string set by this call.

The identifier must only contain alphanumeric ASCII characters,
underscore and minus sign.  The default is the empty string.

See also L</set-program>, L</set-trace>,
L</get-identifier>.

=head2 set-label

 set-label mountable label

Set the filesystem label on C<mountable> to C<label>.

Only some filesystem types support labels, and libguestfs supports
setting labels on only a subset of these.

=over 4

=item ext2, ext3, ext4

Labels are limited to 16 bytes.

=item NTFS

Labels are limited to 128 unicode characters.

=item XFS

The label is limited to 12 bytes.  The filesystem must not
be mounted when trying to set the label.

=item btrfs

The label is limited to 255 bytes and some characters are
not allowed.  Setting the label on a btrfs subvolume will set the
label on its parent filesystem.  The filesystem must not be mounted
when trying to set the label.

=item fat

The label is limited to 11 bytes.

=item swap

The label is limited to 16 bytes.

=back

If there is no support for changing the label
for the type of the specified filesystem,
set_label will fail and set errno as ENOTSUP.

To read the label on a filesystem, call L</vfs-label>.

=head2 set-libvirt-requested-credential

 set-libvirt-requested-credential index cred

After requesting the C<index>'th credential from the user,
call this function to pass the answer back to libvirt.

See L<guestfs(3)/LIBVIRT AUTHENTICATION> for documentation and example code.

=head2 set-libvirt-supported-credentials

 set-libvirt-supported-credentials 'creds ...'

Call this function before setting an event handler for
C<GUESTFS_EVENT_LIBVIRT_AUTH>, to supply the list of credential types
that the program knows how to process.

The C<creds> list must be a non-empty list of strings.
Possible strings are:

=over 4

=item C<username>

=item C<authname>

=item C<language>

=item C<cnonce>

=item C<passphrase>

=item C<echoprompt>

=item C<noechoprompt>

=item C<realm>

=item C<external>

=back

See libvirt documentation for the meaning of these credential types.

See L<guestfs(3)/LIBVIRT AUTHENTICATION> for documentation and example code.

=head2 set-memsize

=head2 memsize

 set-memsize memsize

This sets the memory size in megabytes allocated to the
hypervisor.  This only has any effect if called before
L</launch>.

You can also change this by setting the environment
variable C<LIBGUESTFS_MEMSIZE> before the handle is
created.

For more information on the architecture of libguestfs,
see L<guestfs(3)>.

=head2 set-network

=head2 network

 set-network true|false

If C<network> is true, then the network is enabled in the
libguestfs appliance.  The default is false.

This affects whether commands are able to access the network
(see L<guestfs(3)/RUNNING COMMANDS>).

You must call this before calling L</launch>, otherwise
it has no effect.

=head2 set-path

=head2 path

 set-path searchpath

Set the path that libguestfs searches for kernel and initrd.img.

The default is C<$libdir/guestfs> unless overridden by setting
C<LIBGUESTFS_PATH> environment variable.

Setting C<path> to C<NULL> restores the default path.

=head2 set-pgroup

=head2 pgroup

 set-pgroup true|false

If C<pgroup> is true, child processes are placed into
their own process group.

The practical upshot of this is that signals like C<SIGINT> (from
users pressing C<^C>) won't be received by the child process.

The default for this flag is false, because usually you want
C<^C> to kill the subprocess.  Guestfish sets this flag to
true when used interactively, so that C<^C> can cancel
long-running commands gracefully (see L</user-cancel>).

=head2 set-program

=head2 program

 set-program program

Set the program name.  This is an informative string which the
main program may optionally set in the handle.

When the handle is created, the program name in the handle is
set to the basename from C<argv[0]>.  The program name can never
be C<NULL>.

=head2 set-qemu

=head2 qemu

 set-qemu hv

Set the hypervisor binary (usually qemu) that we will use.

The default is chosen when the library was compiled by the
configure script.

You can also override this by setting the C<LIBGUESTFS_HV>
environment variable.

Setting C<hv> to C<NULL> restores the default qemu binary.

Note that you should call this function as early as possible
after creating the handle.  This is because some pre-launch
operations depend on testing qemu features (by running C<qemu -help>).
If the qemu binary changes, we don't retest features, and
so you might see inconsistent results.  Using the environment
variable C<LIBGUESTFS_HV> is safest of all since that picks
the qemu binary at the same time as the handle is created.

I<This function is deprecated.>
In new code, use the L</set-hv> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 set-recovery-proc

=head2 recovery-proc

 set-recovery-proc true|false

If this is called with the parameter C<false> then
L</launch> does not create a recovery process.  The
purpose of the recovery process is to stop runaway hypervisor
processes in the case where the main program aborts abruptly.

This only has any effect if called before L</launch>,
and the default is true.

About the only time when you would want to disable this is
if the main process will fork itself into the background
("daemonize" itself).  In this case the recovery process
thinks that the main program has disappeared and so kills
the hypervisor, which is not very helpful.

=head2 set-selinux

=head2 selinux

 set-selinux true|false

This sets the selinux flag that is passed to the appliance
at boot time.  The default is C<selinux=0> (disabled).

Note that if SELinux is enabled, it is always in
Permissive mode (C<enforcing=0>).

For more information on the architecture of libguestfs,
see L<guestfs(3)>.

I<This function is deprecated.>
In new code, use the L</selinux-relabel> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 set-smp

=head2 smp

 set-smp smp

Change the number of virtual CPUs assigned to the appliance.  The
default is C<1>.  Increasing this may improve performance, though
often it has no effect.

This function must be called before L</launch>.

=head2 set-tmpdir

=head2 tmpdir

 set-tmpdir tmpdir

Set the directory used by the handle to store temporary files.

The environment variables C<LIBGUESTFS_TMPDIR> and C<TMPDIR>
control the default value: If C<LIBGUESTFS_TMPDIR> is set, then
that is the default.  Else if C<TMPDIR> is set, then that is
the default.  Else F</tmp> is the default.

=head2 set-trace

=head2 trace

 set-trace true|false

If the command trace flag is set to 1, then libguestfs
calls, parameters and return values are traced.

If you want to trace C API calls into libguestfs (and
other libraries) then possibly a better way is to use
the external L<ltrace(1)> command.

Command traces are disabled unless the environment variable
C<LIBGUESTFS_TRACE> is defined and set to C<1>.

Trace messages are normally sent to C<stderr>, unless you
register a callback to send them somewhere else (see
L</set-event-callback>).

=head2 set-uuid

 set-uuid device uuid

Set the filesystem UUID on C<device> to C<uuid>.
If this fails and the errno is ENOTSUP,
means that there is no support for changing the UUID
for the type of the specified filesystem.

Only some filesystem types support setting UUIDs.

To read the UUID on a filesystem, call L</vfs-uuid>.

=head2 set-uuid-random

 set-uuid-random device

Set the filesystem UUID on C<device> to a random UUID.
If this fails and the errno is ENOTSUP,
means that there is no support for changing the UUID
for the type of the specified filesystem.

Only some filesystem types support setting UUIDs.

To read the UUID on a filesystem, call L</vfs-uuid>.

=head2 set-verbose

=head2 verbose

 set-verbose true|false

If C<verbose> is true, this turns on verbose messages.

Verbose messages are disabled unless the environment variable
C<LIBGUESTFS_DEBUG> is defined and set to C<1>.

Verbose messages are normally sent to C<stderr>, unless you
register a callback to send them somewhere else (see
L</set-event-callback>).

=head2 setcon

 setcon context

This sets the SELinux security context of the daemon
to the string C<context>.

See the documentation about SELINUX in L<guestfs(3)>.

I<This function is deprecated.>
In new code, use the L</selinux-relabel> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<selinux>.   See also
L</feature-available>.

=head2 setxattr

 setxattr xattr val vallen path

This call sets the extended attribute named C<xattr>
of the file C<path> to the value C<val> (of length C<vallen>).
The value is arbitrary 8 bit data.

See also: L</lsetxattr>, L<attr(5)>.

This command depends on the feature C<linuxxattrs>.   See also
L</feature-available>.

=head2 sfdisk

 sfdisk device cyls heads sectors 'lines ...'

This is a direct interface to the L<sfdisk(8)> program for creating
partitions on block devices.

C<device> should be a block device, for example F</dev/sda>.

C<cyls>, C<heads> and C<sectors> are the number of cylinders, heads
and sectors on the device, which are passed directly to L<sfdisk(8)>
as the I<-C>, I<-H> and I<-S> parameters.  If you pass C<0> for any
of these, then the corresponding parameter is omitted.  Usually for
‘large’ disks, you can just pass C<0> for these, but for small
(floppy-sized) disks, L<sfdisk(8)> (or rather, the kernel) cannot work
out the right geometry and you will need to tell it.

C<lines> is a list of lines that we feed to L<sfdisk(8)>.  For more
information refer to the L<sfdisk(8)> manpage.

To create a single partition occupying the whole disk, you would
pass C<lines> as a single element list, when the single element being
the string C<,> (comma).

See also: L</sfdisk-l>, L</sfdisk-N>,
L</part-init>

I<This function is deprecated.>
In new code, use the L</part-add> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 sfdiskM

 sfdiskM device 'lines ...'

This is a simplified interface to the L</sfdisk>
command, where partition sizes are specified in megabytes
only (rounded to the nearest cylinder) and you don't need
to specify the cyls, heads and sectors parameters which
were rarely if ever used anyway.

See also: L</sfdisk>, the L<sfdisk(8)> manpage
and L</part-disk>

I<This function is deprecated.>
In new code, use the L</part-add> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 sfdisk-N

 sfdisk-N device partnum cyls heads sectors line

This runs L<sfdisk(8)> option to modify just the single
partition C<n> (note: C<n> counts from 1).

For other parameters, see L</sfdisk>.  You should usually
pass C<0> for the cyls/heads/sectors parameters.

See also: L</part-add>

I<This function is deprecated.>
In new code, use the L</part-add> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 sfdisk-disk-geometry

 sfdisk-disk-geometry device

This displays the disk geometry of C<device> read from the
partition table.  Especially in the case where the underlying
block device has been resized, this can be different from the
kernel’s idea of the geometry (see L</sfdisk-kernel-geometry>).

The result is in human-readable format, and not designed to
be parsed.

=head2 sfdisk-kernel-geometry

 sfdisk-kernel-geometry device

This displays the kernel’s idea of the geometry of C<device>.

The result is in human-readable format, and not designed to
be parsed.

=head2 sfdisk-l

 sfdisk-l device

This displays the partition table on C<device>, in the
human-readable output of the L<sfdisk(8)> command.  It is
not intended to be parsed.

See also: L</part-list>

I<This function is deprecated.>
In new code, use the L</part-list> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 sh

 sh command

This call runs a command from the guest filesystem via the
guest’s F</bin/sh>.

This is like L</command>, but passes the command to:

 /bin/sh -c "command"

Depending on the guest’s shell, this usually results in
wildcards being expanded, shell expressions being interpolated
and so on.

All the provisos about L</command> apply to this call.

=head2 sh-lines

 sh-lines command

This is the same as L</sh>, but splits the result
into a list of lines.

See also: L</command-lines>

=head2 shutdown

 shutdown

This is the opposite of L</launch>.  It performs an orderly
shutdown of the backend process(es).  If the autosync flag is set
(which is the default) then the disk image is synchronized.

If the subprocess exits with an error then this function will return
an error, which should I<not> be ignored (it may indicate that the
disk image could not be written out properly).

It is safe to call this multiple times.  Extra calls are ignored.

This call does I<not> close or free up the handle.  You still
need to call L</close> afterwards.

L</close> will call this if you don't do it explicitly,
but note that any errors are ignored in that case.

=head2 sleep

 sleep secs

Sleep for C<secs> seconds.

=head2 stat

 stat path

Returns file information for the given C<path>.

This is the same as the L<stat(2)> system call.

I<This function is deprecated.>
In new code, use the L</statns> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 statns

 statns path

Returns file information for the given C<path>.

This is the same as the L<stat(2)> system call.

=head2 statvfs

 statvfs path

Returns file system statistics for any mounted file system.
C<path> should be a file or directory in the mounted file system
(typically it is the mount point itself, but it doesn't need to be).

This is the same as the L<statvfs(2)> system call.

=head2 strings

 strings path

This runs the L<strings(1)> command on a file and returns
the list of printable strings found.

The C<strings> command has, in the past, had problems with
parsing untrusted files.  These are mitigated in the current
version of libguestfs, but see L<guestfs(3)/CVE-2014-8484>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 strings-e

 strings-e encoding path

This is like the L</strings> command, but allows you to
specify the encoding of strings that are looked for in
the source file C<path>.

Allowed encodings are:

=over 4

=item s

Single 7-bit-byte characters like ASCII and the ASCII-compatible
parts of ISO-8859-X (this is what L</strings> uses).

=item S

Single 8-bit-byte characters.

=item b

16-bit big endian strings such as those encoded in
UTF-16BE or UCS-2BE.

=item l (lower case letter L)

16-bit little endian such as UTF-16LE and UCS-2LE.
This is useful for examining binaries in Windows guests.

=item B

32-bit big endian such as UCS-4BE.

=item L

32-bit little endian such as UCS-4LE.

=back

The returned strings are transcoded to UTF-8.

The C<strings> command has, in the past, had problems with
parsing untrusted files.  These are mitigated in the current
version of libguestfs, but see L<guestfs(3)/CVE-2014-8484>.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 swapoff-device

 swapoff-device device

This command disables the libguestfs appliance swap
device or partition named C<device>.
See L</swapon-device>.

=head2 swapoff-file

 swapoff-file file

This command disables the libguestfs appliance swap on file.

=head2 swapoff-label

 swapoff-label label

This command disables the libguestfs appliance swap on
labeled swap partition.

=head2 swapoff-uuid

 swapoff-uuid uuid

This command disables the libguestfs appliance swap partition
with the given UUID.

This command depends on the feature C<linuxfsuuid>.   See also
L</feature-available>.

=head2 swapon-device

 swapon-device device

This command enables the libguestfs appliance to use the
swap device or partition named C<device>.  The increased
memory is made available for all commands, for example
those run using L</command> or L</sh>.

Note that you should not swap to existing guest swap
partitions unless you know what you are doing.  They may
contain hibernation information, or other information that
the guest doesn't want you to trash.  You also risk leaking
information about the host to the guest this way.  Instead,
attach a new host device to the guest and swap on that.

=head2 swapon-file

 swapon-file file

This command enables swap to a file.
See L</swapon-device> for other notes.

=head2 swapon-label

 swapon-label label

This command enables swap to a labeled swap partition.
See L</swapon-device> for other notes.

=head2 swapon-uuid

 swapon-uuid uuid

This command enables swap to a swap partition with the given UUID.
See L</swapon-device> for other notes.

This command depends on the feature C<linuxfsuuid>.   See also
L</feature-available>.

=head2 sync

 sync

This syncs the disk, so that any writes are flushed through to the
underlying disk image.

You should always call this if you have modified a disk image, before
closing the handle.

=head2 syslinux

 syslinux device [directory:..]

Install the SYSLINUX bootloader on C<device>.

The device parameter must be either a whole disk formatted
as a FAT filesystem, or a partition formatted as a FAT filesystem.
In the latter case, the partition should be marked as "active"
(L</part-set-bootable>) and a Master Boot Record must be
installed (eg. using L</pwrite-device>) on the first
sector of the whole disk.
The SYSLINUX package comes with some suitable Master Boot Records.
See the L<syslinux(1)> man page for further information.

The optional arguments are:

=over 4

=item F<directory>

Install SYSLINUX in the named subdirectory, instead of in the
root directory of the FAT filesystem.

=back

Additional configuration can be supplied to SYSLINUX by
placing a file called F<syslinux.cfg> on the FAT filesystem,
either in the root directory, or under F<directory> if that
optional argument is being used.  For further information
about the contents of this file, see L<syslinux(1)>.

See also L</extlinux>.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<syslinux>.   See also
L</feature-available>.

=head2 tail

 tail path

This command returns up to the last 10 lines of a file as
a list of strings.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 tail-n

 tail-n nrlines path

If the parameter C<nrlines> is a positive number, this returns the last
C<nrlines> lines of the file C<path>.

If the parameter C<nrlines> is a negative number, this returns lines
from the file C<path>, starting with the C<-nrlines>'th line.

If the parameter C<nrlines> is zero, this returns an empty list.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

=head2 tar-in

=head2 tar-in-opts

 tar-in (tarfile|-) directory [compress:..] [xattrs:true|false] [selinux:true|false] [acls:true|false]

This command uploads and unpacks local file C<tarfile> into F<directory>.

The optional C<compress> flag controls compression.  If not given,
then the input should be an uncompressed tar file.  Otherwise one
of the following strings may be given to select the compression
type of the input file: C<compress>, C<gzip>, C<bzip2>, C<xz>, C<lzop>.
(Note that not all builds of libguestfs will support all of these
compression types).

The other optional arguments are:

=over 4

=item C<xattrs>

If set to true, extended attributes are restored from the tar file.

=item C<selinux>

If set to true, SELinux contexts are restored from the tar file.

=item C<acls>

If set to true, POSIX ACLs are restored from the tar file.

=back

Use C<-> instead of a filename to read/write from stdin/stdout.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 tar-out

=head2 tar-out-opts

 tar-out directory (tarfile|-) [compress:..] [numericowner:true|false] [excludes:..] [xattrs:true|false] [selinux:true|false] [acls:true|false]

This command packs the contents of F<directory> and downloads
it to local file C<tarfile>.

The optional C<compress> flag controls compression.  If not given,
then the output will be an uncompressed tar file.  Otherwise one
of the following strings may be given to select the compression
type of the output file: C<compress>, C<gzip>, C<bzip2>, C<xz>, C<lzop>.
(Note that not all builds of libguestfs will support all of these
compression types).

The other optional arguments are:

=over 4

=item C<excludes>

A list of wildcards.  Files are excluded if they match any of the
wildcards.

=item C<numericowner>

If set to true, the output tar file will contain UID/GID numbers
instead of user/group names.

=item C<xattrs>

If set to true, extended attributes are saved in the output tar.

=item C<selinux>

If set to true, SELinux contexts are saved in the output tar.

=item C<acls>

If set to true, POSIX ACLs are saved in the output tar.

=back

Use C<-> instead of a filename to read/write from stdin/stdout.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 tgz-in

 tgz-in (tarball|-) directory

This command uploads and unpacks local file C<tarball> (a
I<gzip compressed> tar file) into F<directory>.

Use C<-> instead of a filename to read/write from stdin/stdout.

I<This function is deprecated.>
In new code, use the L</tar-in> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 tgz-out

 tgz-out directory (tarball|-)

This command packs the contents of F<directory> and downloads
it to local file C<tarball>.

Use C<-> instead of a filename to read/write from stdin/stdout.

I<This function is deprecated.>
In new code, use the L</tar-out> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 touch

 touch path

Touch acts like the L<touch(1)> command.  It can be used to
update the timestamps on a file, or, if the file does not exist,
to create a new zero-length file.

This command only works on regular files, and will fail on other
file types such as directories, symbolic links, block special etc.

=head2 truncate

 truncate path

This command truncates C<path> to a zero-length file.  The
file must exist already.

=head2 truncate-size

 truncate-size path size

This command truncates C<path> to size C<size> bytes.  The file
must exist already.

If the current file size is less than C<size> then
the file is extended to the required size with zero bytes.
This creates a sparse file (ie. disk blocks are not allocated
for the file until you write to it).  To create a non-sparse
file of zeroes, use L</fallocate64> instead.

=head2 tune2fs

 tune2fs device [force:true|false] [maxmountcount:N] [mountcount:N] [errorbehavior:..] [group:N] [intervalbetweenchecks:N] [reservedblockspercentage:N] [lastmounteddirectory:..] [reservedblockscount:N] [user:N]

This call allows you to adjust various filesystem parameters of
an ext2/ext3/ext4 filesystem called C<device>.

The optional parameters are:

=over 4

=item C<force>

Force tune2fs to complete the operation even in the face of errors.
This is the same as the L<tune2fs(8)> C<-f> option.

=item C<maxmountcount>

Set the number of mounts after which the filesystem is checked
by L<e2fsck(8)>.  If this is C<0> then the number of mounts is
disregarded.  This is the same as the L<tune2fs(8)> C<-c> option.

=item C<mountcount>

Set the number of times the filesystem has been mounted.
This is the same as the L<tune2fs(8)> C<-C> option.

=item C<errorbehavior>

Change the behavior of the kernel code when errors are detected.
Possible values currently are: C<continue>, C<remount-ro>, C<panic>.
In practice these options don't really make any difference,
particularly for write errors.

This is the same as the L<tune2fs(8)> C<-e> option.

=item C<group>

Set the group which can use reserved filesystem blocks.
This is the same as the L<tune2fs(8)> C<-g> option except that it
can only be specified as a number.

=item C<intervalbetweenchecks>

Adjust the maximal time between two filesystem checks
(in seconds).  If the option is passed as C<0> then
time-dependent checking is disabled.

This is the same as the L<tune2fs(8)> C<-i> option.

=item C<reservedblockspercentage>

Set the percentage of the filesystem which may only be allocated
by privileged processes.
This is the same as the L<tune2fs(8)> C<-m> option.

=item C<lastmounteddirectory>

Set the last mounted directory.
This is the same as the L<tune2fs(8)> C<-M> option.

=item C<reservedblockscount>
Set the number of reserved filesystem blocks.
This is the same as the L<tune2fs(8)> C<-r> option.

=item C<user>

Set the user who can use the reserved filesystem blocks.
This is the same as the L<tune2fs(8)> C<-u> option except that it
can only be specified as a number.

=back

To get the current values of filesystem parameters, see
L</tune2fs-l>.  For precise details of how tune2fs
works, see the L<tune2fs(8)> man page.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 tune2fs-l

 tune2fs-l device

This returns the contents of the ext2, ext3 or ext4 filesystem
superblock on C<device>.

It is the same as running C<tune2fs -l device>.  See L<tune2fs(8)>
manpage for more details.  The list of fields returned isn't
clearly defined, and depends on both the version of C<tune2fs>
that libguestfs was built against, and the filesystem itself.

=head2 txz-in

 txz-in (tarball|-) directory

This command uploads and unpacks local file C<tarball> (an
I<xz compressed> tar file) into F<directory>.

Use C<-> instead of a filename to read/write from stdin/stdout.

I<This function is deprecated.>
In new code, use the L</tar-in> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<xz>.   See also
L</feature-available>.

=head2 txz-out

 txz-out directory (tarball|-)

This command packs the contents of F<directory> and downloads
it to local file C<tarball> (as an xz compressed tar archive).

Use C<-> instead of a filename to read/write from stdin/stdout.

I<This function is deprecated.>
In new code, use the L</tar-out> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

This command depends on the feature C<xz>.   See also
L</feature-available>.

=head2 umask

 umask mask

This function sets the mask used for creating new files and
device nodes to C<mask & 0777>.

Typical umask values would be C<022> which creates new files
with permissions like "-rw-r--r--" or "-rwxr-xr-x", and
C<002> which creates new files with permissions like
"-rw-rw-r--" or "-rwxrwxr-x".

The default umask is C<022>.  This is important because it
means that directories and device nodes will be created with
C<0644> or C<0755> mode even if you specify C<0777>.

See also L</get-umask>,
L<umask(2)>, L</mknod>, L</mkdir>.

This call returns the previous umask.

=head2 umount

=head2 unmount

=head2 umount-opts

 umount pathordevice [force:true|false] [lazyunmount:true|false]

This unmounts the given filesystem.  The filesystem may be
specified either by its mountpoint (path) or the device which
contains the filesystem.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 umount-all

=head2 unmount-all

 umount-all

This unmounts all mounted filesystems.

Some internal mounts are not unmounted by this call.

=head2 umount-local

 umount-local [retry:true|false]

If libguestfs is exporting the filesystem on a local
mountpoint, then this unmounts it.

See L<guestfs(3)/MOUNT LOCAL> for full documentation.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

=head2 upload

 upload (filename|-) remotefilename

Upload local file F<filename> to F<remotefilename> on the
filesystem.

F<filename> can also be a named pipe.

See also L</download>.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 upload-offset

 upload-offset (filename|-) remotefilename offset

Upload local file F<filename> to F<remotefilename> on the
filesystem.

F<remotefilename> is overwritten starting at the byte C<offset>
specified.  The intention is to overwrite parts of existing
files or devices, although if a non-existent file is specified
then it is created with a "hole" before C<offset>.  The
size of the data written is implicit in the size of the
source F<filename>.

Note that there is no limit on the amount of data that
can be uploaded with this call, unlike with L</pwrite>,
and this call always writes the full amount unless an
error occurs.

See also L</upload>, L</pwrite>.

Use C<-> instead of a filename to read/write from stdin/stdout.

=head2 user-cancel

 user-cancel

This function cancels the current upload or download operation.

Unlike most other libguestfs calls, this function is signal safe and
thread safe.  You can call it from a signal handler or from another
thread, without needing to do any locking.

The transfer that was in progress (if there is one) will stop shortly
afterwards, and will return an error.  The errno (see
L</guestfs_last_errno>) is set to C<EINTR>, so you can test for this
to find out if the operation was cancelled or failed because of
another error.

No cleanup is performed: for example, if a file was being uploaded
then after cancellation there may be a partially uploaded file.  It is
the caller’s responsibility to clean up if necessary.

There are two common places that you might call L</user-cancel>:

In an interactive text-based program, you might call it from a
C<SIGINT> signal handler so that pressing C<^C> cancels the current
operation.  (You also need to call L</set-pgroup> so that
child processes don't receive the C<^C> signal).

In a graphical program, when the main thread is displaying a progress
bar with a cancel button, wire up the cancel button to call this
function.

=head2 utimens

 utimens path atsecs atnsecs mtsecs mtnsecs

This command sets the timestamps of a file with nanosecond
precision.

C<atsecs>, C<atnsecs> are the last access time (atime) in secs and
nanoseconds from the epoch.

C<mtsecs>, C<mtnsecs> are the last modification time (mtime) in
secs and nanoseconds from the epoch.

If the C<*nsecs> field contains the special value C<-1> then
the corresponding timestamp is set to the current time.  (The
C<*secs> field is ignored in this case).

If the C<*nsecs> field contains the special value C<-2> then
the corresponding timestamp is left unchanged.  (The
C<*secs> field is ignored in this case).

=head2 utsname

 utsname

This returns the kernel version of the appliance, where this is
available.  This information is only useful for debugging.  Nothing
in the returned structure is defined by the API.

=head2 version

 version

Return the libguestfs version number that the program is linked
against.

Note that because of dynamic linking this is not necessarily
the version of libguestfs that you compiled against.  You can
compile the program, and then at runtime dynamically link
against a completely different F<libguestfs.so> library.

This call was added in version C<1.0.58>.  In previous
versions of libguestfs there was no way to get the version
number.  From C code you can use dynamic linker functions
to find out if this symbol exists (if it doesn't, then
it’s an earlier version).

The call returns a structure with four elements.  The first
three (C<major>, C<minor> and C<release>) are numbers and
correspond to the usual version triplet.  The fourth element
(C<extra>) is a string and is normally empty, but may be
used for distro-specific information.

To construct the original version string:
C<$major.$minor.$release$extra>

See also: L<guestfs(3)/LIBGUESTFS VERSION NUMBERS>.

I<Note:> Don't use this call to test for availability
of features.  In enterprise distributions we backport
features from later versions into earlier versions,
making this an unreliable way to test for features.
Use L</available> or L</feature-available> instead.

=head2 vfs-label

 vfs-label mountable

This returns the label of the filesystem on C<mountable>.

If the filesystem is unlabeled, this returns the empty string.

To find a filesystem from the label, use L</findfs-label>.

=head2 vfs-minimum-size

 vfs-minimum-size mountable

Get the minimum size of filesystem in bytes.
This is the minimum possible size for filesystem shrinking.

If getting minimum size of specified filesystem is not supported,
this will fail and set errno as ENOTSUP.

See also L<ntfsresize(8)>, L<resize2fs(8)>, L<btrfs(8)>, L<xfs_info(8)>.

=head2 vfs-type

 vfs-type mountable

This command gets the filesystem type corresponding to
the filesystem on C<mountable>.

For most filesystems, the result is the name of the Linux
VFS module which would be used to mount this filesystem
if you mounted it without specifying the filesystem type.
For example a string such as C<ext3> or C<ntfs>.

=head2 vfs-uuid

=head2 get-uuid

 vfs-uuid mountable

This returns the filesystem UUID of the filesystem on C<mountable>.

If the filesystem does not have a UUID, this returns the empty string.

To find a filesystem from the UUID, use L</findfs-uuid>.

=head2 vg-activate

 vg-activate true|false 'volgroups ...'

This command activates or (if C<activate> is false) deactivates
all logical volumes in the listed volume groups C<volgroups>.

This command is the same as running C<vgchange -a y|n volgroups...>

Note that if C<volgroups> is an empty list then B<all> volume groups
are activated or deactivated.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vg-activate-all

 vg-activate-all true|false

This command activates or (if C<activate> is false) deactivates
all logical volumes in all volume groups.

This command is the same as running C<vgchange -a y|n>

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vgchange-uuid

 vgchange-uuid vg

Generate a new random UUID for the volume group C<vg>.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vgchange-uuid-all

 vgchange-uuid-all

Generate new random UUIDs for all volume groups.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vgcreate

 vgcreate volgroup 'physvols ...'

This creates an LVM volume group called C<volgroup>
from the non-empty list of physical volumes C<physvols>.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vglvuuids

 vglvuuids vgname

Given a VG called C<vgname>, this returns the UUIDs of all
the logical volumes created in this volume group.

You can use this along with L</lvs> and L</lvuuid>
calls to associate logical volumes and volume groups.

See also L</vgpvuuids>.

=head2 vgmeta

 vgmeta vgname

C<vgname> is an LVM volume group.  This command examines the
volume group and returns its metadata.

Note that the metadata is an internal structure used by LVM,
subject to change at any time, and is provided for information only.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vgpvuuids

 vgpvuuids vgname

Given a VG called C<vgname>, this returns the UUIDs of all
the physical volumes that this volume group resides on.

You can use this along with L</pvs> and L</pvuuid>
calls to associate physical volumes and volume groups.

See also L</vglvuuids>.

=head2 vgremove

 vgremove vgname

Remove an LVM volume group C<vgname>, (for example C<VG>).

This also forcibly removes all logical volumes in the volume
group (if any).

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vgrename

 vgrename volgroup newvolgroup

Rename a volume group C<volgroup> with the new name C<newvolgroup>.

=head2 vgs

 vgs

List all the volumes groups detected.  This is the equivalent
of the L<vgs(8)> command.

This returns a list of just the volume group names that were
detected (eg. C<VolGroup00>).

See also L</vgs-full>.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vgs-full

 vgs-full

List all the volumes groups detected.  This is the equivalent
of the L<vgs(8)> command.  The "full" version includes all fields.

This command depends on the feature C<lvm2>.   See also
L</feature-available>.

=head2 vgscan

 vgscan

This rescans all block devices and rebuilds the list of LVM
physical volumes, volume groups and logical volumes.

I<This function is deprecated.>
In new code, use the L</lvm-scan> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 vguuid

 vguuid vgname

This command returns the UUID of the LVM VG named C<vgname>.

=head2 wc-c

 wc-c path

This command counts the characters in a file, using the
C<wc -c> external command.

=head2 wc-l

 wc-l path

This command counts the lines in a file, using the
C<wc -l> external command.

=head2 wc-w

 wc-w path

This command counts the words in a file, using the
C<wc -w> external command.

=head2 wipefs

 wipefs device

This command erases filesystem or RAID signatures from
the specified C<device> to make the filesystem invisible to libblkid.

This does not erase the filesystem itself nor any other data from the
C<device>.

Compare with L</zero> which zeroes the first few blocks of a
device.

This command depends on the feature C<wipefs>.   See also
L</feature-available>.

=head2 write

 write path content

This call creates a file called C<path>.  The content of the
file is the string C<content> (which can contain any 8 bit data).

See also L</write-append>.

=head2 write-append

 write-append path content

This call appends C<content> to the end of file C<path>.  If
C<path> does not exist, then a new file is created.

See also L</write>.

=head2 write-file

 write-file path content size

This call creates a file called C<path>.  The contents of the
file is the string C<content> (which can contain any 8 bit data),
with length C<size>.

As a special case, if C<size> is C<0>
then the length is calculated using C<strlen> (so in this case
the content cannot contain embedded ASCII NULs).

I<NB.> Owing to a bug, writing content containing ASCII NUL
characters does I<not> work, even if the length is specified.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</write> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 xfs-admin

 xfs-admin device [extunwritten:true|false] [imgfile:true|false] [v2log:true|false] [projid32bit:true|false] [lazycounter:true|false] [label:..] [uuid:..]

Change the parameters of the XFS filesystem on C<device>.

Devices that are mounted cannot be modified.
Administrators must unmount filesystems before this call
can modify parameters.

Some of the parameters of a mounted filesystem can be examined
and modified using the L</xfs-info> and
L</xfs-growfs> calls.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<xfs>.   See also
L</feature-available>.

=head2 xfs-growfs

 xfs-growfs path [datasec:true|false] [logsec:true|false] [rtsec:true|false] [datasize:N] [logsize:N] [rtsize:N] [rtextsize:N] [maxpct:N]

Grow the XFS filesystem mounted at C<path>.

The returned struct contains geometry information.  Missing
fields are returned as C<-1> (for numeric fields) or empty
string.

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<xfs>.   See also
L</feature-available>.

=head2 xfs-info

 xfs-info pathordevice

C<pathordevice> is a mounted XFS filesystem or a device containing
an XFS filesystem.  This command returns the geometry of the filesystem.

The returned struct contains geometry information.  Missing
fields are returned as C<-1> (for numeric fields) or empty
string.

This command depends on the feature C<xfs>.   See also
L</feature-available>.

=head2 xfs-repair

 xfs-repair device [forcelogzero:true|false] [nomodify:true|false] [noprefetch:true|false] [forcegeometry:true|false] [maxmem:N] [ihashsize:N] [bhashsize:N] [agstride:N] [logdev:..] [rtdev:..]

Repair corrupt or damaged XFS filesystem on C<device>.

The filesystem is specified using the C<device> argument which should be
the device name of the disk partition or volume containing the filesystem.
If given the name of a block device, C<xfs_repair> will attempt to find
the raw device associated with the specified block device and will use
the raw device instead.

Regardless, the filesystem to be repaired must be unmounted, otherwise,
the resulting filesystem may be inconsistent or corrupt.

The returned status indicates whether filesystem corruption was
detected (returns C<1>) or was not detected (returns C<0>).

This command has one or more optional arguments.  See L</OPTIONAL ARGUMENTS>.

This command depends on the feature C<xfs>.   See also
L</feature-available>.

=head2 yara-destroy

 yara-destroy

Destroy previously loaded Yara rules in order to free libguestfs resources.

This command depends on the feature C<libyara>.   See also
L</feature-available>.

=head2 yara-load

 yara-load (filename|-)

Upload a set of Yara rules from local file F<filename>.

Yara rules allow to categorize files based on textual or binary patterns
within their content.
See L</yara-scan> to see how to scan files with the loaded rules.

Rules can be in binary format, as when compiled with yarac command, or
in source code format. In the latter case, the rules will be first
compiled and then loaded.

Rules in source code format cannot include external files. In such cases,
it is recommended to compile them first.

Previously loaded rules will be destroyed.

Use C<-> instead of a filename to read/write from stdin/stdout.

This command depends on the feature C<libyara>.   See also
L</feature-available>.

=head2 yara-scan

 yara-scan path

Scan a file with the previously loaded Yara rules.

For each matching rule, a C<yara_detection> structure is returned.

The C<yara_detection> structure contains the following fields.

=over 4

=item C<yara_name>

Path of the file matching a Yara rule.

=item C<yara_rule>

Identifier of the Yara rule which matched against the given file.

=back

This command depends on the feature C<libyara>.   See also
L</feature-available>.

=head2 zegrep

 zegrep regex path

This calls the external C<zegrep> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 zegrepi

 zegrepi regex path

This calls the external C<zegrep -i> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 zero

 zero device

This command writes zeroes over the first few blocks of C<device>.

How many blocks are zeroed isn't specified (but it’s I<not> enough
to securely wipe the device).  It should be sufficient to remove
any partition tables, filesystem superblocks and so on.

If blocks are already zero, then this command avoids writing
zeroes.  This prevents the underlying device from becoming non-sparse
or growing unnecessarily.

See also: L</zero-device>, L</scrub-device>,
L</is-zero-device>

=head2 zero-device

 zero-device device

This command writes zeroes over the entire C<device>.  Compare
with L</zero> which just zeroes the first few blocks of
a device.

If blocks are already zero, then this command avoids writing
zeroes.  This prevents the underlying device from becoming non-sparse
or growing unnecessarily.

=head2 zero-free-space

 zero-free-space directory

Zero the free space in the filesystem mounted on F<directory>.
The filesystem must be mounted read-write.

The filesystem contents are not affected, but any free space
in the filesystem is freed.

Free space is not "trimmed".  You may want to call
L</fstrim> either as an alternative to this,
or after calling this, depending on your requirements.

=head2 zerofree

 zerofree device

This runs the I<zerofree> program on C<device>.  This program
claims to zero unused inodes and disk blocks on an ext2/3
filesystem, thus making it possible to compress the filesystem
more effectively.

You should B<not> run this program if the filesystem is
mounted.

It is possible that using this program can damage the filesystem
or data on the filesystem.

This command depends on the feature C<zerofree>.   See also
L</feature-available>.

=head2 zfgrep

 zfgrep pattern path

This calls the external C<zfgrep> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 zfgrepi

 zfgrepi pattern path

This calls the external C<zfgrep -i> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 zfile

 zfile meth path

This command runs L<file(1)> after first decompressing C<path>
using C<meth>.

C<meth> must be one of C<gzip>, C<compress> or C<bzip2>.

Since 1.0.63, use L</file> instead which can now
process compressed files.

I<This function is deprecated.>
In new code, use the L</file> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 zgrep

 zgrep regex path

This calls the external L<zgrep(1)> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

=head2 zgrepi

 zgrepi regex path

This calls the external C<zgrep -i> program and returns the
matching lines.

Because of the message protocol, there is a transfer limit
of somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.

I<This function is deprecated.>
In new code, use the L</grep> call instead.

Deprecated functions will not be removed from the API, but the
fact that they are deprecated indicates that there are problems
with correct use of these functions.

